/*----------------------------------------------------------------------------*/
/* File: libio_mng.h 				         		      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _IO_HDL_FILE_H_
#define _IO_HDL_FILE_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include <libio_mng.h>





/*----------------------------------------------------------------------------*/
/* Defines                                                                    */
/*----------------------------------------------------------------------------*/





/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _IO_HDL_FILE_C_

IMRT_Status  IO_Hdl_File_Open(  IMRT_Medium  *, IMRT_Medium_Path, IMRT_Dir_Id);
IMRT_Status  IO_Hdl_File_Close( IMRT_Medium  *);
IMRT_Status  IO_Hdl_File_Mem_Str( char  **, const char  *, size_t, const char  *, size_t);
IMRT_Status  IO_Hdl_File_Read(  IMRT_Buffer  *, size_t  *, IMRT_Medium  *, IMRT_Read_Mode);
IMRT_Status  IO_Hdl_File_Write( IMRT_Medium  *, size_t  *, IMRT_Buffer  *);
IMRT_Status  IO_Hdl_File_Begin( IMRT_Medium  *Medium_Ptr);
IMRT_Status  IO_Hdl_File_Commit( IMRT_Medium  *Medium_Ptr);
IMRT_Status  IO_Hdl_File_Rollback( IMRT_Medium  *Medium_Ptr);


#   else

/*----------------------------------------------------------------------------*/
/* IO_Hdl_File_Open                                                           */
/*----------------------------------------------------------------------------*/
/* Medium_Ptr:    Pointer to the medium to open                               */
/* Medium_Path:   Medium Path to open                                         */
/* Dir_Id:        Medium open direction                                       */
/*----------------------------------------------------------------------------*/

extern IMRT_Status  IO_Hdl_File_Open( IMRT_Medium  *, IMRT_Medium_Path, IMRT_Dir_Id);



/*----------------------------------------------------------------------------*/
/* IO_Hdl_File_Close                                                          */
/*----------------------------------------------------------------------------*/
/* Medium_Ptr:    Pointer to the medium to close                              */
/*----------------------------------------------------------------------------*/

extern IMRT_Status  IO_Hdl_File_Close( IMRT_Medium  *);



/*----------------------------------------------------------------------------*/
/* IO_Hdl_File_Read                                                           */
/*----------------------------------------------------------------------------*/
/* Buffer_Ptr:    Buffer to write data in                                     */
/* Read_Len_Ptr:  Number of byte readen                                       */
/* Medium_Path:   Medium to read                                              */
/* Read_Mode:     Read mode                                                   */
/*----------------------------------------------------------------------------*/

extern IMRT_Status  IO_Hdl_File_Read( IMRT_Buffer  *, size_t  *, IMRT_Medium  *, IMRT_Read_Mode);



/*----------------------------------------------------------------------------*/
/* IO_Hdl_File_Write                                                          */
/*----------------------------------------------------------------------------*/
/* Medium_Ptr:      Pointer to the medium towrite data to                     */
/* Write_Len_Ptr:   Number of byte writen                                     */
/* Buffer_Ptr:      Buffer to read                                            */
/*----------------------------------------------------------------------------*/

IMRT_Status  IO_Hdl_File_Write( IMRT_Medium  *, size_t  *, IMRT_Buffer  *);



/*----------------------------------------------------------------------------*/
/* IO_Hdl_File_Begin                                                          */
/*----------------------------------------------------------------------------*/
/* IMRT_Medium  *Medium_Ptr                                                   */
/*----------------------------------------------------------------------------*/
extern IMRT_Status  IO_Hdl_File_Begin( IMRT_Medium  *Medium_Ptr);


/*----------------------------------------------------------------------------*/
/* IO_Hdl_File_Commit                                                         */
/*----------------------------------------------------------------------------*/
/* IMRT_Medium  *Medium_Ptr                                                   */
/*----------------------------------------------------------------------------*/
extern IMRT_Status  IO_Hdl_File_Commit( IMRT_Medium  *Medium_Ptr);


/*----------------------------------------------------------------------------*/
/* IO_Hdl_File_Rollback                                                       */
/*----------------------------------------------------------------------------*/
/* IMRT_Medium  *Medium_Ptr                                                   */
/*----------------------------------------------------------------------------*/
extern IMRT_Status  IO_Hdl_File_Rollback( IMRT_Medium  *Medium_Ptr);

#   endif





/*----------------------------------------------------------------------------*/

#endif
