/*----------------------------------------------------------------------------*/
/* File: io_hdl_tux.h 				         		      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _IO_HDL_TUX_H_
#define _IO_HDL_TUX_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include <libio_mng.h>





/*----------------------------------------------------------------------------*/
/* Defines                                                                    */
/*----------------------------------------------------------------------------*/

#define IMRD_FML_TYPE_32                      "FML32"
#define IMRD_TMIB_SERVICE                     ".TMIB"
#define IMRD_HDL_TUX_TIME_OUT                 0



typedef short  IMRT_HDL_TUX_TRAN_MODE ;

#define IMRD_HDL_TUX_IN_TRANS          (IMRT_HDL_TUX_TRAN_MODE)1
#define IMRD_HDL_TUX_NOT_IN_TRANS      (IMRT_HDL_TUX_TRAN_MODE)0

#   ifdef _IO_HDL_TUX_C_

IMRT_HDL_TUX_TRAN_MODE IMRG_HDL_TUX_MODE = IMRD_HDL_TUX_NOT_IN_TRANS ;

#   endif /* _IO_HDL_TUX_C_ */





/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _IO_HDL_TUX_C_

IMRT_Status  IO_Hdl_Tux_Open(  IMRT_Medium  *, IMRT_Medium_Path, IMRT_Dir_Id);
IMRT_Status  IO_Hdl_Tux_Close( IMRT_Medium  *);
IMRT_Status  IO_Hdl_Tux_Read(  IMRT_Buffer  *, size_t  *, IMRT_Medium  *, IMRT_Read_Mode);
IMRT_Status  IO_Hdl_Tux_Write( IMRT_Medium  *, size_t  *, IMRT_Buffer  *);
IMRT_Status  Queue_Alloc( IMRT_Tux_Buffer  **);
IMRT_Status  Queue_Free( IMRT_Tux_Buffer  *);
IMRT_Status  Queue_Exist_Mib( IMRT_Tux_Queue_Space , IMRT_Tux_Queue_Name , IMRT_Tux_Buffer  *, IMRT_Tux_Buffer  *);
IMRT_Status  Queue_Exist( IMRT_Tux_Queue_Space , IMRT_Tux_Queue_Name);
IMRT_Status  IO_Hdl_Tux_Begin( IMRT_Medium  *Medium_Ptr);
IMRT_Status  IO_Hdl_Tux_Commit( IMRT_Medium  *Medium_Ptr);
IMRT_Status  IO_Hdl_Tux_Rollback( IMRT_Medium  *Medium_Ptr);

#   else

/*----------------------------------------------------------------------------*/
/* IO_Hdl_Tux_Open                                                            */
/*----------------------------------------------------------------------------*/
/* Medium_Ptr:    Pointer to the medium to open                               */
/* Medium_Path:   Medium Path to open                                         */
/* Dir_Id:        Medium open direction                                       */
/*----------------------------------------------------------------------------*/

extern IMRT_Status  IO_Hdl_Tux_Open( IMRT_Medium  *, IMRT_Medium_Path, IMRT_Dir_Id);



/*----------------------------------------------------------------------------*/
/* IO_Hdl_Tux_Close                                                           */
/*----------------------------------------------------------------------------*/
/* Medium_Ptr:    Pointer to the medium to close                              */
/*----------------------------------------------------------------------------*/

extern IMRT_Status  IO_Hdl_Tux_Close( IMRT_Medium  *);



/*----------------------------------------------------------------------------*/
/* IO_Hdl_Tux_Read                                                            */
/*----------------------------------------------------------------------------*/
/* Buffer_Ptr:    Buffer to write data in                                     */
/* Read_Len_Ptr:  Number of byte writen                                       */
/* Medium_Path:   Medium to read                                              */
/* Read_Mode:     Read mode                                                   */
/*----------------------------------------------------------------------------*/

extern IMRT_Status  IO_Hdl_Tux_Read( IMRT_Buffer  *, size_t  *, IMRT_Medium  *, IMRT_Read_Mode);



/*----------------------------------------------------------------------------*/
/* IO_Hdl_Tux_Write                                                           */
/*----------------------------------------------------------------------------*/
/* Medium_Ptr:   Pointer to the medium towrite data to                        */
/* Write_Len_Ptr:   Number of byte writen                                     */
/* Buffer_Ptr:   Buffer to read                                               */
/*----------------------------------------------------------------------------*/

extern IMRT_Status  IO_Hdl_Tux_Write( IMRT_Medium  *, size_t  *, IMRT_Buffer  *);


/*----------------------------------------------------------------------------*/
/* IO_Hdl_Tux_Begin                                                           */
/*----------------------------------------------------------------------------*/
/* IMRT_Medium  *Medium_Ptr                                                   */
/*----------------------------------------------------------------------------*/
extern IMRT_Status  IO_Hdl_Tux_Begin( IMRT_Medium  *Medium_Ptr);


/*----------------------------------------------------------------------------*/
/* IO_Hdl_Tux_Commit                                                          */
/*----------------------------------------------------------------------------*/
/* IMRT_Medium  *Medium_Ptr                                                   */
/*----------------------------------------------------------------------------*/
extern IMRT_Status  IO_Hdl_Tux_Commit( IMRT_Medium  *Medium_Ptr);

/*----------------------------------------------------------------------------*/
/* IO_Hdl_Tux_Rollback                                                        */
/*----------------------------------------------------------------------------*/
/* IMRT_Medium  *Medium_Ptr                                                   */
/*----------------------------------------------------------------------------*/
extern IMRT_Status  IO_Hdl_Tux_Rollback( IMRT_Medium  *Medium_Ptr);


#   endif





/*----------------------------------------------------------------------------*/

#endif




