/*----------------------------------------------------------------------------*/
/* File: liblog_mng.h 				         		      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _LIBLOG_MNG_H_
#define _LIBLOG_MNG_H_





/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include <imr.h>
#include <time.h>




/*----------------------------------------------------------------------------*/
/* Lib Definition                                                             */
/*----------------------------------------------------------------------------*/

#define IMRD_LM_MODULE_ID                ( IMRT_Module_Id) 1
#define IMRD_LM_MODULE_NAME            ( IMRT_Module_Name) "lm"
#define IMRD_LM_MODULE_NAME_LONG  ( IMRT_Module_Name_Long) "Log Manager"
#define IMRD_LM_MODULE_VERSION      ( IMRT_Module_Version) "@(#) VERSIONIMR: $Label:  $   $Date: 2008/11/12 02:25:22 $   $Workfile:   liblog_mng.h  $"

#define IMRD_MODULE_PTR                                    &IMRG_LM_Module





/*----------------------------------------------------------------------------*/
/* Local Definitions                                                          */
/*----------------------------------------------------------------------------*/

typedef struct IMRT_LM_Base
{
	IMRT_Log_Type_Name   Log_Type_Tab[ IMRD_LOG_TYPE_NB];
	IMRT_LM_Config       Config;
	FILE                *Stream_Out;
}  IMRT_LM_Base;





/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBLOG_MNG_C_

#   endif





/*----------------------------------------------------------------------------*/
/* Local Includes                                                             */
/*----------------------------------------------------------------------------*/





/*----------------------------------------------------------------------------*/
/* Global Variables                                                           */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBLOG_MNG_C_

IMRT_LM_Base  IMRG_LM_Base =
{
    { IMRD_LOG_TYPE_NAME_UNKNOWN, IMRD_LOG_TYPE_NAME_TRACE, IMRD_LOG_TYPE_NAME_INFO, IMRD_LOG_TYPE_NAME_WARNING, IMRD_LOG_TYPE_NAME_ERROR},
    { "", 0, { 0 } },
    NULL
};



IMRT_Module  IMRG_LM_Module =
{ 
    IMRD_LM_MODULE_ID,
    IMRD_LM_MODULE_NAME,
    IMRD_LM_MODULE_NAME_LONG,
    IMRD_LM_MODULE_VERSION,
    IMRD_MODULE_TYPE_LIBRARY,
    {
	IMRD_LIB_STATUS_CLOSED,
	( IMRT_Lib_Open    *) &IMR_LM_Library_Open,
	( IMRT_Lib_Close   *) &IMR_LM_Library_Close
    }
};

#   else

extern IMRT_LM_Base  IMRG_LM_Base;
extern IMRT_Module   IMRG_LM_Module;

#   endif







/*----------------------------------------------------------------------------*/

#endif
