/*----------------------------------------------------------------------------*/
/* File: mapping_mng.h 				                              */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _MAPPING_MNG_H_
#define _MAPPING_MNG_H_



#include <imr.h>





/*----------------------------------------------------------------------------*/
/* IMRD_MM_API definition                                                     */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBMAPPING_MNG_C_
#       define IMRD_MM_API  
#   else
#       define IMRD_MM_API  extern
#   endif







/*----------------------------------------------------------------------------*/
/* MM_Config definition                                                       */
/*----------------------------------------------------------------------------*/

typedef struct IMRT_MM_Config
{
	IMRT_Boolean  XML_Format;
}  IMRT_MM_Config;





/*----------------------------------------------------------------------------*/
/* Global Variables                                                           */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBMAPPING_MNG_

#   else

extern IMRT_Module  IMRG_MM_Module;

#   endif







/******************************************************************************/
/* Mapping Manager API                                                        */
/******************************************************************************/



/*----------------------------------------------------------------------------*/
/* Open Mapping Manager                                                       */
/*----------------------------------------------------------------------------*/

IMRD_MM_API IMRT_Status  IMR_MM_Library_Open( IMRT_MM_Config  *);



/*----------------------------------------------------------------------------*/
/* Close Mapping Manager                                                      */
/*----------------------------------------------------------------------------*/

IMRD_MM_API IMRT_Status  IMR_MM_Library_Close( void);



/*----------------------------------------------------------------------------*/
/* Buffer allocation	                                                      */
/*----------------------------------------------------------------------------*/
/* (O) Buffer_Ptr_Ptr :   Buffer pointer pointer		    	      */
/*----------------------------------------------------------------------------*/

IMRD_MM_API IMRT_Status IMR_MM_Buffer_Alloc( IMRT_Buffer **);


/*----------------------------------------------------------------------------*/
/* Buffer free			                                              */
/*----------------------------------------------------------------------------*/
/* (IO) Buffer_Ptr_Ptr :   Buffer pointer pointer		    	      */
/*----------------------------------------------------------------------------*/

IMRD_MM_API IMRT_Status	IMR_MM_Buffer_Free( IMRT_Buffer **);


/*----------------------------------------------------------------------------*/
/* Buffer check			                                              */
/*----------------------------------------------------------------------------*/
/* (I) Buffer_Ptr :   Buffer pointer 					      */
/*----------------------------------------------------------------------------*/

IMRD_MM_API IMRT_Status	IMR_MM_Buffer_Check (IMRT_Buffer *);


/*----------------------------------------------------------------------------*/
/* Buffer list			                                              */
/*----------------------------------------------------------------------------*/
/* (I) Buffer_Ptr :   Buffer pointer 					      */
/* (I) texte 	  :   Text to print		 			      */
/*----------------------------------------------------------------------------*/

IMRD_MM_API IMRT_Status	IMR_MM_Buffer_List( IMRT_Buffer *, char *);


/*----------------------------------------------------------------------------*/
/* Buffer mapping		                                              */
/*----------------------------------------------------------------------------*/
/* (I) Output_Buffer_Ptr :   Output buffer pointer 			      */
/* (I) Input_Buffer_Ptr  :   Input buffer pointer		 	      */
/*----------------------------------------------------------------------------*/

IMRD_MM_API IMRT_Status IMR_MM_Buffer_Map( IMRT_Buffer *,  IMRT_Buffer *);


/*----------------------------------------------------------------------------*/

#endif
