/*----------------------------------------------------------------------------*/
/* File: cnv_hdl_pad_right.c    				         	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#define _LIBMAPPING_MNG_
#define _CNV_HANDLER_PAD_RIGHT_C_

#include "cnv_hdl_pad_right.h" 

IMRT_Status	MM_Pad_Right_Init()
{
	return (IMRS_OK);
}

IMRT_Status	MM_Pad_Right_DeInit()
{

	return (IMRS_OK);
}


IMRT_Status	MM_Pad_Right_Convert(IMRT_Buffer_Data *Data_Out_Ptr , IMRT_Buffer_Data *Data_In_Ptr , size_t * Len_Ptr , size_t size , IMRT_Cnv_Attr Cnv_Attr )
{
	IMRT_Status status;
	char attr;
	size_t compteur;
	size_t len_tmp;
	IMRT_Buffer_Data *data_tmp_ptr;
	char *func_name = "MM_Pad_Right_Convert";

        
        status = IMRS_OK;
        compteur = 0L;
        attr = '0';

        len_tmp = *Len_Ptr ;
                
        if (len_tmp > size)
        {
        	IMRD_LM_LOG_ERROR_0("Field Len > size" );
        	status = IMRS_KO;
        }
        else
        {
        	if (Data_In_Ptr == NULL)
        	{
        		IMRD_LM_LOG_ERROR_0("Input pointer NULL" );
        		status = IMRS_KO;
        	}
        	else
        	if (Data_Out_Ptr == NULL)
        	{
        		IMRD_LM_LOG_ERROR_0("Output pointer NULL" );
        		status = IMRS_KO;
        	}
        	else
         	{
		        attr = Cnv_Attr[0];
		        
		        memcpy(Data_Out_Ptr , Data_In_Ptr , len_tmp);
		        data_tmp_ptr = Data_Out_Ptr + len_tmp ;
		        
		        for (compteur = 0L ; compteur < (size - len_tmp) ; compteur++)
		        {
		                data_tmp_ptr[compteur] = attr;
		        }
		        
		        data_tmp_ptr[compteur] = '\0';
		        *Len_Ptr = size ;
		}
	}


	return (status);
}

