/*----------------------------------------------------------------------------*/
/* File: cnv_hdl_strip_left.c    				         	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#define _LIBMAPPING_MNG_
#define _CNV_HANDLER_STRIP_LEFT_C_

#include "cnv_hdl_strip_left.h" 

IMRT_Status	MM_Strip_Left_Init()
{
	return (IMRS_OK);
}

IMRT_Status	MM_Strip_Left_DeInit()
{

	return (IMRS_OK);
}

IMRT_Status	MM_Strip_Left_Convert(IMRT_Buffer_Data *Data_Out_Ptr , IMRT_Buffer_Data *Data_In_Ptr , size_t * Len_Ptr , size_t size , IMRT_Cnv_Attr Cnv_Attr )
{
	IMRT_Status status;
	char attr;
	size_t compteur;
	size_t len_tmp;
	IMRT_Buffer_Data *data_tmp_ptr;
	IMRT_Buffer_Data *data_tmp_idx_ptr;
	char *func_name = "MM_Strip_Left_Convert";


        status = IMRS_OK;
        
        
       	if (Len_Ptr == NULL)
       	{
       		IMRD_LM_LOG_ERROR_0("Len pointer NULL" );
       		status = IMRS_KO;
       	}
       	else
       	if (Data_In_Ptr == NULL)
       	{
       		IMRD_LM_LOG_ERROR_0("Input pointer NULL" );
       		status = IMRS_KO;
       	}
       	else
       	if (Data_Out_Ptr == NULL)
       	{
       		IMRD_LM_LOG_ERROR_0("Output pointer NULL" );
       		status = IMRS_KO;
       	}
       	else
       	{
       		len_tmp = *Len_Ptr ;
	        if (len_tmp > size)
	        {
	        	IMRD_LM_LOG_ERROR_0("Field Len > size" );
	        	status = IMRS_KO;
	        }
	        else
	        {
		        attr = Cnv_Attr[0];
		        
		        data_tmp_ptr = (IMRT_Buffer_Data *)malloc(size + 1L);
		        if(data_tmp_ptr == NULL)
			{
			    /*erreur allocation */
			    IMRD_LM_LOG_ERROR_0("Memory allocation failed");
			    status = IMRS_KO;
			}
			else
			{
			        memset( data_tmp_ptr, '\0' , (size + 1L) );
			        data_tmp_idx_ptr = data_tmp_ptr;
			        memcpy(data_tmp_ptr , Data_In_Ptr , len_tmp) ;
			        data_tmp_ptr[len_tmp] = '\0';
			        memset( Data_Out_Ptr, '\0' , (size + 1L) );
			        
			        compteur = 0L;
			        
			        while ((data_tmp_idx_ptr[0L] == attr) && (compteur < *Len_Ptr))
			        {
			                data_tmp_idx_ptr++;
			                len_tmp--;
			                compteur++;
			        }
			        
			        data_tmp_idx_ptr[len_tmp] = '\0';       
			        
			        memcpy(Data_Out_Ptr , data_tmp_idx_ptr , len_tmp + 1L);
			        
			        *Len_Ptr = len_tmp ;
			        
				free(data_tmp_ptr);
			}
		}

	}

		
	return (status);

}

