/*----------------------------------------------------------------------------*/
/* File: cnv_hdl_strip_num.c    				         	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#define _LIBMAPPING_MNG_
#define _CNV_HANDLER_STRIP_NUM_C_

#include "cnv_hdl_strip_num.h" 

IMRT_Status	MM_Strip_Num_Init()
{
	return (IMRS_OK);
}

IMRT_Status	MM_Strip_Num_DeInit()
{

	return (IMRS_OK);
}

IMRT_Status	MM_Strip_Num_Convert(IMRT_Buffer_Data *Data_Out_Ptr , IMRT_Buffer_Data *Data_In_Ptr , size_t * Len_Ptr , size_t size , IMRT_Cnv_Attr Cnv_Attr )
{
	IMRT_Status status;
	char attr_space[2] ;
	char attr_zero[2] ;
	IMRT_Buffer_Data *Data_Tmp_Ptr;
	char *func_name = "MM_Strip_Num_Convert";


	status = IMRS_OK;
	strcpy(attr_space , " ");
	strcpy(attr_zero , "0");

	Data_Tmp_Ptr = (IMRT_Buffer_Data *)malloc(size + 1L);
	if (Data_Tmp_Ptr == NULL)
	{
		IMRD_LM_LOG_ERROR_0("Memory allocation failed");
		status = IMRS_KO;
	}
	else
	{
		memset(Data_Tmp_Ptr, '\0', (size + 1L));
	
		status = MM_Strip_Left_Convert(Data_Tmp_Ptr , Data_In_Ptr , Len_Ptr , size , attr_space );
		
		if (status == IMRS_OK)
			status = MM_Strip_Left_Convert(Data_Out_Ptr , Data_Tmp_Ptr , Len_Ptr , size , attr_zero );
	}

	if(Data_Tmp_Ptr != NULL)
		free(Data_Tmp_Ptr);

	return (status);

}

