/*----------------------------------------------------------------------------*/
/* File: cnv_hdl_strip_right.c    				         	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#define _LIBMAPPING_MNG_
#define _CNV_HANDLER_STRIP_RIGHT_C_

#include "cnv_hdl_strip_right.h" 

IMRT_Status	MM_Strip_Right_Init()
{
	return (IMRS_OK);
}

IMRT_Status	MM_Strip_Right_DeInit()
{

	return (IMRS_OK);
}

IMRT_Status	MM_Strip_Right_Convert(IMRT_Buffer_Data *Data_Out_Ptr , IMRT_Buffer_Data *Data_In_Ptr , size_t * Len_Ptr , size_t size , IMRT_Cnv_Attr Cnv_Attr )
{
	IMRT_Status status;
	char attr;
	size_t len_tmp;
	IMRT_Buffer_Data *data_tmp_ptr;
	char *func_name = "MM_Strip_Right_Convert";


        status = IMRS_OK;
        
        
       	if (Len_Ptr == NULL)
       	{
       		IMRD_LM_LOG_ERROR_0("Len pointer NULL" );
       		status = IMRS_KO;
       	}
       	else
       	if (Data_In_Ptr == NULL)
       	{
       		IMRD_LM_LOG_ERROR_0("Input pointer NULL" );
       		status = IMRS_KO;
       	}
       	else
       	if (Data_Out_Ptr == NULL)
       	{
       		IMRD_LM_LOG_ERROR_0("Output pointer NULL" );
       		status = IMRS_KO;
       	}
       	else
       	{
       		len_tmp = *Len_Ptr ;
	        if (len_tmp > size)
	        {
	        	IMRD_LM_LOG_ERROR_0("Field Len > size" );
	        	status = IMRS_KO;
	        }
	        else
	        {
		        attr = Cnv_Attr[0];
		        
		        data_tmp_ptr = Data_In_Ptr + len_tmp ;
		        
		       
		        while ((data_tmp_ptr > Data_In_Ptr) && (*(--data_tmp_ptr) == attr) )
		        {
		                len_tmp--;
		        }
		        
		        if (Data_Out_Ptr != Data_In_Ptr)
		        	memcpy(Data_Out_Ptr , Data_In_Ptr , len_tmp);
		        Data_Out_Ptr[len_tmp] = '\0';       
		        
		        *Len_Ptr = len_tmp ;
		}
	}


	return (status);
}

