/*----------------------------------------------------------------------------*/
/* File: fmt_hdl_dltd.h    				         	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _DELIMITED_HANDLER_H_
#define _DELIMITED_HANDLER_H_

/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include "libmapping_mng.h"



/*----------------------------------------------------------------------------*/
/* Local definition                                                           */
/*----------------------------------------------------------------------------*/

#ifdef _DELIMITED_HANDLER_C_
		
#   define DELIMITED_TAILLE_ALLOC 100000
    
    typedef struct IMRT_Delimited_TmpId
        {
	        IMRT_Delimited_Id TmpId;
        } IMRT_Delimited_TmpId;


#endif


/*----------------------------------------------------------------------------*/
/*	Global Variables                                                      */
/*----------------------------------------------------------------------------*/
#ifdef _DELIMITED_HANDLER_C_
		
    IMRT_Buffer	*IMRG_Delimited_Buffer_Ident_Ptr;

#endif

/*----------------------------------------------------------------------------*/
/*	Prototypes							      */
/*----------------------------------------------------------------------------*/

#ifdef _DELIMITED_HANDLER_C_

    IMRT_Status	    MM_Delimited_StrHdl_Init            ( void );
    IMRT_Status	    MM_Delimited_StrHdl_DeInit          ( void );
    IMRT_Status	    Delimited_Hdl_DataBuf_Alloc	        ( IMRT_Buffer * , size_t );
    IMRT_Status	    MM_Delimited_StrHdl_Data_Free       ( IMRT_Buffer * );
    IMRT_Status	    Delimited_Hdl_Format_Ident	        ( IMRT_Buffer * );
    IMRT_Status     MM_Delimited_StrHdl_Ident           ( IMRT_Msg_Id * , IMRT_Buffer * );
    IMRT_Status     Delimited_Hdl_Occ_Count             ( IMRT_Buffer_Data * , short * , IMRT_FmtAttr_Value );
    IMRT_Status     Delimited_Hdl_TmpId_Init            ( IMRT_Buffer * , short );
    IMRT_Status	    MM_Delimited_StrHdl_Open	        ( IMRT_Buffer * );
    IMRT_Status	    MM_Delimited_StrHdl_Close	        ( IMRT_Buffer * );
    IMRT_Status     MM_Delimited_StrHdl_Flush           ( IMRT_Buffer * );
    IMRT_Status	    MM_Delimited_StrHdl_Flush           ( IMRT_Buffer * );
    IMRT_Status	    MM_Delimited_StrHdl_Data_List       ( IMRT_Buffer * );
    IMRT_Status	    MM_Delimited_StrHdl_Copy	        ( IMRT_Buffer * , IMRT_Buffer * );
    IMRT_Status	    Delimited_Hdl_Field_Exist           ( IMRT_Field * , IMRT_Buffer * );
    IMRT_Status     MM_Delimited_StrHdl_Get             ( IMRT_Buffer_Data ** , IMRT_Field * , IMRT_Buffer * , size_t * );
    IMRT_Status	    MM_Delimited_StrHdl_Convert	        ( IMRT_Buffer_Data ** , IMRT_Buffer_Data * , IMRT_Field * , size_t *, IMRT_StrHdl_Cnv_Func * );
    IMRT_Status	    MM_Delimited_StrHdl_Put	        ( IMRT_Buffer_Data * , IMRT_Field * , IMRT_Buffer * , size_t );
    IMRT_Status     IMR_MM_Delimited_StrHdl_Field_Value ( IMRT_Field * , IMRT_Field_Value_Id);
    IMRT_Status     IMR_MM_Delimited_StrHdl_Field_Exist ( IMRT_Field * );
    IMRT_Status     IMR_MM_Delimited_StrHdl_Msg_Size    ( size_t );
#else

    extern IMRT_Status  MM_Delimited_StrHdl_Init            ( void );
    extern IMRT_Status  MM_Delimited_StrHdl_DeInit          ( void );
    extern IMRT_Status  MM_Delimited_StrHdl_Library_Open    ( void );
    extern IMRT_Status  MM_Delimited_StrHdl_Data_Free       ( IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Ident           ( IMRT_Msg_Id * , IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Open            ( IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Close	    ( IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Flush           ( IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Flush	    ( IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Data_List       ( IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Copy	    ( IMRT_Buffer * , IMRT_Buffer * );
    extern IMRT_Status  MM_Delimited_StrHdl_Get		    ( IMRT_Buffer_Data ** , IMRT_Field * , IMRT_Buffer * , size_t * );
    extern IMRT_Status	MM_Delimited_StrHdl_Convert	    ( IMRT_Buffer_Data ** , IMRT_Buffer_Data * , IMRT_Field * , size_t *, IMRT_StrHdl_Cnv_Func * );
    extern IMRT_Status  MM_Delimited_StrHdl_Put		    ( IMRT_Buffer_Data * , IMRT_Field * , IMRT_Buffer * , size_t );

#endif

/*----------------------------------------------------------------------------*/

#endif                                   

