/*----------------------------------------------------------------------------*/
/* File: fmt_hdl_xml.h    	        		         	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _FML_HANDLER_H_
#define _FML_HANDLER_H_

#include "fml.h"
#include "fml32.h"
#include "atmi.h"
#include "field.tbls.h"
#include "userlog.h"

/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include "libmapping_mng.h"

/*----------------------------------------------------------------------------*/
/* Local definition                                                           */
/*----------------------------------------------------------------------------*/

#ifdef _FML_HANDLER_C_

    #define IMRD_FML_TYPE "FML32"
    #define IMRD_FML_SIZE (FLDLEN32)10000L
    #define IMRD_FML_MAX_FLD (FLDOCC32)50L

#endif

/*----------------------------------------------------------------------------*/
/*	Global Variables			                              */
/*----------------------------------------------------------------------------*/

#ifdef _FML_HANDLER_C_
		
    IMRT_Buffer	*IMRG_FML_Buffer_Ident_Ptr;

#endif

/*----------------------------------------------------------------------------*/
/*	Prototypes							      */
/*----------------------------------------------------------------------------*/

#ifdef _FML_HANDLER_C_

    IMRT_Status MM_FML_StrHdl_Init              ( void );
    IMRT_Status MM_FML_StrHdl_DeInit            ( void );
    IMRT_Status FML_Hdl_DataBuf_Alloc           ( IMRT_Buffer * );
    IMRT_Status MM_FML_StrHdl_Data_Free         ( IMRT_Buffer * );
    IMRT_Status	FML_Hdl_Format_Ident            ( IMRT_Buffer * );
    IMRT_Status MM_FML_StrHdl_Ident             ( IMRT_Msg_Id * , IMRT_Buffer * );
    IMRT_Status MM_FML_StrHdl_Open              ( IMRT_Buffer * );
    IMRT_Status MM_FML_StrHdl_Close             ( IMRT_Buffer * );
    IMRT_Status	MM_FML_StrHdl_Flush             ( IMRT_Buffer * );
    IMRT_Status MM_FML_StrHdl_Data_List         ( IMRT_Buffer * );
    IMRT_Status MM_FML_StrHdl_Copy              ( IMRT_Buffer * , IMRT_Buffer * );
    IMRT_Status	FML_Hdl_Field_Exist             ( IMRT_Field * , IMRT_Buffer * , FLDID32 );
    IMRT_Status	MM_FML_StrHdl_Get               (IMRT_Buffer_Data ** , IMRT_Field * , IMRT_Buffer * , size_t * );
    IMRT_Status	MM_FML_StrHdl_Convert           (IMRT_Buffer_Data ** , IMRT_Buffer_Data * , IMRT_Field * , size_t *, IMRT_StrHdl_Cnv_Func * );
    IMRT_Status	MM_FML_StrHdl_Put               (IMRT_Buffer_Data * , IMRT_Field * , IMRT_Buffer * , size_t );
    IMRT_Status IMR_MM_FML_StrHdl_Field_Value   ( IMRT_Field * , IMRT_Field_Value_Id);
    IMRT_Status IMR_MM_FML_StrHdl_Field_Exist   ( IMRT_Field * );
    IMRT_Status IMR_MM_FML_StrHdl_Msg_Size      ( size_t );

#else

    extern IMRT_Status MM_FML_StrHdl_Init           ( void );
    extern IMRT_Status MM_FML_StrHdl_DeInit         ( void );
    extern IMRT_Status MM_FML_StrHdl_Data_Free      ( IMRT_Buffer * );
    extern IMRT_Status MM_FML_StrHdl_Ident          ( IMRT_Msg_Id * , IMRT_Buffer * );
    extern IMRT_Status MM_FML_StrHdl_Open           ( IMRT_Buffer * );
    extern IMRT_Status MM_FML_StrHdl_Close          ( IMRT_Buffer * );
    extern IMRT_Status MM_FML_StrHdl_Flush          ( IMRT_Buffer * );
    extern IMRT_Status MM_FML_StrHdl_Data_List      ( IMRT_Buffer * );
    extern IMRT_Status MM_FML_StrHdl_Copy           ( IMRT_Buffer * , IMRT_Buffer * );
    extern IMRT_Status MM_FML_StrHdl_Get            (IMRT_Buffer_Data ** , IMRT_Field * , IMRT_Buffer * , size_t * );
    extern IMRT_Status MM_FML_StrHdl_Convert        (IMRT_Buffer_Data ** , IMRT_Buffer_Data * , IMRT_Field * , size_t *, IMRT_StrHdl_Cnv_Func * );
    extern IMRT_Status MM_FML_StrHdl_Put            (IMRT_Buffer_Data * , IMRT_Field * , IMRT_Buffer * , size_t );

#endif   

#endif
