/*----------------------------------------------------------------------------*/
/* File: libmapping_mng.h 				      		      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _LIBMAPPING_MNG_H_
#define _LIBMAPPING_MNG_H_





/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include <imr.h>





/*----------------------------------------------------------------------------*/
/* Lib Definitions                                                            */
/*----------------------------------------------------------------------------*/

#define IMRD_MM_MODULE_ID                ( IMRT_Module_Id) 4
#define IMRD_MM_MODULE_NAME            ( IMRT_Module_Name) "mm"
#define IMRD_MM_MODULE_NAME_LONG  ( IMRT_Module_Name_Long) "Mapping Manager"
#define IMRD_MM_MODULE_VERSION      ( IMRT_Module_Version) "@(#) VERSIONIMR: $Label:  $   $Date: 2008/11/12 02:25:23 $   $Workfile:   libmapping_mng.h  $"

#define IMRD_MODULE_PTR                                    &IMRG_MM_Module





/*----------------------------------------------------------------------------*/
/* Local definition                                                           */
/*----------------------------------------------------------------------------*/

#define IMRD_STATUS_NOTHING_TO_DO		(IMRT_Status) 4

typedef IMRT_Status  (IMRT_MM_Cnv_Init)( void );
typedef IMRT_Status  (IMRT_MM_Cnv_DeInit)( void );
typedef IMRT_Status  (IMRT_MM_Convert)( IMRT_Buffer_Data * , IMRT_Buffer_Data * , size_t * , size_t , IMRT_Cnv_Attr ); 

typedef struct IMRT_StrHdl_Cnv_Func
	
{   IMRT_Cnv_Name        	Nom;
    IMRT_MM_Cnv_Init            *Init_Ptr;
    IMRT_MM_Cnv_DeInit  	*DeInit_Ptr;
    IMRT_MM_Convert   	        *Convert_Ptr;	    
} IMRT_StrHdl_Cnv_Func;

/* a virer apres les tests */      
IMRT_StrHdl_Cnv_Func    *IMRG_MM_StrHdl_Cnv_Func_Tab;



typedef struct IMRT_MM_Base
{
	IMRT_MM_Config  Config;
}  IMRT_MM_Base;





/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/







/*----------------------------------------------------------------------------*/
/* Global Variables                                                           */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBMAPPING_MNG_C_

IMRT_MM_Base  IMRG_MM_Base =
{
    { IMRD_FALSE}
};



IMRT_Module  IMRG_MM_Module = 
{ 
    IMRD_MM_MODULE_ID,
    IMRD_MM_MODULE_NAME,
    IMRD_MM_MODULE_NAME_LONG,
    IMRD_MM_MODULE_VERSION,
    IMRD_MODULE_TYPE_LIBRARY,
    {
	IMRD_LIB_STATUS_CLOSED,
	( IMRT_Lib_Open    *) &IMR_MM_Library_Open,
	( IMRT_Lib_Close   *) &IMR_MM_Library_Close
    }
};

#   else

extern IMRT_MM_Base  IMRG_MM_Base;
extern IMRT_Module   IMRG_MM_Module;

#   endif





#endif
