/*----------------------------------------------------------------------------*/
/* File: map_scheduler.h					 	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _MAP_SCHEDULER_H_
#define _MAP_SCHEDULER_H_

/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include "libmapping_mng.h"

/*----------------------------------------------------------------------------*/
/*	Global Variables						      */
/*----------------------------------------------------------------------------*/

#ifdef _MAP_SCHEDULER_C_

	IMRT_Buffer *Buffer_Tab[IMRT_BUFFER_ID_MAX_NB];

#endif

/*----------------------------------------------------------------------------*/
/*	Prototypes							      */
/*----------------------------------------------------------------------------*/
#ifdef _MAP_SCHEDULER_C_

        IMRT_Status MM_Schedul_Init             ( void );
        IMRT_Status MM_Schedul_DeInit           ( void );
        IMRT_Status MM_Schedul_Buffer_Map	( IMRT_Buffer * , IMRT_Buffer * );
	IMRT_Status Schedul_Buffers_Check	( IMRT_Buffer * , IMRT_Buffer * );
	IMRT_Status IMR_MM_Schedul_Ident	( IMRT_Fmt_Id * , IMRT_Msg_Id *, IMRT_Buffer_Id , IMRT_Boolean );
	IMRT_Status IMR_MM_Schedul_Copy		( IMRT_Buffer_Id , IMRT_Buffer_Id );

/*----------------------------------------------------------------------------*/
/* Buffer Mapping CallBack                                                    */
/*----------------------------------------------------------------------------*/
/* (I) Buffer_Id_Target:   Target buffer id                                   */
/* (I) Fmt_Target:         Target format                                      */
/* (I) Fmt_Attr_Target:    Target format attribute                            */
/* (I) Buffer_Id_Src:      Source buffer id                                   */
/* (I) Fmt_Src:            Source format                                      */
/* (I) Fmt_Attr_Src:       Source format attribute                            */
/* (I) MsgMap:             Message Map to use                                 */
/* (I) Clear_Flag:         Clear or donn't clear output buffer                */
/*----------------------------------------------------------------------------*/
        IMRT_Status  IMR_MM_Schedul_Map( IMRT_Buffer_Id, IMRT_Fmt_Id, IMRT_FmtAttr_Value, IMRT_Buffer_Id, IMRT_Fmt_Id, IMRT_FmtAttr_Value, IMRT_MsgMap  *, IMRT_MapCmd_Flag);

/*----------------------------------------------------------------------------*/


#else

        extern IMRT_Status MM_Schedul_Init              ( void );
        extern IMRT_Status MM_Schedul_DeInit            ( void );
	extern IMRT_Status MM_Schedul_Buffer_Map	( IMRT_Buffer * , IMRT_Buffer * );
																 
#endif


/*----------------------------------------------------------------------------*/

#endif                                   
