/*----------------------------------------------------------------------------*/
/* File: msg_router.h 				         		      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _MSG_ROUTER_H_
#define _MSG_ROUTER_H_



#include <imr.h>





/*----------------------------------------------------------------------------*/
/* IMRD_MR_API definition                                                     */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBMSG_ROUTER_
#       define IMRD_MR_API  
#   else
#       define IMRD_MR_API  extern
#   endif





/*----------------------------------------------------------------------------*/
/* MR_Config definition                                                       */
/*----------------------------------------------------------------------------*/

typedef struct IMRT_MR_Config
{
	IMRT_Boolean        Mapping_Forced;
	IMRT_Boolean        Continue_Forced;
	IMRT_Read_Mode      Read_Mode;
	IMRT_Log_Id_Struct  Log_Id_Struct_Input;
	IMRT_Log_Id_Struct  Log_Id_Struct_Output;
}  IMRT_MR_Config;





/*----------------------------------------------------------------------------*/
/* Global Variables                                                           */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBMSG_ROUTER_

#   else

extern IMRT_Module  IMRG_MR_Module;

#   endif







/******************************************************************************/
/* Msg Router API                                                             */
/******************************************************************************/



/*----------------------------------------------------------------------------*/
/* Open Msg Router                                                            */
/*----------------------------------------------------------------------------*/
/* Lib_Flag:   Setup MR init mode                                             */
/*----------------------------------------------------------------------------*/

IMRD_MR_API IMRT_Status  IMR_MR_Library_Open( IMRT_MR_Config  *);



/*----------------------------------------------------------------------------*/
/* Close Msg Router                                                           */
/*----------------------------------------------------------------------------*/

IMRD_MR_API IMRT_Status  IMR_MR_Library_Close( void);





/*----------------------------------------------------------------------------*/
/* Proceed Message Routing                                                    */
/*----------------------------------------------------------------------------*/
/* Medium_URL_Output:   Output medium URL                                     */
/* Appl_Id_Output:      Output application Id                                 */
/* Medium_URL_Input:    Trash Medium URL                                      */
/* Medium_URL_Input:    Input Medium URL                                      */
/* Appl_Id_Input:       Input Application Id                                  */
/*----------------------------------------------------------------------------*/

IMRD_MR_API IMRT_Status  IMR_MR_Proceed( IMRT_Medium_URL, IMRT_Appl_Id, IMRT_Medium_URL, IMRT_Medium_URL, IMRT_Appl_Id);



/*----------------------------------------------------------------------------*/

#endif
