/*----------------------------------------------------------------------------*/
/* File: libmsg_router.h 				       		      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _LIBMSG_ROUTER_H_
#define _LIBMSG_ROUTER_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#include <imr.h>





/*----------------------------------------------------------------------------*/
/* Lib Definitions                                                            */
/*----------------------------------------------------------------------------*/

#define IMRD_MR_MODULE_ID                ( IMRT_Module_Id) 5
#define IMRD_MR_MODULE_NAME            ( IMRT_Module_Name) "mr"
#define IMRD_MR_MODULE_NAME_LONG  ( IMRT_Module_Name_Long) "Message Router"
#define IMRD_MR_MODULE_VERSION      ( IMRT_Module_Version) "@(#) VERSIONIMR: $Label:  $   $Date: 2008/11/12 02:25:23 $   $Workfile:   libmsg_router.h  $"

#define IMRD_MODULE_PTR                                    &IMRG_MR_Module



typedef struct IMRT_MR_Base
{
	IMRT_MR_Config  Config;
}  IMRT_MR_Base;





/*----------------------------------------------------------------------------*/
/* Local Definitions                                                          */
/*----------------------------------------------------------------------------*/

#define IMRD_MR_LOG_ID_HEADER_MSG_INPUT   ( IMRT_Log_Id_Header) "Input  Message Id:"
#define IMRD_MR_LOG_ID_HEADER_MSG_OUTPUT  ( IMRT_Log_Id_Header) "Output Message Id:"  







/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBMSG_ROUTER_C_

IMRT_Status  Close_All( IMRT_Buffer  *, IMRT_Buffer  *, IMRT_Medium  *, IMRT_Medium  *, IMRT_Medium  *);

#   endif






/*----------------------------------------------------------------------------*/
/* Local Includes                                                             */
/*----------------------------------------------------------------------------*/







/*----------------------------------------------------------------------------*/
/* Global Variables                                                           */
/*----------------------------------------------------------------------------*/

#   ifdef _LIBMSG_ROUTER_C_

IMRT_MR_Base  IMRG_MR_Base =
{
    {
	IMRD_FALSE,
	IMRD_READ_MODE_WAIT
    }
};

IMRT_Module  IMRG_MR_Module = 
{ 
    IMRD_MR_MODULE_ID,
    IMRD_MR_MODULE_NAME,
    IMRD_MR_MODULE_NAME_LONG,
    IMRD_MR_MODULE_VERSION,
    IMRD_MODULE_TYPE_LIBRARY,
    {
	IMRD_LIB_STATUS_CLOSED,
	( IMRT_Lib_Open    *) &IMR_MR_Library_Open,
	( IMRT_Lib_Close   *) &IMR_MR_Library_Close
    }
};

#   else

extern IMRT_MR_Base  IMRG_MR_Base;
extern IMRT_Module   IMRG_MR_Module;

#   endif





/*----------------------------------------------------------------------------*/

#endif
