/*----------------------------------------------------------------------------*/
/* File: arc_hdl_sql.h 				                 	      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _ARC_HDL_SQL_H_
#   define _ARC_HDL_SQL_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#   include <libstatic_data_mng.h>
#   include <sqlca.h>


/*----------------------------------------------------------------------------*/
/* Global variables                                                           */
/*----------------------------------------------------------------------------*/
#   ifdef _ARC_HDL_SQL_PC_

typedef short  IMRT_DB_Open_Flag;

#define IMRD_DB_OPEN_FLAG_UNKNOWN  ( IMRT_DB_Open_Flag) 0
#define IMRD_DB_OPEN_FLAG_OPENED   ( IMRT_DB_Open_Flag) 1
#define IMRD_DB_OPEN_FLAG_CLOSED   ( IMRT_DB_Open_Flag) 2



typedef struct IMRT_SDM_SQL_Base
{
    IMRT_DB_Open_Flag  Open_Flag;

} IMRT_SDM_SQL_Base;



IMRT_SDM_SQL_Base  IMRG_SDM_SQL_Base =
{
	IMRD_DB_OPEN_FLAG_CLOSED
};

#	endif



/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _ARC_HDL_SQL_PC_

IMRT_Status SDM_HDR_SQL_Init(IMRT_SDM_Flag  Flag);
IMRT_Status SDM_HDR_SQL_DInit(void);
IMRT_Status SDM_SQL_ConnectOra(void);
IMRT_Status SDM_SQL_DisconnectOra(void);
IMRT_Status SDM_SQL_Set_Struct_Version(IMRT_Data_Version *, char *);

#   else

extern IMRT_Status SDM_HDR_SQL_Init(IMRT_SDM_Flag  Flag);
extern IMRT_Status SDM_HDR_SQL_DInit(void);
extern IMRT_Status SDM_SQL_ConnectOra(void);
extern IMRT_Status SDM_SQL_DisconnectOra(void);
extern IMRT_Status SDM_SQL_Set_Struct_Version(IMRT_Data_Version *, char *);

#   endif





/*----------------------------------------------------------------------------*/

#endif
