/*----------------------------------------------------------------------------*/
/* File: arc_hdl_xml.c   		         		  	      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#define _LIBSTATIC_DATA_MNG_
#define _ARC_HDL_XML_C_

#include "arc_hdl_xml.h" 





/*----------------------------------------------------------------------------*/
/*Raise Error                                                                 */
/*ctx : contexte avec lequele la fonction est appele                         */
/*functionname : nom de la focntion qui lve l'erreur                         */
/*lib_error :  libell de l'erreur                                            */
/*code : code de l'erreur                                                     */
/*----------------------------------------------------------------------------*/

IMRT_Status SDM_HDR_XML_Init(IMRT_SDM_Flag  Flag)
{

  return(IMRS_OK);

}

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status SDM_HDR_XML_DInit(void)
{

  return(IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
void SDM_RaiseError(xmlParserCtxt * Ctx_Sax_Ptr, IMRT_Error * Struct_Error_Ptr ,IMRT_Status * Flag_Error , 
		    const char* functionname, const char* lib_error, const int code )
{
  
  fprintf(stderr,"\nRaise error <%s>",lib_error);
  Ctx_Sax_Ptr->sax = &ErrorSAXHandlerStruct;
  *Flag_Error = IMRS_KO;
  Struct_Error_Ptr->errorCode = code;
  strcpy(Struct_Error_Ptr->libError,lib_error) ;
  strcpy(Struct_Error_Ptr->function,functionname);
}
