/*----------------------------------------------------------------------------*/
/* File: buffer_info_mng.c   		         		  	      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#define _LIBSTATIC_DATA_MNG_
#define _BUFFER_INFO_MNG_C_

#include "buffer_info_mng.h" 

IMRT_Status  SDM_DataStruct_Finalize(NDT_Root  *ds_Ptr, NDT_Index_Type *Index_Type_Ptr, short hMaxEntries)
{
	NDT_Status    nd_status;
	IMRT_Status   status;
	short  Compteur;

	Compteur = 0;
	status = IMRS_OK;

	do
	{
		if (Compteur == 0)
		{
		    nd_status = ND_DataStruct_Convert(ds_Ptr, Index_Type_Ptr);
		  
			if(nd_status != NDS_OK)
			{
				
				status = IMRS_KO;
			}
		}
		else
		{
			nd_status = ND_Index_Open(ds_Ptr, Compteur, Index_Type_Ptr[Compteur]);
			if(nd_status != NDS_OK)
			{
				
				status = IMRS_KO;
			}
		}

		Compteur = Compteur + 1;
	} while((nd_status == NDS_OK)&&(Compteur < hMaxEntries));
 
	return(status);	
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
void SDM_IniTableCritere(IMRT_Status Table[],const int NbElement)
{
  int i;
  for(i =0; i<NbElement;i++)
  {
    Table[i] = IMRS_OK;
  }
}


void SDM_CompareCritereMapPath(IMRT_Status CitereTable[],
			       const int NbCritere,
			       SDMT_CritereRecChemin * Critere,
			       IMRT_MapPath * myMapPath,
			       IMRT_Status  *Valide )
{
    int indexe;
    
    SDM_IniTableCritere(CitereTable,NbCritere);
    
    if( (Critere->InputAppli != IMRD_APPL_ID_UNKNOWN) &&
        (Critere->InputAppli != myMapPath->Appl_Input_Ptr->Id) &&
        (myMapPath->Appl_Input_Ptr->Id != IMRD_APPL_ID_UNKNOWN)
	)
    {
		CitereTable[SDMD_CRI_IA] = IMRS_KO;
    }
    if( (Critere->OutputAppli != IMRD_APPL_ID_UNKNOWN ) &&
        (Critere->OutputAppli != myMapPath->Appl_Output_Ptr->Id) &&
        (myMapPath->Appl_Output_Ptr->Id != IMRD_APPL_ID_UNKNOWN )
	)
    {
		CitereTable[SDMD_CRI_OA] = IMRS_KO;
    }
    if( (Critere->InputFormat != IMRD_FMT_ID_UNKNOWN) &&
        (Critere->InputFormat != myMapPath->Fmt_Input_Ptr->Id) &&
        (myMapPath->Fmt_Input_Ptr->Id != IMRD_FMT_ID_UNKNOWN)
	)
    {
		CitereTable[SDMD_CRI_IF] = IMRS_KO;
    }
    if( (Critere->OutputFormat != IMRD_FMT_ID_UNKNOWN) &&
        (Critere->OutputFormat != myMapPath->Fmt_Output_Ptr->Id) &&
        (myMapPath->Fmt_Output_Ptr->Id != IMRD_FMT_ID_UNKNOWN)
        )
    {
		CitereTable[SDMD_CRI_OF] = IMRS_KO;
    }
    
    *Valide=IMRS_OK;
    for(indexe =0; indexe <NbCritere;indexe++)
    {
        if(CitereTable[indexe] == IMRS_KO)
	{
	    *Valide = IMRS_KO;            
    }
    }
}



/*----------------------------------------------------------------------------*/
/* Appl Manager                                                               */
/*----------------------------------------------------------------------------*/

NDT_Status  SDM_Appl_Manager( NDT_Root  *Root_Ptr, NDT_Index_Id  Index_Id, NDT_Node  *Node_Ptr, NDT_Command  Command, va_list  Args)
{
    NDT_Command_Name  Command_Name;


    switch( Command)
    {
	case NDD_CMD_MANAGER_VERSION:
        {
            NDT_Version_Name  *Version_Name_Ptr = (NDT_Version_Name  *)va_arg( Args, NDT_Version_Name  *);


            Command_Name = "NDD_CMD_MANAGER_VERSION";
            *Version_Name_Ptr = "Revision: 2.1    Name: libnode-2_0_4-1    Date: 2002/02/28 22:00:35    Author: agibert ";

            return( NDS_OK);
        }

        case NDD_CMD_INDEX_GET:
        {
            /*
	      NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
	      NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
	      NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
	      void          *Value_ptr          = (void  *)va_arg( Args, void  *);
            */
            NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
            NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
            NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
            IMRT_Appl    * Value_ptr          = (IMRT_Appl  *)va_arg( Args, IMRT_Appl  *);


            Command_Name = "NDD_CMD_INDEX_GET";

            switch(Cmd)
            {
                case IMRD_SDMD_CMD_INDEX0_PRINT:
                {
                    *Reply_Index_Id_Ptr = 0;
                    *Reply_Command_Ptr = NDD_CMD_VALUE_PRINT;

                    break;
                }
                default:
                {
                    *Reply_Index_Id_Ptr = Index_Id;
                    *Reply_Command_Ptr = Cmd;

                    break;
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ALLOC:
        {
            /*
	      void       **Value_Ptr_Ptr = (void **)va_arg( Args, void  **);
	      va_list      user_args     = (va_list)va_arg( Args, va_list);
	      user_type    user_data     = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_Appl  **Value_Ptr_Ptr = va_arg( Args, IMRT_Appl  **);


            Command_Name = "NDD_CMD_VALUE_ALLOC";

            if( ( *Value_Ptr_Ptr = (IMRT_Appl  *)malloc( sizeof(IMRT_Appl))) == NULL)
            {
                return( NDS_ERRMEM);
            }
            else
            {
                SDM_InitAppl(*Value_Ptr_Ptr);
                return( NDS_OK);
            }
        }

        case NDD_CMD_VALUE_FREE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_Appl  *Value_Ptr = (IMRT_Appl  *)va_arg( Args, IMRT_Appl  *);
            Command_Name = "NDD_CMD_VALUE_FREE";

            free( Value_Ptr);

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_COMP:
        {
            /*
	      void       *Value1_Ptr = (void *)va_arg( Args, void  *);
	      void       *Value2_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args  = (va_list)va_arg( Args, va_list);
	      user_type   user_data  = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_Appl    *Value1_Ptr = va_arg( Args, IMRT_Appl  *);
            IMRT_Appl    *Value2_Ptr = va_arg( Args, IMRT_Appl  *);


            Command_Name = "NDD_CMD_VALUE_COMP";

            switch( Index_Id)
            {
                case 0:
                {
                    if( Value1_Ptr->Id < Value2_Ptr->Id)
                    {
                        return( NDS_LOWER);
                    }
                    else
                    {
                        if( Value1_Ptr->Id > Value2_Ptr->Id)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                case 1:
                {
                    int     rc;


                    rc=strcmp( Value1_Ptr->Name, Value2_Ptr->Name);

                    if( rc <0)
                    {
                        return( NDS_LOWER);
                    }
                    else
                    {
                        if( rc > 0)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                default:
                {
                     return( NDS_KO);
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ADD:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_ADD";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_REMOVE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_REMOVE";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list               lib_args        = (va_list)va_arg( Args, va_list);
            FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);

            IMRT_Appl           *Value_Ptr            = Node_Ptr->Value;


            Command_Name = "NDD_CMD_VALUE_PRINT";

            fprintf( Out, "Name: (%s) \n", Value_Ptr->Name);
            return( NDS_OK);

        }

        case NDD_CMD_INFO_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */

            Command_Name = "NDD_CMD_INFO_PRINT";

            return( NDS_OK);
        }

		case IMRD_SDMD_CMD_API_SQL_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

			IMRT_Appl        *Appl_Ptr  = Node_Ptr->Value;


			Command_Name = "IMRD_SDMD_CMD_API_SQL_DUMP";

			fprintf( Out, "INSERT INTO IMR_APPLI(APPLI_ID, APPLI_NAME) VALUES(%d, '%s');\n",
					Appl_Ptr->Id, Appl_Ptr->Name);

			return( NDS_OK);
		}

		case IMRD_SDMD_CMD_API_XML_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

			IMRT_Appl        *Appl_Ptr  = Node_Ptr->Value;


			Command_Name = "IMRD_SDMD_CMD_API_XML_DUMP";

			fprintf( Out, "\t<%s>\n", IMRD_SDMD_TAG_APPLI);

			fprintf( Out, "\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_NAME, Appl_Ptr->Name, IMRD_SDMD_TAG_NAME);

			fprintf( Out, "\t</%s>\n", IMRD_SDMD_TAG_APPLI);

			return( NDS_OK);
		}

        default:
        {
            IMRD_LM_LOG_ERROR_1( "SDM_Appl_Manager() called with an undefined command %d\n", Command);
            return NDS_ERRAPI;
        }
    }

    
    return NDS_OK;
}




/*----------------------------------------------------------------------------*/
/* FmtAttr Manager                                                            */
/*----------------------------------------------------------------------------*/

NDT_Status  SDM_FmtAttr_Manager( NDT_Root  *Root_Ptr, NDT_Index_Id  Index_Id, NDT_Node  *Node_Ptr, NDT_Command  Command, va_list  Args)
{
    NDT_Command_Name  Command_Name;
    IMRT_Status       status;


    switch( Command)
    {
	case NDD_CMD_MANAGER_VERSION:
        {
            NDT_Version_Name  *Version_Name_Ptr = (NDT_Version_Name  *)va_arg( Args, NDT_Version_Name  *);


            Command_Name = "NDD_CMD_MANAGER_VERSION";
            *Version_Name_Ptr = "Revision: 2.1    Name: libnode-2_0_4-1    Date: 2002/02/28 22:00:35    Author: agibert ";

            return( NDS_OK);
        }

        case NDD_CMD_INDEX_GET:
        {
            /*
	      NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
	      NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
	      NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
	      void          *Value_ptr          = (void  *)va_arg( Args, void  *);
            */
            NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
            NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
            NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
            IMRT_FmtAttr  *Value_ptr          = (IMRT_FmtAttr  *)va_arg( Args, IMRT_FmtAttr  *);


            Command_Name = "NDD_CMD_INDEX_GET";

            switch(Cmd)
            {
                case IMRD_SDMD_CMD_INDEX0_PRINT:
                {
                    *Reply_Index_Id_Ptr = 0;
                    *Reply_Command_Ptr = NDD_CMD_VALUE_PRINT;

                    break;
                }
                default:
                {
                    *Reply_Index_Id_Ptr = Index_Id;
                    *Reply_Command_Ptr = Cmd;

                    break;
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ALLOC:
        {
            /*
	      void       **Value_Ptr_Ptr = (void **)va_arg( Args, void  **);
	      va_list      user_args     = (va_list)va_arg( Args, va_list);
	      user_type    user_data     = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_FmtAttr  **Value_Ptr_Ptr = va_arg( Args, IMRT_FmtAttr  **);


            Command_Name = "NDD_CMD_VALUE_ALLOC";

            if( ( *Value_Ptr_Ptr = (IMRT_FmtAttr  *)malloc( sizeof(IMRT_FmtAttr))) == NULL)
            {
                return( NDS_ERRMEM);
            }
            else
            {
                SDM_InitFmtAttr(*Value_Ptr_Ptr);
                return( NDS_OK);
            }
        }

        case NDD_CMD_VALUE_FREE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_FmtAttr  *Value_Ptr = (IMRT_FmtAttr  *)va_arg( Args, IMRT_FmtAttr  *);
            Command_Name = "NDD_CMD_VALUE_FREE";

            free( Value_Ptr);

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_COMP:
        {
            /*
	      void       *Value1_Ptr = (void *)va_arg( Args, void  *);
	      void       *Value2_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args  = (va_list)va_arg( Args, va_list);
	      user_type   user_data  = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_FmtAttr    *Value1_Ptr = va_arg( Args, IMRT_FmtAttr  *);
            IMRT_FmtAttr    *Value2_Ptr = va_arg( Args, IMRT_FmtAttr  *);


            Command_Name = "NDD_CMD_VALUE_COMP";

            switch( Index_Id)
            {
                case 0:
                {
                    if( Value1_Ptr->Id < Value2_Ptr->Id)
                    {
                        return( NDS_LOWER);
                    }
                    else
                    {
                        if( Value1_Ptr->Id > Value2_Ptr->Id)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                case 1:
                {
                    int     rc;


                    rc=strcmp( Value1_Ptr->Name, Value2_Ptr->Name);

                    if( rc <0)
                    {
                        return( NDS_LOWER);
                    }
                    else
                    {
                        if( rc > 0)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                default:
                {
                   IMRD_LM_LOG_ERROR_1( "SDM_FmtAttr_Manager Unknown COMP idx (%d) !\n", Index_Id);

                    return( NDS_KO);
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ADD:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_ADD";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_REMOVE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_REMOVE";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list               lib_args        = (va_list)va_arg( Args, va_list);
            FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);

            IMRT_FmtAttr         *FmtAttr_Ptr     = Node_Ptr->Value;


            Command_Name = "NDD_CMD_VALUE_PRINT";

            fprintf( Out, "Id: (%d) Name: (%s) Value: (%s) \n", FmtAttr_Ptr->Id, FmtAttr_Ptr->Name, FmtAttr_Ptr->Value);
            return( NDS_OK);

        }

        case NDD_CMD_INFO_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */

            Command_Name = "NDD_CMD_INFO_PRINT";

            return( NDS_OK);
        }

		case IMRD_SDMD_CMD_API_SQL_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);
			IMRT_FmtAttr    *FmtAttr_Ptr   = Node_Ptr->Value;

			char   * FmtAttr_Value_convert_Ptr;

			Command_Name = "IMRD_SDMD_CMD_API_SQL_DUMP";

				FmtAttr_Value_convert_Ptr = (char *) malloc(IMRD_FMTATTR_VALUE_SIZE);
				status = SDM_ConvertAttributeInv(FmtAttr_Ptr->Value, FmtAttr_Value_convert_Ptr);
       			fprintf( Out, "INSERT INTO IMR_FMT_ATTR(FMTATTR_ID, FMTATTR_NAME, FMTATTR_VALUE) VALUES(%d, '%s', '%s');\n", 
       						FmtAttr_Ptr->Id, FmtAttr_Ptr->Name, FmtAttr_Value_convert_Ptr);
       			free(FmtAttr_Value_convert_Ptr);

			return( NDS_OK);
		}

		case IMRD_SDMD_CMD_API_XML_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);
			IMRT_FmtAttr    *FmtAttr_Ptr   =      Node_Ptr->Value;

			char   * FmtAttr_Value_convert_Ptr;

			Command_Name = "IMRD_SDMD_CMD_API_XML_DUMP";

			fprintf( Out, "\t<%s>\n", IMRD_SDMD_TAG_FMTATTR);

			fprintf( Out, "\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_NAME, FmtAttr_Ptr->Name, IMRD_SDMD_TAG_NAME);

			FmtAttr_Value_convert_Ptr = (char *) malloc(IMRD_FMTATTR_VALUE_SIZE);
			status = SDM_ConvertAttributeInv(FmtAttr_Ptr->Value, FmtAttr_Value_convert_Ptr);
			fprintf( Out, "\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_VALUE, FmtAttr_Value_convert_Ptr, IMRD_SDMD_TAG_VALUE);

			fprintf( Out, "\t</%s>\n", IMRD_SDMD_TAG_FMTATTR);
   			free(FmtAttr_Value_convert_Ptr);

			return( NDS_OK);
		}

        default:
        {
            IMRD_LM_LOG_ERROR_1( "SDM_FmtAttr_Manager() called with an undefined command %d\n", Command);
            return NDS_ERRAPI;
        }
    }

    
    return NDS_OK;
}




/*----------------------------------------------------------------------------*/
/* FmtMsg Manager                                                             */
/*----------------------------------------------------------------------------*/

NDT_Status  SDM_FmtMsg_Manager( NDT_Root  *Root_Ptr, NDT_Index_Id  Index_Id, NDT_Node  *Node_Ptr, NDT_Command  Command, va_list  Args)
{
    NDT_Command_Name  Command_Name;
    NDT_Status        status;
    IMRT_Status statuscb;
    /*static short  Num_Ordre=0;*/


    switch( Command)
    {
        case NDD_CMD_MANAGER_VERSION:
        {
            NDT_Version_Name  *Version_Name_Ptr = (NDT_Version_Name  *)va_arg( Args, NDT_Version_Name  *);

            Command_Name = "NDD_CMD_MANAGER_VERSION";
            *Version_Name_Ptr = "Revision: 2.1    Name: libnode-2_0_4-1    Date: 2002/02/28 22:00:35    Author: agibert ";

            return( NDS_OK);
        }

        case NDD_CMD_INDEX_GET:
        {
            /*
	      NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
	      NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
	      NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
	      void          *Value_ptr          = (void  *)va_arg( Args, void  *);
            */
            NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
            NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
            NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
            IMRT_FmtMsg    * Value_ptr       = (IMRT_FmtMsg  *)va_arg( Args, IMRT_FmtMsg  *);


            Command_Name = "NDD_CMD_INDEX_GET";

            switch(Cmd)
            {
                case IMRD_SDMD_CMD_INDEX0_PRINT:
                {
                    *Reply_Index_Id_Ptr = 0;
                    *Reply_Command_Ptr = NDD_CMD_VALUE_PRINT;

                    break;
                }

                case IMRD_SDMD_CMD_EXECUTE:
                {
                    *Reply_Index_Id_Ptr = 0;
                    *Reply_Command_Ptr = NDD_CMD_EXECUTE;

                    break;
                }

                default:
                {
                    *Reply_Index_Id_Ptr = Index_Id;
                    *Reply_Command_Ptr = Cmd;

                    break;
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ALLOC:
        {
            /*
	      void       **Value_Ptr_Ptr = (void **)va_arg( Args, void  **);
	      va_list      user_args     = (va_list)va_arg( Args, va_list);
	      user_type    user_data     = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_FmtMsg  **Value_Ptr_Ptr = va_arg( Args, IMRT_FmtMsg  **);


            Command_Name = "NDD_CMD_VALUE_ALLOC";

            if( ( *Value_Ptr_Ptr = (IMRT_FmtMsg  *)malloc( sizeof(IMRT_FmtMsg))) == NULL)
            {
                return( NDS_ERRMEM);
            }
            else
            {
                SDM_InitFmtMsg(*Value_Ptr_Ptr);

                return( NDS_OK);
            }

        }

        case NDD_CMD_VALUE_FREE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
           
            /*IMRT_Fmt  *Value_Ptr = (IMRT_Fmt  *)va_arg( Args, IMRT_Fmt  *);


            Command_Name = "NDD_CMD_VALUE_FREE";

            free( Value_Ptr->FmtAttr_Ptr);
            free( Value_Ptr);*/


			IMRT_FmtMsg		*Value_Ptr = (IMRT_FmtMsg  *)va_arg( Args, IMRT_FmtMsg  *);

            Command_Name = "NDD_CMD_VALUE_FREE";

            free( Value_Ptr);

            return( NDS_OK);

        }

        case NDD_CMD_VALUE_COMP:
        {
            /*
	      void       *Value1_Ptr = (void *)va_arg( Args, void  *);
	      void       *Value2_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args  = (va_list)va_arg( Args, va_list);
	      user_type   user_data  = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_Msg    * Value1_Ptr = (IMRT_Msg *)va_arg( Args, NDT_Node *);
            IMRT_Msg    * Value2_Ptr = (IMRT_Msg *)va_arg( Args, NDT_Node *);


            Command_Name = "NDD_CMD_VALUE_COMP";

            switch( Index_Id)
            {
                case 0:
                {
                    int     rc;


                    rc = strcmp( Value1_Ptr->Name, Value1_Ptr->Name);

                    if( rc < 0)
                    {
                        return( NDS_LOWER);
                    }
                    else
                    {
                        if( rc > 0)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                default:
                {
                    IMRD_LM_LOG_ERROR_1("SDM_FmtMsg_Manager Unknown COMP idx (%d) !\n", Index_Id);

                    return( NDS_KO);
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ADD:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_ADD";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_REMOVE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_REMOVE";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list               lib_args        = (va_list)va_arg( Args, va_list);
            FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
            IMRT_FmtMsg          *Value_Ptr = Node_Ptr->Value;


            Command_Name = "NDD_CMD_VALUE_PRINT";

            fprintf( Out, "\tFmtMsg - Msg Name: (%s) Branche Id: (%d)  Attribute:  (%s)\n", Value_Ptr->Msg_Ptr->Name, Value_Ptr->Branche_Id, Value_Ptr->FmtAttr_Ptr->Value);

            return( NDS_OK);
        }

        case NDD_CMD_INFO_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            Command_Name = "NDD_CMD_INFO_PRINT";

            return( NDS_OK);
        }
        case NDD_CMD_EXECUTE:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            NDT_Node *Next_Node_Ptr            = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list lib_args                   = (va_list)va_arg( Args, va_list);
            FILE *Out                          = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            va_list user_args                  = (va_list)va_arg( Args, va_list);
            IMRT_SDM_IdentMessage *  IdentStruct_Ptr   = (IMRT_SDM_IdentMessage *)va_arg(lib_args,IMRT_SDM_IdentMessage *);

            IMRT_FmtMsg     *FmtMsg_Ptr        = (IMRT_FmtMsg *)Node_Ptr->Value;
            IMRT_Msg        *Msg_Ptr           = (IMRT_Msg *)FmtMsg_Ptr->Msg_Ptr;

            Command_Name = "NDD_CMD_EXECUTE";
            status = NDS_OK;
            statuscb = IMRS_OK;

	 	    if (IdentStruct_Ptr->Mode == IMRD_SKIP_MODE)
	    {
		if (IdentStruct_Ptr->Id == Msg_Ptr->Id)
		{
		    IdentStruct_Ptr->Mode = IMRD_NORMALE_MODE;
		    IdentStruct_Ptr->Branche_Id = FmtMsg_Ptr->Branche_Id;
		}
            }
            else
            {
		if (FmtMsg_Ptr->Branche_Id == IdentStruct_Ptr->Branche_Id)
		{
		    if(Msg_Ptr->Size != 0 )
		    {
			statuscb = IdentStruct_Ptr->Ident_Msg_SizeFunc_Ptr(Msg_Ptr->Size);
		    }

		    if(statuscb == IMRS_OK)
		    {
			status = ND_DataStruct_Traverse( Msg_Ptr->Field_Struct_Ptr, IMRD_SDMD_CMD_EXECUTE, stdout, NDD_RECURSIVE_MODE_PARENT, IdentStruct_Ptr); 
                            
			if(status == NDS_OK)
			{
			    strcpy( IdentStruct_Ptr->Type, Msg_Ptr->Name);
			    IdentStruct_Ptr->Id = Msg_Ptr->Id;  
			    status = NDS_IDENT_OK;
			}
			else if(status == NDS_KO)
			{
			    status = NDS_KO;
			}
			else
			{ 
			    status = NDS_OK;
			}
		    }
		    else if(statuscb == IMRS_NO_IDENT) 
		    {
			status = NDS_OK;
		    }
		    else
		    {
			status = NDS_KO;
		    }
		}
		else
		{
		    status = NDS_NO_IDENT;
		}
	    }

            return (status);
        }

	case IMRD_SDMD_CMD_CHECK_FMT_ATTR:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			/*FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);*/
			IMRT_Msg        *Msg_Ptr         =     (IMRT_Msg  *)va_arg( user_args, IMRT_Msg  *);
			IMRT_FmtAttr    *FmtAttr_Ptr     =     (IMRT_FmtAttr *)va_arg( user_args, IMRT_FmtAttr  *);

			IMRT_FmtMsg        *FmtMsg_Ptr  = Node_Ptr->Value;

			Command_Name = "IMRD_SDMD_CMD_CHECK_FMT_ATTR";

			if((FmtMsg_Ptr->Msg_Ptr == Msg_Ptr) &&
			   (FmtMsg_Ptr->FmtAttr_Ptr == FmtAttr_Ptr))
			{
				return( NDS_NODE_FOUND);
			}
			return( NDS_OK);
		}

	case IMRD_SDMD_CMD_API_SQL_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);
			IMRT_Fmt_Id      Fmt_Id        =     (IMRT_Fmt_Id)va_arg( user_args, IMRT_Fmt_Id);
			short           *Num_Ordre     =     (short *)va_arg( user_args, short *);

			IMRT_FmtMsg         *FmtMsg_Ptr  = Node_Ptr->Value;
			IMRT_FmtAttr_Id  FmtAttr_Id;


			Command_Name = "IMRD_SDMD_CMD_API_SQL_DUMP";

			*Num_Ordre += 1;
			if (FmtMsg_Ptr->FmtAttr_Ptr == NULL)
			{
				FmtAttr_Id = IMRD_FMTATTR_ID_UNKNOWN;
			}
			else
			{
				FmtAttr_Id = FmtMsg_Ptr->FmtAttr_Ptr->Id;
			}
				
			fprintf( Out, "INSERT INTO IMR_FMT_MSG(MSG_ID, FORMAT_ID, FMTATTR_Id, NUM_ORDRE_FMT_MSG, FMTMSG_BRANCHE_ID) VALUES(%d, %d, %d, %d, %d);\n",
					FmtMsg_Ptr->Msg_Ptr->Id, Fmt_Id, FmtAttr_Id, *Num_Ordre, FmtMsg_Ptr->Branche_Id);

			return( NDS_OK);
		}

		case IMRD_SDMD_CMD_API_XML_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

			IMRT_FmtMsg        *FmtMsg_Ptr  = Node_Ptr->Value;

			Command_Name = "IMRD_SDMD_CMD_API_XML_DUMP";

			fprintf( Out, "\t\t<%s>\n", IMRD_SDMD_TAG_FMTMSG);

			fprintf( Out, "\t\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_NAME, FmtMsg_Ptr->Msg_Ptr->Name, IMRD_SDMD_TAG_NAME);

			fprintf( Out, "\t\t\t<%s>%d</%s>\n", 
					IMRD_SDMD_TAG_BRANCHE_ID, FmtMsg_Ptr->Branche_Id, IMRD_SDMD_TAG_BRANCHE_ID);

			if (FmtMsg_Ptr->FmtAttr_Ptr != NULL)
			{
				if (strcmp(FmtMsg_Ptr->FmtAttr_Ptr->Name, IMRD_FMTATTR_NAME_UNKNOWN) != 0)
				{
					fprintf( Out, "\t\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_FMTATTR_NAME, FmtMsg_Ptr->FmtAttr_Ptr->Name, IMRD_SDMD_TAG_FMTATTR_NAME);
				}
			}


			fprintf( Out, "\t\t</%s>\n", IMRD_SDMD_TAG_FMTMSG);

			return( NDS_OK);
		}

        default:
        {
           IMRD_LM_LOG_ERROR_1("SDM_FmtMsg_Manager() called with an undefined command %d\n", Command);

            return( NDS_ERRAPI);
        }
    }
    return( NDS_OK);
}





/*----------------------------------------------------------------------------*/
/* Fmt Manager                                                                */
/*----------------------------------------------------------------------------*/

NDT_Status  SDM_Fmt_Manager( NDT_Root  *Root_Ptr, NDT_Index_Id  Index_Id, NDT_Node  *Node_Ptr, NDT_Command  Command, va_list  Args)
{
    NDT_Command_Name  Command_Name;
    NDT_Status        status;
    IMRT_Status       imr_status;


    switch( Command)
    {
        case NDD_CMD_MANAGER_VERSION:
        {
            NDT_Version_Name  *Version_Name_Ptr = (NDT_Version_Name  *)va_arg( Args, NDT_Version_Name  *);


            Command_Name = "NDD_CMD_MANAGER_VERSION";

            *Version_Name_Ptr = "Revision: 2.1    Name: libnode-2_0_4-1    Date: 2002/02/28 22:00:35    Author: agibert ";

            return( NDS_OK);
        }

        case NDD_CMD_INDEX_GET:
        {
            /*
	      NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
	      NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
	      NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
	      void          *Value_ptr          = (void  *)va_arg( Args, void  *);
            */
            NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
            NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
            NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
            IMRT_Fmt    * Value_ptr           = (IMRT_Fmt  *)va_arg( Args, IMRT_Fmt  *);


            Command_Name = "NDD_CMD_INDEX_GET";

            switch(Cmd)
            {
                case IMRD_SDMD_CMD_INDEX0_PRINT:
                {
                    *Reply_Index_Id_Ptr = 0;
                    *Reply_Command_Ptr = NDD_CMD_VALUE_PRINT;

                    break;
                }

                default:
                {
                    *Reply_Index_Id_Ptr = Index_Id;
                    *Reply_Command_Ptr = Cmd;

                    break;
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ALLOC:
        {
            /*
	      void       **Value_Ptr_Ptr = (void **)va_arg( Args, void  **);
	      va_list      user_args     = (va_list)va_arg( Args, va_list);
	      user_type    user_data     = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_Fmt  **Value_Ptr_Ptr = va_arg( Args, IMRT_Fmt  **);


            Command_Name = "NDD_CMD_VALUE_ALLOC";

            if( ( *Value_Ptr_Ptr = (IMRT_Fmt  *)malloc( sizeof(IMRT_Fmt))) == NULL)
            {
                return( NDS_ERRMEM);
            }
            else
            {
                SDM_InitFormat(*Value_Ptr_Ptr);

                if( ( status = ND_DataStruct_Open( &((*Value_Ptr_Ptr)->FmtMsg_Struct_Ptr), IMRD_SDMD_INDEX_NB, index_type_initial_tab, "SDM_FmtMsg_Manager", SDM_FmtMsg_Manager, NULL, NULL, NULL, NULL,0,  NULL)) != NDS_OK)
				{
                  IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Open() Format failed (%d) !\n", status);
				}
                return( NDS_OK);
            }
        }

        case NDD_CMD_VALUE_FREE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_Fmt  *Value_Ptr = (IMRT_Fmt  *)va_arg( Args, IMRT_Fmt  *);


            Command_Name = "NDD_CMD_VALUE_FREE";

            if( ( status = ND_DataStruct_Close( Value_Ptr->FmtMsg_Struct_Ptr)) != NDS_OK)
	    {
		IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Close() Format failed (%d) !\n", status);
		return( status);
	    }
            free( Value_Ptr);

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_COMP:
        {
            /*
	      void       *Value1_Ptr = (void *)va_arg( Args, void  *);
	      void       *Value2_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args  = (va_list)va_arg( Args, va_list);
	      user_type   user_data  = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_Fmt    *Value1_Ptr = va_arg( Args, IMRT_Fmt  *);
            IMRT_Fmt    *Value2_Ptr = va_arg( Args, IMRT_Fmt  *);


            Command_Name = "NDD_CMD_VALUE_COMP";

            switch( Index_Id)
            {
                
                case 0:
                {
                    if( Value1_Ptr->Id < Value2_Ptr->Id)
                    {
                        return( NDS_LOWER);
                  }
                    else
                    {
                        if( Value1_Ptr->Id > Value2_Ptr->Id)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                case 1:
                {
                    int     rc;


                    rc=strcmp( Value1_Ptr->Name, Value2_Ptr->Name);

                    if( rc <0)
                    {
                        return( NDS_LOWER);
                    }
                    else
                    {
                        if( rc > 0)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                default:
                {
                    IMRD_LM_LOG_ERROR_1( "Unknown COMP idx (%d) !\n", Index_Id);

                    return( NDS_KO);
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ADD:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            Command_Name = "NDD_CMD_VALUE_ADD";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_REMOVE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            Command_Name = "NDD_CMD_VALUE_REMOVE";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr    = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args         = (va_list)va_arg( Args, va_list);
	      FILE                 *Out              = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode   = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth  = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      NDT_Recursive_Offset  Recursive_Offset = (NDT_Recursive_Offset)va_arg( lib_args, NDT_Recursive_Offset);
	      va_list               user_args        = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data        = (user_type)va_arg( user_args, user_type);
	      ...  = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr        = Node_Ptr->Value;
            */
            NDT_Node             *Next_Node_Ptr    = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list               lib_args         = (va_list)va_arg( Args, va_list);
            FILE                 *Out              = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode   = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            NDT_Recursive_Depth   Recursive_Depth  = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
            NDT_Recursive_Offset  Recursive_Offset = (NDT_Recursive_Offset)va_arg( lib_args, NDT_Recursive_Offset);

            IMRT_Fmt           *Value_Ptr       = Node_Ptr->Value;


            Command_Name = "NDD_CMD_VALUE_PRINT";

            fprintf( Out, "Format - Name: (%s) \n",Value_Ptr->Name);

            return( ND_DataStruct_Value_Print( Out, Value_Ptr->FmtMsg_Struct_Ptr, NDD_RECURSIVE_MODE_PARENT_CHILD, --Recursive_Depth, ++Recursive_Offset));
        }

        case NDD_CMD_INFO_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */

            Command_Name = "NDD_CMD_INFO_PRINT";

            return( NDS_OK);
        }

        case IMRD_SDMD_CMD_EXECUTE:
        { /*
            NDT_Node             *Next_Node_Ptr    = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list               lib_args         = (va_list)va_arg( Args, va_list);
            FILE                 *Out              = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode   = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            NDT_Recursive_Depth   Recursive_Depth  = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
            NDT_Recursive_Offset  Recursive_Offset = (NDT_Recursive_Offset)va_arg( lib_args, NDT_Recursive_Offset);
            va_list               user_args        = (va_list)va_arg( lib_args, va_list);
            user_type             user_data        = (user_type)va_arg( user_args, user_type);
	    ...  = (...)va_arg( user_args, ...);
            void                 *Value_Ptr        = Node_Ptr->Value;
	  */
            IMRT_Fmt *  Value_Ptr             = (IMRT_Fmt*)Node_Ptr->Value;
            NDT_Node *Next_Node_Ptr                = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list lib_args                       = (va_list)va_arg( Args, va_list);
            FILE *Out                              = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode   = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            IMRT_SDMCB_Fmt_Add   * FmtProceedFunc      = ( IMRT_SDMCB_Fmt_Add *)va_arg(lib_args, IMRT_SDMCB_Fmt_Add *);
            
            imr_status = FmtProceedFunc(Value_Ptr->Id, Value_Ptr->Name, IMRG_SDM_Base.RootFmt->Index_Tab[NDD_INDEX_PRIMARY].Node_Number);
            if(imr_status == IMRS_OK)
            {
	            status = NDS_OK;
            }
            else
            {
	            status = NDS_KO;
            }

			return(status);
        }

		case IMRD_SDMD_CMD_API_SQL_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

			IMRT_Fmt        *Fmt_Ptr  = Node_Ptr->Value;
			short  Num_Ordre=0;

			Command_Name = "IMRD_SDMD_CMD_API_SQL_DUMP";

			fprintf( Out, "INSERT INTO IMR_FORMAT(FORMAT_ID, FORMAT_NAME) VALUES(%d, '%s');\n",
					Fmt_Ptr->Id, Fmt_Ptr->Name);

		    if( ( status = ND_DataStruct_Traverse( Fmt_Ptr->FmtMsg_Struct_Ptr, IMRD_SDMD_CMD_API_SQL_DUMP, Out, Fmt_Ptr->Id, &Num_Ordre)) != NDS_OK)
			{
			    IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Traverse failed (%d)...\n",status);
				return(NDS_KO);
			}

			return( NDS_OK);
		}

		case IMRD_SDMD_CMD_API_XML_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

			IMRT_Fmt        *Fmt_Ptr  = Node_Ptr->Value;


			Command_Name = "IMRD_SDMD_CMD_API_XML_DUMP";

			fprintf( Out, "\t<%s>\n", IMRD_SDMD_TAG_FORMAT);

			fprintf( Out, "\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_NAME, Fmt_Ptr->Name, IMRD_SDMD_TAG_NAME);

		    if( ( status = ND_DataStruct_Traverse( Fmt_Ptr->FmtMsg_Struct_Ptr, IMRD_SDMD_CMD_API_XML_DUMP, Out)) != NDS_OK)
			{
			    IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Traverse failed (%d)...\n",status);
				return(NDS_KO);
			}

			fprintf( Out, "\t</%s>\n", IMRD_SDMD_TAG_FORMAT);

			return( NDS_OK);
		}

        default:
        {
            IMRD_LM_LOG_ERROR_1( "SDM_Fmt_Manager() called with an undefined command %d\n", Command);

            return( NDS_ERRAPI);
        }
    }

   

    return( NDS_OK);
}





/*----------------------------------------------------------------------------*/
/* MapCmd Manager                                                             */
/*----------------------------------------------------------------------------*/

NDT_Status  SDM_MapCmd_Manager( NDT_Root  *Root_Ptr, NDT_Index_Id  Index_Id, NDT_Node  *Node_Ptr, NDT_Command  Command, va_list Args)
{
    NDT_Command_Name        Command_Name;
    SDMT_CritereRecChemin * Recherche = NULL;
    IMRT_Status     statusTmp;
    char functioname[] = "SDM_MapCmd_Manager";
	int                i;
  
   
    

    switch( Command)
    {
        case NDD_CMD_MANAGER_VERSION:
        {
            NDT_Version_Name  *Version_Name_Ptr = (NDT_Version_Name  *)va_arg( Args, NDT_Version_Name  *);


            Command_Name = "NDD_CMD_MANAGER_VERSION";

            *Version_Name_Ptr = "Revision: 2.1    Name: libnode-2_0_4-1    Date: 2002/02/28 22:00:35    Author: agibert ";

            return( NDS_OK);
        }

        case NDD_CMD_INDEX_GET:
        {
            /*
	      NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
	      NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
	      NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
	      void          *Value_ptr          = (void  *)va_arg( Args, void  *);
            */
            NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
            NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
            NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
            IMRT_MapCmd    * Value_ptr        = (IMRT_MapCmd  *)va_arg( Args, IMRT_MapCmd  *);

            Command_Name = "NDD_CMD_INDEX_GET";

            switch(Cmd)
            {
                case IMRD_SDMD_CMD_INDEX0_PRINT:
                {
                    *Reply_Index_Id_Ptr = 0;
                    *Reply_Command_Ptr = NDD_CMD_VALUE_PRINT;
                    break;
                }

                case IMRD_SDMD_CMD_EXECUTE:
                {
		    *Reply_Index_Id_Ptr = 0;
		    *Reply_Command_Ptr = NDD_CMD_EXECUTE;
		    break;
                }

                default:
                {
                    *Reply_Index_Id_Ptr = Index_Id;
                    *Reply_Command_Ptr = Cmd;
                    break;
                }
            }
            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ALLOC:
        {
            /*
	      void       **Value_Ptr_Ptr = (void **)va_arg( Args, void  **);
	      va_list      user_args     = (va_list)va_arg( Args, va_list);
	      user_type    user_data     = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_MapCmd  **Value_Ptr_Ptr = va_arg( Args, IMRT_MapCmd  **);

            Command_Name = "NDD_CMD_VALUE_ALLOC";

            if( ( *Value_Ptr_Ptr = (IMRT_MapCmd  *)malloc( sizeof(IMRT_MapCmd))) == NULL)
            {
                return( NDS_ERRMEM);
            }
            else
            {
                SDM_InitMapCmd( *Value_Ptr_Ptr);
                return( NDS_OK);
            }
        }

        case NDD_CMD_VALUE_FREE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_MapCmd  *Value_Ptr = (IMRT_MapCmd  *)va_arg( Args, IMRT_MapCmd  *);

            Command_Name = "NDD_CMD_VALUE_FREE";
			
			free(Value_Ptr->Jump_Tab);
            free( Value_Ptr);

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_COMP:
        {
            /*
	      void       *Value1_Ptr = (void *)va_arg( Args, void  *);
	      void       *Value2_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args  = (va_list)va_arg( Args, va_list);
	      user_type   user_data  = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_MapCmd    *Value1_Ptr = va_arg( Args, IMRT_MapCmd  *);
            IMRT_MapCmd    *Value2_Ptr = va_arg( Args, IMRT_MapCmd  *);


            Command_Name = "NDD_CMD_VALUE_COMP";

            switch( Index_Id)
            {
                case 0:
                {
		    if( Value1_Ptr->MapCmd_Id<Value2_Ptr->MapCmd_Id)
                    {
                        return( NDS_LOWER);
                    }
                    else
                    {
                        if( Value1_Ptr->MapCmd_Id > Value2_Ptr->MapCmd_Id)
                        {
                            return( NDS_GREATER);
                        }
                        else
                        {
                            return( NDS_EQUAL);
                        }
                    }
                }

                default:
                {
                    IMRD_LM_LOG_ERROR_1( "Unknown COMP idx (%d) !\n", Index_Id);
                    return( NDS_KO);
                }
            }

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ADD:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_ADD";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_REMOVE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            Command_Name = "NDD_CMD_VALUE_REMOVE";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list               lib_args        = (va_list)va_arg( Args, va_list);
            FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);

            IMRT_MapCmd           *Value_Ptr       = Node_Ptr->Value;
			char                   Local_Ident_Total;

	    Command_Name = "NDD_CMD_VALUE_PRINT";

	    if( Value_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_MAP)
	    {
		fprintf( Out,"type_commande (mapper)\n");
	    }
	    else if( Value_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_COPY)
	    {
		fprintf( Out,"type_commande (copier)\n");
	    }
	    else if( Value_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_IDENT)
	    {
		fprintf( Out,"type_commande (identifier)\n");
	    }
	    else if( Value_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_GOTO)
	    {
		fprintf( Out,"type_commande (go_to)\n");
	    }

		if (Value_Ptr->Ident_Total == IMRD_TRUE)
		{
			Local_Ident_Total = IMRD_YES;
		}
		else
		{
			Local_Ident_Total = IMRD_NO;
		}

	    fprintf( Out, "IdMapCmd: (%d) Ident_Total: (%c) InputFormat: (%s)  InputFormat_Attr: (%s)  OutputFormat: (%s) OutputFormat_Attr: (%s) \n Branche_id (%d) OutputBuffer: (%d) InputBuffer : (%d) MappingRule: (%s) NumBufferToIdent (%d)  \n",
		     Value_Ptr->MapCmd_Id, Local_Ident_Total, Value_Ptr->Fmt_Input_Ptr->Name, Value_Ptr->FmtAttr_Input_Ptr->Value,
		     Value_Ptr->Fmt_Output_Ptr->Name,Value_Ptr->FmtAttr_Output_Ptr->Value, Value_Ptr->Branche_Id,
		     Value_Ptr->Buffer_Id_Input,Value_Ptr->Buffer_Id_Output, 
		     Value_Ptr->MsgMap_Ptr->Name , Value_Ptr->Buffer_Id_Ident);

            return( NDS_OK);
        }

        case NDD_CMD_INFO_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            
            Command_Name = "NDD_CMD_INFO_PRINT";

            return( NDS_OK);
        }

        case NDD_CMD_EXECUTE:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
	        IMRT_MapCmd *  Value_Ptr = (IMRT_MapCmd*)Node_Ptr->Value;
	    	IMRT_Status statuscb;
	        int branche =-1;
	        IMRT_Fmt_Id  Format;
	        NDT_Status status;
	        NDT_Node     *node_ptr_input;
	        NDT_Node     *node_ptr_output;
	        IMRT_Msg_Id  BufferType;
	        NDT_Node *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	        va_list lib_args          = (va_list)va_arg( Args, va_list);
	        FILE *Out                 = (FILE  *)va_arg( lib_args, FILE  *);
	        NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	        va_list user_args         = (va_list)va_arg( Args, va_list);
	        SDMT_CritereRecChemin *Recherche        = (SDMT_CritereRecChemin *)va_arg(lib_args,SDMT_CritereRecChemin *);
	        IMRT_Mode_Traverse * Mode_Normal_Erreur_Ptr = (IMRT_Mode_Traverse *)va_arg(lib_args, IMRT_Mode_Traverse *);

    
            Command_Name = "NDD_CMD_EXECUTE";
		    statuscb = IMRS_OK;

            if(Value_Ptr->Branche_Id == Recherche->Branche_id)
            {
				switch(Value_Ptr->TypeCmd)
				{
					case IMRD_MAPCMD_TYPE_MAP:
					{
						statuscb = Recherche->CallBackBCommandeMap(Value_Ptr->Buffer_Id_Output ,
											 Value_Ptr->Fmt_Output_Ptr->Id,
											 ( (Value_Ptr->FmtAttr_Output_Ptr == NULL) ? NULL : Value_Ptr->FmtAttr_Output_Ptr->Value),
											 Value_Ptr->Buffer_Id_Input,
											 Value_Ptr->Fmt_Input_Ptr->Id ,
											 ( (Value_Ptr->FmtAttr_Input_Ptr == NULL) ? NULL : Value_Ptr->FmtAttr_Input_Ptr->Value), 
											 Value_Ptr->MsgMap_Ptr ,
											 Value_Ptr->Clear_Flag);
						break;
					}

					case IMRD_MAPCMD_TYPE_COPY:
					{
						statuscb = Recherche->CallBackCommandeCopy(Value_Ptr->Buffer_Id_Output, Value_Ptr->Buffer_Id_Input);
						break;
					}

					case IMRD_MAPCMD_TYPE_IDENT:
					{
						IMRT_Status found = IMRS_KO;
						Format = IMRD_FMT_ID_UNKNOWN;
						BufferType = Value_Ptr->Ident_First_Msg_Ptr->Id;
						statuscb = Recherche->CallBackCommandeIdent(&Format,
											&BufferType,
											Value_Ptr->Buffer_Id_Ident,
											Value_Ptr->Ident_Total);
						if(statuscb == IMRS_OK)
						{
							for(i=0; i<Value_Ptr->JmpTbleNbElts; i++)
							{
								if ((Format == Value_Ptr->Jump_Tab[i].Fmt_Ptr->Id) && 
								    (BufferType == Value_Ptr->Jump_Tab[i].Msg_Ptr->Id))
								{
									Recherche->Branche_id = Value_Ptr->Jump_Tab[i].Branche_Id;
									found = IMRS_OK;
								}
							}

							if(found == IMRS_KO)
							{
								statuscb = IMRS_KO;
							}
						}

						break;
					}

					case IMRD_MAPCMD_TYPE_GOTO:
					{
					    Recherche->Branche_id = Value_Ptr->Goto_Branche_Id;

					    break;
					}

					default:
					{
					    strcpy(Recherche->FataError.function,functioname);
					    Recherche->FataError.errorCode = SDMD_CODE_ERROR_7;
					    strcpy(Recherche->FataError.libError,SDMD_LIB_ERROR_7);
	
					    return( NDS_KO);
					}
				}

				if (*Mode_Normal_Erreur_Ptr == IMRD_NORMALE_MODE)
				{
					if (statuscb != IMRS_OK)
					{
						*Mode_Normal_Erreur_Ptr = IMRD_ERREUR_MODE;
						Recherche->Branche_id = IMRD_LATEST_BRANCHE;
					}
				}
		    }
	
            return( NDS_OK);
        }
	case IMRD_SDMD_CMD_API_SQL_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);
			int              MapPath_Id    =     (int)va_arg( user_args, int);
			IMRT_MapCmd        *MapCmd_Ptr  = Node_Ptr->Value;


			Command_Name = "IMRD_SDMD_CMD_API_SQL_DUMP";

			fprintf( Out, "INSERT INTO IMR_MAPCMD(MAPCMD_ID, MAPCMD_TYPE, CURRENT_BRANCHE_ID) VALUES(%d, %d, %d);\n",
						MapCmd_Ptr->MapCmd_Id, MapCmd_Ptr->TypeCmd, MapCmd_Ptr->Branche_Id);

			fprintf( Out, "INSERT INTO IMR_CMD_MAP_PATH(MAP_PATH_ID, MAPCMD_ID) VALUES(%d, %d);\n",
						MapPath_Id, MapCmd_Ptr->MapCmd_Id);

			if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_IDENT)
			{
				if(MapCmd_Ptr->Ident_Total == IMRD_FALSE)
				{
					fprintf( Out, "INSERT INTO IMR_CMD_IDENT(MAPCMD_ID, IDENT_BUFFER_ID, IDENT_TOTAL, IDENT_FIRST_MSG_ID) VALUES(%d, %d, '%c', %d);\n",
						MapCmd_Ptr->MapCmd_Id, MapCmd_Ptr->Buffer_Id_Ident, IMRD_NO, MapCmd_Ptr->Ident_First_Msg_Ptr->Id);
				}
				else
				{
					fprintf( Out, "INSERT INTO IMR_CMD_IDENT(MAPCMD_ID, IDENT_BUFFER_ID, IDENT_TOTAL, IDENT_FIRST_MSG_ID) VALUES(%d, %d, '%c', %d);\n",
						MapCmd_Ptr->MapCmd_Id, MapCmd_Ptr->Buffer_Id_Ident, IMRD_YES, MapCmd_Ptr->Ident_First_Msg_Ptr->Id);
				}

				for(i=0; i<MapCmd_Ptr->JmpTbleNbElts; i++)
				{
					fprintf( Out, "INSERT INTO IMR_JUMP_TABLE(MAPCMD_ID, MSG_ID, FORMAT_ID, NUM_ORDRE_JUMP, IDENT_BRANCHE_ID) VALUES(%d, %d, %d, %d, %d);\n",
						MapCmd_Ptr->MapCmd_Id, MapCmd_Ptr->Jump_Tab[i].Msg_Ptr->Id, MapCmd_Ptr->Jump_Tab[i].Fmt_Ptr->Id, i, MapCmd_Ptr->Jump_Tab[i].Branche_Id);
				}

			}
			else if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_MAP)
			{
				fprintf( Out, "INSERT INTO IMR_CMD_MAP(MAPCMD_ID, FORMAT_IN_ID, FMTATTR_IN_ID, FORMAT_OUT_ID, FMTATTR_OUT_ID, MSG_MAP_ID, MAP_BUFFER_ID_INPUT, MAP_BUFFER_ID_OUTPUT, CLEAR_FLAG) VALUES(%d, %d, %d, %d, %d, %d, %d, %d, %d);\n",
						MapCmd_Ptr->MapCmd_Id, MapCmd_Ptr->Fmt_Input_Ptr->Id, MapCmd_Ptr->FmtAttr_Input_Ptr->Id, MapCmd_Ptr->Fmt_Output_Ptr->Id, MapCmd_Ptr->FmtAttr_Output_Ptr->Id, 
						MapCmd_Ptr->MsgMap_Ptr->Id, MapCmd_Ptr->Buffer_Id_Input, MapCmd_Ptr->Buffer_Id_Output, MapCmd_Ptr->Clear_Flag);
			}
			else if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_COPY)
			{
				fprintf( Out, "INSERT INTO IMR_CMD_COPY(MAPCMD_ID, COPY_BUFFER_ID_INPUT, COPY_BUFFER_ID_OUTPUT) VALUES(%d, %d, %d);\n",
						MapCmd_Ptr->MapCmd_Id, MapCmd_Ptr->Buffer_Id_Input, MapCmd_Ptr->Buffer_Id_Output);
			}
			else if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_GOTO)
			{
				fprintf( Out, "INSERT INTO IMR_CMD_GOTO(MAPCMD_ID, GOTO_BRANCHE_ID) VALUES(%d, %d);\n",
						MapCmd_Ptr->MapCmd_Id, MapCmd_Ptr->Goto_Branche_Id);
			}
			

			return( NDS_OK);
		}

		case IMRD_SDMD_CMD_API_XML_DUMP:
		{
		/*
			NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list     user_args     =     (va_list)va_arg( Args, va_list);
			user_type   user_data     =   (user_type)va_arg( user_args, user_type);
								  ... =         (...)va_arg( user_args, ...);

  			void       *Value_Ptr     = Node_Ptr->Value;
		*/
			NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
			va_list          user_args     =     (va_list)va_arg( Args, va_list);
			FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

			IMRT_MapCmd        *MapCmd_Ptr  = Node_Ptr->Value;


			Command_Name = "IMRD_SDMD_CMD_API_XML_DUMP";

			fprintf( Out, "\t\t\t<%s>\n", IMRD_SDMD_TAG_MAPCMD);

			fprintf( Out, "\t\t\t\t<%s>%d</%s>\n", 
					IMRD_SDMD_TAG_BRANCHE_ID, MapCmd_Ptr->Branche_Id, IMRD_SDMD_TAG_BRANCHE_ID);

			if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_IDENT)
			{
				fprintf( Out, "\t\t\t\t<%s>\n", IMRD_SDMD_TAG_IDENTIFIER);

				fprintf( Out, "\t\t\t\t\t<%s>%d</%s>\n",
					IMRD_SDMD_TAG_NUMBUFFER, MapCmd_Ptr->Buffer_Id_Ident, IMRD_SDMD_TAG_NUMBUFFER);

				if(MapCmd_Ptr->Ident_Total == IMRD_FALSE)
				{
					fprintf( Out, "\t\t\t\t\t<%s>%c</%s>\n", 
						IMRD_SDMD_TAG_IDENTTOTAL, IMRD_NO, IMRD_SDMD_TAG_IDENTTOTAL);
				}
				else
				{
					fprintf( Out, "\t\t\t\t\t<%s>%c</%s>\n", 
						IMRD_SDMD_TAG_IDENTTOTAL, IMRD_YES, IMRD_SDMD_TAG_IDENTTOTAL);
				}

				if(MapCmd_Ptr->Ident_First_Msg_Ptr != NULL)
				{
					fprintf( Out, "\t\t\t\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_TYPE, MapCmd_Ptr->Ident_First_Msg_Ptr->Name, IMRD_SDMD_TAG_TYPE);
				}

				for(i=0; i<MapCmd_Ptr->JmpTbleNbElts; i++)
				{
					fprintf( Out, "\t\t\t\t\t<%s>\n", IMRD_SDMD_TAG_GO_TO);
						fprintf( Out, "\t\t\t\t\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_FORMAT, MapCmd_Ptr->Jump_Tab[i].Fmt_Ptr->Name, IMRD_SDMD_TAG_FORMAT);

					fprintf( Out, "\t\t\t\t\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_TYPE, MapCmd_Ptr->Jump_Tab[i].Msg_Ptr->Name, IMRD_SDMD_TAG_TYPE);

					fprintf( Out, "\t\t\t\t\t\t<%s>%d</%s>\n", 
						IMRD_SDMD_TAG_BRANCHE_ID, MapCmd_Ptr->Jump_Tab[i].Branche_Id, IMRD_SDMD_TAG_BRANCHE_ID);
						fprintf( Out, "\t\t\t\t\t</%s>\n", IMRD_SDMD_TAG_GO_TO);
				}

				fprintf( Out, "\t\t\t\t</%s>\n", IMRD_SDMD_TAG_IDENTIFIER);
			}
			else if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_MAP)
			{
				fprintf( Out, "\t\t\t\t<%s>\n", IMRD_SDMD_TAG_MAPPER);

				fprintf( Out, "\t\t\t\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_INPUTFORMAT, MapCmd_Ptr->Fmt_Input_Ptr->Name, IMRD_SDMD_TAG_INPUTFORMAT);

				if(strcmp(MapCmd_Ptr->FmtAttr_Input_Ptr->Value, IMRD_SDMD_EMPTY_STRING) != 0)
				{
					fprintf( Out, "\t\t\t\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_INPUTFORMAT_ATTR, MapCmd_Ptr->FmtAttr_Input_Ptr->Name, IMRD_SDMD_TAG_INPUTFORMAT_ATTR);
				}

				fprintf( Out, "\t\t\t\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_OUTPUTFORMAT, MapCmd_Ptr->Fmt_Output_Ptr->Name, IMRD_SDMD_TAG_OUTPUTFORMAT);

				if(strcmp(MapCmd_Ptr->FmtAttr_Output_Ptr->Value, IMRD_SDMD_EMPTY_STRING) != 0)
				{
					fprintf( Out, "\t\t\t\t\t<%s>%s</%s>\n", 
						IMRD_SDMD_TAG_OUTPUTFORMAT_ATTR, MapCmd_Ptr->FmtAttr_Output_Ptr->Name, IMRD_SDMD_TAG_OUTPUTFORMAT_ATTR);
				}

				fprintf( Out, "\t\t\t\t\t<%s>%d</%s>\n", 
					IMRD_SDMD_TAG_INPUTBUFFER, MapCmd_Ptr->Buffer_Id_Input, IMRD_SDMD_TAG_INPUTBUFFER);

				fprintf( Out, "\t\t\t\t\t<%s>%d</%s>\n", 
					IMRD_SDMD_TAG_OUTPUTBUFFER, MapCmd_Ptr->Buffer_Id_Output, IMRD_SDMD_TAG_OUTPUTBUFFER);

				if(MapCmd_Ptr->Clear_Flag != 0)
				{
					fprintf( Out, "\t\t\t\t\t<%s>%d</%s>\n", 
						IMRD_SDMD_TAG_CLEARFLAG, MapCmd_Ptr->Clear_Flag, IMRD_SDMD_TAG_CLEARFLAG);
				}

				fprintf( Out, "\t\t\t\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_MSGMAP, MapCmd_Ptr->MsgMap_Ptr->Name, IMRD_SDMD_TAG_MSGMAP);

				fprintf( Out, "\t\t\t\t</%s>\n", IMRD_SDMD_TAG_MAPPER);
			}
			else if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_COPY)
			{
				fprintf( Out, "\t\t\t\t<%s>\n", IMRD_SDMD_TAG_COPIE);

				fprintf( Out, "\t\t\t\t\t<%s>%d</%s>\n", 
					IMRD_SDMD_TAG_INPUTBUFFER, MapCmd_Ptr->Buffer_Id_Input, IMRD_SDMD_TAG_INPUTBUFFER);

				fprintf( Out, "\t\t\t\t\t<%s>%d</%s>\n", 
					IMRD_SDMD_TAG_OUTPUTBUFFER, MapCmd_Ptr->Buffer_Id_Output, IMRD_SDMD_TAG_OUTPUTBUFFER);

				fprintf( Out, "\t\t\t\t</%s>\n", IMRD_SDMD_TAG_COPIE);
			}
			else if(MapCmd_Ptr->TypeCmd == IMRD_MAPCMD_TYPE_GOTO)
			{
				fprintf( Out, "\t\t\t\t<%s>\n", IMRD_SDMD_TAG_GO_TO);

				fprintf( Out, "\t\t\t\t\t<%s>%d</%s>\n", 
					IMRD_SDMD_TAG_BRANCHE_ID, MapCmd_Ptr->Goto_Branche_Id, IMRD_SDMD_TAG_BRANCHE_ID);

				fprintf( Out, "\t\t\t\t</%s>\n", IMRD_SDMD_TAG_GO_TO);
			}

			fprintf( Out, "\t\t\t</%s>\n", IMRD_SDMD_TAG_MAPCMD);

			return( NDS_OK);
		}

        default:
        {
            IMRD_LM_LOG_ERROR_1( "with an undefined command %d\n", Command);

            return( NDS_ERRAPI);
        }
    }

    return( NDS_OK);
}





/*----------------------------------------------------------------------------*/
/* MapPath Manager                                                            */
/*----------------------------------------------------------------------------*/

NDT_Status  SDM_MapPath_Manager( NDT_Root  *Root_Ptr, NDT_Index_Id  Index_Id, NDT_Node  *Node_Ptr, NDT_Command  Command, va_list  Args)
{
    NDT_Command_Name        Command_Name;
    NDT_Status              status;
    SDMT_CritereRecChemin  *Recherche = NULL;
    IMRT_Status             TableCritere[SDMD_NB_CRITERE_CHEMIN];
    IMRT_Status             Valide;
    char                    functioname[] = "Manager_MapPath";
    

    switch( Command)
    {
        case NDD_CMD_MANAGER_VERSION:
        {
            NDT_Version_Name  *Version_Name_Ptr = (NDT_Version_Name  *)va_arg( Args, NDT_Version_Name  *);


            Command_Name = "NDD_CMD_MANAGER_VERSION";

            *Version_Name_Ptr = "Revision: 2.1    Name: libnode-2_0_4-1    Date: 2002/02/28 22:00:35    Author: agibert ";

            return( NDS_OK);
        }

        case NDD_CMD_INDEX_GET:
        {
            /*
	      NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
	      NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
	      NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
	      void          *Value_ptr          = (void  *)va_arg( Args, void  *);
            */
            NDT_Index_Id  *Reply_Index_Id_Ptr = (NDT_Index_Id  *)va_arg( Args, NDT_Index_Id  *);
            NDT_Command   *Reply_Command_Ptr  = (NDT_Command  *)va_arg( Args, NDT_Command  *);
            NDT_Command    Cmd                = (NDT_Command)va_arg( Args, NDT_Command);
            IMRT_MapPath    *Value_ptr        = (IMRT_MapPath  *)va_arg( Args, IMRT_MapPath  *);
            Command_Name = "NDD_CMD_INDEX_GET";

            switch(Cmd)
            {
                case IMRD_SDMD_CMD_INDEX0_PRINT:
                {
                    *Reply_Index_Id_Ptr = 0;
                    *Reply_Command_Ptr = NDD_CMD_VALUE_PRINT;
                    break;
                }

                default:
                {
                    *Reply_Index_Id_Ptr = Index_Id;
                    *Reply_Command_Ptr = Cmd;
                    break;
                }
            }
            return( NDS_OK);
        }

        case NDD_CMD_VALUE_ALLOC:
        {
            /*
	      void       **Value_Ptr_Ptr = (void **)va_arg( Args, void  **);
	      va_list      user_args     = (va_list)va_arg( Args, va_list);
	      user_type    user_data     = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_MapPath  **Value_Ptr_Ptr = va_arg( Args, IMRT_MapPath  **);

            Command_Name = "NDD_CMD_VALUE_ALLOC";

            if( ( *Value_Ptr_Ptr = (IMRT_MapPath  *)malloc( sizeof(IMRT_MapPath))) == NULL)
            {
                return(NDS_ERRMEM);
            }
            else
            {
                SDM_InitMapPath(*Value_Ptr_Ptr);
                if( ( status = ND_DataStruct_Open( &(*Value_Ptr_Ptr)->MapCmd_Struct_Ptr, IMRD_SDMD_INDEX_NB, index_type_initial_tab, "SDM_MapCmd_Manager", SDM_MapCmd_Manager, NULL, NULL, NULL, NULL,0,NULL)) != NDS_OK)
		{
		    IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Open() MapCmd failed (%d) !\n", status);
		    return(NDS_KO);
		}

                return( NDS_OK);
            }
        }

        case NDD_CMD_VALUE_FREE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            IMRT_MapPath  *Value_Ptr = (IMRT_MapPath  *)va_arg( Args, IMRT_MapPath  *);

            Command_Name = "NDD_CMD_VALUE_FREE";
            if(Value_Ptr->MapCmd_Struct_Ptr != NULL)
            {	if( ( status = ND_DataStruct_Close(Value_Ptr->MapCmd_Struct_Ptr)) != NDS_OK)
				{
				    IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Close() failed (%d) !\n", status);
				    return(status);
				}
            }

            free( Value_Ptr);
            
            return( NDS_OK);
        }

        case NDD_CMD_VALUE_COMP:
        {
            /*
	      void       *Value1_Ptr = (void *)va_arg( Args, void  *);
	      void       *Value2_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args  = (va_list)va_arg( Args, va_list);
	      user_type   user_data  = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */
            
            IMRT_MapPath *Value1_Ptr = va_arg( Args, IMRT_MapPath  *);
            IMRT_MapPath *Value2_Ptr = va_arg( Args, IMRT_MapPath  *);
            va_list user_args   = (va_list)va_arg( Args, va_list);    
            
            Command_Name = "NDD_CMD_VALUE_COMP";

                switch( Index_Id)
                {
				    case 0:
				    {
						if( Value1_Ptr->idMapPath< Value2_Ptr->idMapPath)
						{
						    return(NDS_LOWER);
						}
						else
						{
						    if( Value1_Ptr->idMapPath > Value2_Ptr->idMapPath)
						    {
								return(NDS_GREATER);
						    }
						    else
						    {
								return(NDS_EQUAL);
						    }
						}
				    }

				    default:
				    {
						IMRD_LM_LOG_ERROR_1( "Unknown COMP idx (%d) !\n", Index_Id);
						return( NDS_KO);
				    }
                }  /* end switch */

                return( NDS_OK);
	    
        }

        case NDD_CMD_VALUE_ADD:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_ADD";

            return( NDS_OK);
        }

        case NDD_CMD_VALUE_REMOVE:
        {
            /*
	      void       *Value_Ptr = (void *)va_arg( Args, void  *);
	      va_list     user_args = (va_list)va_arg( Args, va_list);
	      user_type   user_data = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
            */

            Command_Name = "NDD_CMD_VALUE_REMOVE";
            return( NDS_OK);
        }

        case NDD_CMD_VALUE_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr    = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args         = (va_list)va_arg( Args, va_list);
	      FILE                 *Out              = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode   = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth  = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      NDT_Recursive_Offset  Recursive_Offset = (NDT_Recursive_Offset)va_arg( lib_args, NDT_Recursive_Offset);
	      va_list               user_args        = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data        = (user_type)va_arg( user_args, user_type);
	      ...  = (...)va_arg( user_args, ...);

	      void                 *Value_Ptr        = Node_Ptr->Value;
            */
            NDT_Node             *Next_Node_Ptr    = (NDT_Node  *)va_arg( Args, NDT_Node  *);
            va_list               lib_args         = (va_list)va_arg( Args, va_list);
            FILE                 *Out              = (FILE  *)va_arg( lib_args, FILE  *);
            NDT_Recursive_Mode    Recursive_Mode   = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
            NDT_Recursive_Depth   Recursive_Depth  = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
            NDT_Recursive_Offset  Recursive_Offset = (NDT_Recursive_Offset)va_arg( lib_args, NDT_Recursive_Offset);

            IMRT_MapPath          *Value_Ptr       = Node_Ptr->Value;

            Command_Name = "NDD_CMD_VALUE_PRINT";

           
            fprintf( Out, "idMapPath: (%d)   InputFormat: (%s) OutputFormat: (%s)  InputAppli: (%s)  OutputAppli: (%s)   \n",
		     Value_Ptr->idMapPath, 
		     Value_Ptr->Fmt_Input_Ptr->Name, 
		     Value_Ptr->Fmt_Output_Ptr->Name,
		     Value_Ptr->Appl_Input_Ptr->Name,
		     Value_Ptr->Appl_Output_Ptr->Name);

            return( ND_DataStruct_Value_Print( Out, Value_Ptr->MapCmd_Struct_Ptr, NDD_RECURSIVE_MODE_PARENT_CHILD, --Recursive_Depth, ++Recursive_Offset));
            
        }

        case NDD_CMD_INFO_PRINT:
        {
            /*
	      NDT_Node             *Next_Node_Ptr    = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args         = (va_list)va_arg( Args, va_list);
	      FILE                 *Out              = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode   = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth  = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      NDT_Recursive_Offset  Recursive_Offset = (NDT_Recursive_Offset)va_arg( lib_args, NDT_Recursive_Offset);
	      va_list               user_args        = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data        = (user_type)va_arg( user_args, user_type);
	      ...  = (...)va_arg( user_args, ...);

	      void                 *Value_Ptr       = Node_Ptr->Value;
            */

            NDT_Node             *Next_Node_Ptr    = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	    va_list               lib_args         = (va_list)va_arg( Args, va_list);
	    FILE                 *Out              = (FILE  *)va_arg( lib_args, FILE  *);
	    NDT_Recursive_Mode    Recursive_Mode   =(NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	    NDT_Recursive_Depth   Recursive_Depth  = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	    NDT_Recursive_Offset  Recursive_Offset = (NDT_Recursive_Offset)va_arg( lib_args, NDT_Recursive_Offset);
			      
	    IMRT_MapPath  *MapPath_Ptr                      = Node_Ptr->Value;

	    Command_Name = "NDD_CMD_INFO_PRINT";

	    return( ND_DataStruct_Info_Print( Out, MapPath_Ptr->MapCmd_Struct_Ptr, NDD_RECURSIVE_MODE_PARENT_CHILD, --Recursive_Depth, ++Recursive_Offset));
	}
	case NDD_CMD_FIND_MAPPATH:
        {
            /*
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list               lib_args        = (va_list)va_arg( Args, va_list);
	      FILE                 *Out             = (FILE  *)va_arg( lib_args, FILE  *);
	      NDT_Recursive_Mode    Recursive_Mode  = (NDT_Recursive_Mode)va_arg( lib_args, NDT_Recursive_Mode);
	      NDT_Recursive_Depth   Recursive_Depth = (NDT_Recursive_Depth)va_arg( lib_args, NDT_Recursive_Depth);
	      va_list               user_args       = (va_list)va_arg( lib_args, va_list);
	      user_type             user_data       = (user_type)va_arg( user_args, user_type);
	      ... = (...)va_arg( user_args, ...);
	      void                 *Value_Ptr       = Node_Ptr->Value;
            */
            
            
	      NDT_Node             *Next_Node_Ptr   = (NDT_Node  *)va_arg( Args, NDT_Node  *);
	      va_list                 user_args       = (va_list)va_arg( Args, va_list);
	      FILE                   *Out             = (FILE  *)va_arg( user_args, FILE  *);
	      SDMT_CritereRecChemin  *Recherche       = (SDMT_CritereRecChemin *)va_arg( user_args, SDMT_CritereRecChemin *);

	      IMRT_MapPath    *Value_Ptr       = 	Node_Ptr->Value;
	      IMRT_Mode_Traverse  Mode_Normal_Erreur = IMRD_NORMALE_MODE;

        Command_Name = "NDD_CMD_FIND_MAPPATH";

		SDM_CompareCritereMapPath(TableCritere, SDMD_NB_CRITERE_CHEMIN,Recherche, Value_Ptr, &Valide);
                /*le chemin de mappin vrifie les critre de la demande
                  on va traverser la structure MapCmd qui contient toutes
                  les commandes pour le chemin de mapping slectionn
                */
                if(Valide == IMRS_OK)
                {
		   
		    IMRD_LM_LOG_TRACE_1( IMRD_LOG_LEVEL_VERBOSE_1, "Mappath match Id : <%d>", Value_Ptr->idMapPath);
		    		status = (IMRT_Status)ND_DataStruct_Traverse( Value_Ptr->MapCmd_Struct_Ptr, IMRD_SDMD_CMD_EXECUTE, stdout, NDD_RECURSIVE_MODE_PARENT,Recherche, &Mode_Normal_Erreur);
		    		if ((status != NDS_OK) || (Mode_Normal_Erreur != IMRD_NORMALE_MODE))
		    	    {
						IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Traverse() failed (%d) !\n", status);
						return(NDS_KO);
		    	    }

		    		return(NDS_NODE_FOUND);
                }
                return (NDS_OK);
        }

	case IMRD_SDMD_CMD_API_SQL_DUMP:
	{
	/*
		NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
		va_list     user_args     =     (va_list)va_arg( Args, va_list);
		user_type   user_data     =   (user_type)va_arg( user_args, user_type);
							  ... =         (...)va_arg( user_args, ...);

		void       *Value_Ptr     = Node_Ptr->Value;
	*/
		NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
		va_list          user_args     =     (va_list)va_arg( Args, va_list);
		FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

		IMRT_MapPath    *MapPath_Ptr  = Node_Ptr->Value;


		Command_Name = "IMRD_SDMD_CMD_API_SQL_DUMP";

		fprintf( Out, "INSERT INTO IMR_MAPPATH(MAP_PATH_ID, APPLI_IN_ID, APPLI_OUT_ID, FORMAT_IN_ID, FORMAT_OUT_ID) VALUES(%d, %d, %d, %d, %d);\n",
						MapPath_Ptr->idMapPath, MapPath_Ptr->Appl_Input_Ptr->Id, MapPath_Ptr->Appl_Output_Ptr->Id, MapPath_Ptr->Fmt_Input_Ptr->Id, MapPath_Ptr->Fmt_Output_Ptr->Id);
		
	    if( ( status = ND_DataStruct_Traverse( MapPath_Ptr->MapCmd_Struct_Ptr, IMRD_SDMD_CMD_API_SQL_DUMP, Out, MapPath_Ptr->idMapPath)) != NDS_OK)
		{
		    IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Traverse failed (%d)...\n",status);
			return(NDS_KO);
		}

		return( NDS_OK);
	}

	case IMRD_SDMD_CMD_API_XML_DUMP:
	{
	/*
		NDT_Node   *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
		va_list     user_args     =     (va_list)va_arg( Args, va_list);
		user_type   user_data     =   (user_type)va_arg( user_args, user_type);
							  ... =         (...)va_arg( user_args, ...);

		void       *Value_Ptr     = Node_Ptr->Value;
	*/
		NDT_Node        *Next_Node_Ptr = (NDT_Node  *)va_arg( Args, NDT_Node  *);
		va_list          user_args     =     (va_list)va_arg( Args, va_list);
		FILE            *Out           =     (FILE  *)va_arg( user_args, FILE  *);

		IMRT_MapPath    *MapPath_Ptr  = Node_Ptr->Value;


		Command_Name = "IMRD_SDMD_CMD_API_XML_DUMP";

		fprintf( Out, "\t<%s>\n", IMRD_SDMD_TAG_MAPPATH);

		fprintf( Out, "\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_INPUTAPPLI, MapPath_Ptr->Appl_Input_Ptr->Name, IMRD_SDMD_TAG_INPUTAPPLI);

		fprintf( Out, "\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_OUTPUTAPPLI, MapPath_Ptr->Appl_Output_Ptr->Name, IMRD_SDMD_TAG_OUTPUTAPPLI);

		fprintf( Out, "\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_INPUTFORMAT, MapPath_Ptr->Fmt_Input_Ptr->Name, IMRD_SDMD_TAG_INPUTFORMAT);

		fprintf( Out, "\t\t<%s>%s</%s>\n", 
					IMRD_SDMD_TAG_OUTPUTFORMAT, MapPath_Ptr->Fmt_Output_Ptr->Name, IMRD_SDMD_TAG_OUTPUTFORMAT);
		

	    if( ( status = ND_DataStruct_Traverse( MapPath_Ptr->MapCmd_Struct_Ptr, IMRD_SDMD_CMD_API_XML_DUMP, Out)) != NDS_OK)
		{
		    IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Traverse failed (%d)...\n",status);
			return(NDS_KO);
		}

		fprintf( Out, "\t</%s>\n", IMRD_SDMD_TAG_MAPPATH);

		return( NDS_OK);
	}

	default:
	{
            IMRD_LM_LOG_ERROR_1("called with an undefined command %d\n", Command);

            return( NDS_ERRAPI);
	}
    }

    return( NDS_OK);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status SDM_BufferInfo_Init(IMRT_SDM_Config  * Lib_Config_Ptr)
{
    IMRT_Status  status;

    if(Lib_Config_Ptr->Flag == IMRD_SDM_FLAG_XML)
    {
		status = SDM_XML_BufferInfo_Init(Lib_Config_Ptr->Lib_Path);
    }
    else
    {
#ifdef ORACLE_SUPPORT
		status = SDM_SQL_BufferInfo_Init();
#else
		status = IMRS_OK;
#endif /* ORACLE_SUPPORT */
    }

    return(status);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status SDM_Close_RootMapPath(void)
{
	IMRT_Status  status;
	NDT_Status   nd_status;

	status = IMRS_OK;

	if(IMRG_SDM_Base.RootMapPath != NULL)
	{
		if (IMRG_SDM_Base.RootMapPath->User_Ptr != NULL)
		{
			free(IMRG_SDM_Base.RootMapPath->User_Ptr);
		}

		if( ( nd_status = ND_DataStruct_Close(IMRG_SDM_Base.RootMapPath)) != NDS_OK)
		{
			IMRD_LM_LOG_ERROR_1( "RootMapPath ND_DataStruct_Close() failed (%d) !\n", nd_status);
			status = IMRS_KO;
		}
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status SDM_Close_RootAppl(void)
{
	IMRT_Status  status;
	NDT_Status   nd_status;

	status = IMRS_OK;

	if(IMRG_SDM_Base.RootAppl != NULL)
	{
		if (IMRG_SDM_Base.RootAppl->User_Ptr != NULL)
		{
			free(IMRG_SDM_Base.RootAppl->User_Ptr);
		}

		if( ( nd_status = ND_DataStruct_Close(IMRG_SDM_Base.RootAppl)) != NDS_OK)
		{
			IMRD_LM_LOG_ERROR_1("ND_DataStruct_Close() failed (%d) !\n", nd_status);
			status = IMRS_KO;
		}
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status SDM_Close_RootFmtAttr(void)
{
	IMRT_Status  status;
	NDT_Status   nd_status;

	status = IMRS_OK;

	if(IMRG_SDM_Base.RootFmtAttr != NULL)
	{
		if (IMRG_SDM_Base.RootFmtAttr->User_Ptr != NULL)
		{
			free(IMRG_SDM_Base.RootFmtAttr->User_Ptr);
		}

		if( ( nd_status = ND_DataStruct_Close(IMRG_SDM_Base.RootFmtAttr)) != NDS_OK)
		{
			IMRD_LM_LOG_ERROR_1("ND_DataStruct_Close() failed (%d) !\n", nd_status);
			status = IMRS_KO;
		}
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status SDM_Close_RootFmt(void)
{
	IMRT_Status  status;
	NDT_Status   nd_status;

	status = IMRS_OK;

	if(IMRG_SDM_Base.RootFmt != NULL)
	{
		if (IMRG_SDM_Base.RootFmt->User_Ptr != NULL)
		{
			free(IMRG_SDM_Base.RootFmt->User_Ptr);
		}

		if( ( nd_status = ND_DataStruct_Close(IMRG_SDM_Base.RootFmt)) != NDS_OK)
		{
			IMRD_LM_LOG_ERROR_1( "ND_DataStruct_Close() failed (%d) !\n", nd_status);
			status = IMRS_KO;
		}
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status SDM_BufferInfo_DInit(void)
{
	IMRT_Status  status, StatusMapPath, StatusAppl, StatusFmtAttr, StatusFmt;

	status = IMRS_OK;

	StatusMapPath = SDM_Close_RootMapPath();
	StatusAppl = SDM_Close_RootAppl();
	StatusFmtAttr = SDM_Close_RootFmtAttr();
	StatusFmt = SDM_Close_RootFmt();

	if((StatusMapPath == IMRS_KO)||(StatusAppl == IMRS_KO)||(StatusFmtAttr == IMRS_KO)||(StatusFmt == IMRS_KO))
	{
		status = IMRS_KO;
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_MapPath_Proceed( IMRT_Appl_Id  Appl_Id_Target, IMRT_Fmt_Id  Fmt_Id_Target, IMRT_Msg_Id  Msg_Id_Target,
				  IMRT_Appl_Id  ApplId_Src,     IMRT_Fmt_Id  Fmt_Id_Src,    IMRT_Msg_Id  Msg_Id_Src,
				  IMRT_SDMCB_Buffer_Map    *CCB_Buffer_Map_Ptr,
				  IMRT_SDMCB_Buffer_Copy   *CCB_Buffer_Copy_Ptr,
				  IMRT_SDMCB_Buffer_Ident  *CCB_Buffer_Ident_Ptr)

{
    SDMT_CritereRecChemin Recherche;
    NDT_Node *            node_ptr;
    IMRT_Status            status;
    IMRT_MapPath          mymappath;
  
    Recherche.Branche_id        = 0;
    Recherche.InputAppli =   ApplId_Src;
    Recherche.OutputAppli=   Appl_Id_Target;
    Recherche.InputFormat       = Fmt_Id_Src;
    Recherche.OutputFormat      = Fmt_Id_Target;
    Recherche.InputType =  Msg_Id_Src;
    Recherche.OutputType = Msg_Id_Target;
    Recherche.CallBackCommandeIdent = CCB_Buffer_Ident_Ptr;
    Recherche.CallBackBCommandeMap  = CCB_Buffer_Map_Ptr;
    Recherche.CallBackCommandeCopy  = CCB_Buffer_Copy_Ptr;
      
    status = (IMRT_Status)ND_DataStruct_Traverse( IMRG_SDM_Base.RootMapPath, NDD_CMD_FIND_MAPPATH, stdout,&Recherche);
    
    if(status != NDS_NODE_FOUND)
    {
		status = IMRS_KO;
    }
    else
    {
    	status  = IMRS_OK;
    }
    return(status);
}

IMRT_Status SDM_MsgIdent_Proceed( IMRT_Fmt_Id  Fmt_Id, IMRT_Msg_Id  *Msg_Id, IMRT_SDMCB_Ident_Field_Value  *CCB_Ident_Field_Value_Ptr, IMRT_SDMCB_Ident_Field_Exist *CCB_Ident_Field_Exist_Ptr, IMRT_SDMCB_Ident_Msg_Size *CCB_Ident_Msg_Size_Ptr)
{
/*IMRT_SDMCB_Field_Ident  *CCB_Field_Ident_Ptr*/

    IMRT_Status status;
    IMRT_Fmt   Fmt;
    IMRT_Fmt * Fmt2;
    NDT_Root    * FmtMsg_Ptr ;
    NDT_Node    * node_ptr;
    IMRT_SDM_IdentMessage Struct_Indent;
    char functionname [] = "IMR_IdentificationMessage";
    char DescErr[IMRD_SDMD_DESCERR_LEN];
  
    Struct_Indent.Ident_Msg_SizeFunc_Ptr = CCB_Ident_Msg_Size_Ptr;
    Struct_Indent.Ident_Field_ExistFunc_Ptr = CCB_Ident_Field_Exist_Ptr;
    Struct_Indent.Ident_Field_ValueFunc_Ptr = CCB_Ident_Field_Value_Ptr;

	Struct_Indent.Id = *Msg_Id;
	Struct_Indent.Mode = IMRD_SKIP_MODE;
	

    /*recherche de la liste des message en fonction du format*/
    Fmt.Id = Fmt_Id;
    if((status = (IMRT_Status)ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmt,
						  IMRD_SDMD_FMT_IDX_ID, &Fmt, NULL)) != NDS_OK)
    {
	snprintf(DescErr,sizeof(DescErr),SDMD_LIB_ERROR_8,Fmt.Id);
        status = IMRS_KO;
    }
    else
    {
	Fmt2 = (IMRT_Fmt *)node_ptr->Value;
	FmtMsg_Ptr = Fmt2->FmtMsg_Struct_Ptr;
	status = (IMRT_Status)ND_DataStruct_Traverse( FmtMsg_Ptr, IMRD_SDMD_CMD_EXECUTE, stdout, NDD_RECURSIVE_MODE_PARENT,&Struct_Indent);
	    
	if(status == (IMRT_Status)NDS_IDENT_OK)
	{
	    *Msg_Id = Struct_Indent.Id;
	    status = IMRS_OK;
	}
	else if((status == (IMRT_Status)NDS_KO))
	{
	    status = IMRS_KO;
	    snprintf(DescErr,sizeof(DescErr),SDMD_LIB_ERROR_9,Fmt.Name);
	}
	else
	{
	    *Msg_Id = IMRD_MSG_ID_UNKNOWN; 
	    status = IMRS_OK;
	}
    }

    return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_Fmt_Proceed( IMRT_SDMCB_Fmt_Add  *CCB_Fmt_Add_Ptr)
{

    IMRT_Status status;
    NDT_Status  nd_status;

	status = IMRS_OK;
    if( ( nd_status = ND_DataStruct_Traverse( IMRG_SDM_Base.RootFmt, IMRD_SDMD_CMD_EXECUTE, stdout, NDD_RECURSIVE_MODE_PARENT, CCB_Fmt_Add_Ptr)) != NDS_OK)
    {
	  IMRD_LM_LOG_ERROR_1("ND_DataStruct_Traverse() failed (%d) !\n", nd_status);
	  status = IMRS_KO;
    }

    return(status);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
void SDM_InitMapCmd(IMRT_MapCmd * mymapcmd)
{
 int i;
 mymapcmd->MapCmd_Id         = 0;
 mymapcmd->TypeCmd           = IMRD_MAPCMD_TYPE_UNKNOWN;
 mymapcmd->Fmt_Input_Ptr       = NULL;
 mymapcmd->FmtAttr_Input_Ptr = NULL;
 mymapcmd->Fmt_Output_Ptr      = NULL;
 mymapcmd->FmtAttr_Output_Ptr = NULL;
 mymapcmd->Branche_Id        = -1;
 mymapcmd->Buffer_Id_Input	     = -1;
 mymapcmd->Buffer_Id_Output	     = -1;
 mymapcmd->MsgMap_Ptr       = NULL;
 mymapcmd->Buffer_Id_Ident  = -1;
 mymapcmd->Clear_Flag         = 0;
 mymapcmd->Goto_Branche_Id  = -1;
 mymapcmd->Ident_Total = IMRD_TRUE;
 mymapcmd->Ident_First_Msg_Ptr = NULL;
 mymapcmd->JmpTbleNbElts = 0;
 mymapcmd->Jump_Tab = NULL;
 /*for( i =0 ; i<IMRD_JUMP_NB_MAX;i++)
 {
   mymapcmd->Jump_Tab[i].Fmt_Ptr       = NULL;
   mymapcmd->Jump_Tab[i].Msg_Ptr       = NULL;
   mymapcmd->Jump_Tab[i].Branche_Id = -1;
 } */

}


void SDM_InitMapPath(IMRT_MapPath * mymappath)
{
  mymappath->idMapPath    = 0;
  mymappath->Fmt_Input_Ptr  = NULL;
  mymappath->Fmt_Output_Ptr = NULL;
  mymappath->Appl_Input_Ptr   = NULL;
  mymappath->Appl_Output_Ptr  = NULL;
  mymappath->MapCmd_Struct_Ptr =NULL;
}

void SDM_InitFormat(IMRT_Fmt * myformat)
{
  myformat->Id= IMRD_FMT_ID_UNKNOWN;
  memset(myformat->Name,0,sizeof(myformat->Name));
}

void SDM_InitFmtAttr(IMRT_FmtAttr * myFmtAttr)
{
  myFmtAttr->Id = IMRD_FMTATTR_ID_UNKNOWN;
  strcpy(myFmtAttr->Name, IMRD_FMTATTR_NAME_UNKNOWN);
  memset(myFmtAttr->Value,'\0',sizeof(myFmtAttr->Value));
}

void SDM_InitFmtMsg(IMRT_FmtMsg * myFmtMsg)
{
  myFmtMsg->Msg_Ptr = NULL;
  myFmtMsg->Branche_Id = IMRD_BRANCHE_ID_UNKNOWN;
  myFmtMsg->FmtAttr_Ptr = NULL;
}


void SDM_InitAppl(IMRT_Appl * Appl_Ptr)
{
    Appl_Ptr->Id = IMRD_APPL_ID_UNKNOWN;
    memset(Appl_Ptr->Name,0,sizeof(Appl_Ptr->Name));
}
