/*----------------------------------------------------------------------------*/
/* File: buffer_info_mng.h 				         	      */
/*----------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _BUFFER_INFO_MNG_H_
#   define _BUFFER_INFO_MNG_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#   include <libstatic_data_mng.h>


/*----------------------------------------------------------------------------*/
/* Local definition                                                             */
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/* XML TAG                                                                    */
/*----------------------------------------------------------------------------*/
#define IMRD_SDMD_FMTATTR_STRUCT    "fmtattr_struct"
#define IMRD_SDMD_APPLI_STRUCT      "appl_struct"
#define IMRD_SDMD_FMT_STRUCT        "fmt_struct"
#define IMRD_SDMD_MAPPATH_STRUCT    "mappath_struct"

/* Nom des fichiers pour le chargement XML */
#define SDMD_FMTATTR_FILE           "sd_fmtattr_struct.xml"
#define SDMD_APPLI_FILE             "sd_appl_struct.xml"
#define SDMD_FORMAT_FILE            "sd_fmt_struct.xml"
#define SDMD_MAPPATH_FILE           "sd_mappath_struct.xml"



#define SDMD_CRI_IA 0 /*Critre input appli*/
#define SDMD_CRI_OA 1 /*Critre output appli*/
#define SDMD_CRI_IF 2 /*Critre input format*/
#define SDMD_CRI_OF 3 /*Critre output format*/
#define SDMD_CRI_IT 4 /*Critre input type*/
#define SDMD_CRI_OT 5 /*Critre ouput type*/

#define SDMD_NB_CRITERE_CHEMIN 4


typedef struct IMRT_Appl
{
	IMRT_Appl_Id   Id;
	IMRT_Appl_Name Name ;

} IMRT_Appl;

typedef struct IMRT_MapPath
{
	int      idMapPath;
	IMRT_Fmt   * Fmt_Input_Ptr;
	IMRT_Fmt   * Fmt_Output_Ptr;
	IMRT_Appl  * Appl_Input_Ptr;
	IMRT_Appl  * Appl_Output_Ptr;
	NDT_Root   * MapCmd_Struct_Ptr;
} IMRT_MapPath;


/*typedef struct SDMT_FmtMsg
{
	char name [IMRD_NAME_LEN];
	IMRT_Msg * msg;
 
} SDMT_FmtMsg;
*/


typedef struct SDMT_CritereRecChemin
{
	IMRT_Appl_Id   InputAppli;
	IMRT_Appl_Id   OutputAppli;
	IMRT_Fmt_Id    InputFormat;
	IMRT_Fmt_Id    OutputFormat;
	IMRT_Msg_Id    InputType;
	IMRT_Msg_Id    OutputType;
	int  Branche_id;
	IMRT_Error FataError;
	IMRT_SDMCB_Buffer_Ident * CallBackCommandeIdent;
	IMRT_SDMCB_Buffer_Map   * CallBackBCommandeMap;
	IMRT_SDMCB_Buffer_Copy  * CallBackCommandeCopy;

} SDMT_CritereRecChemin;

/********************************************************************/
/*       Les index du Manager SDM_Appl_Manager                      */
/********************************************************************/
#define IMRD_SDMD_APPL_STRUCT_IDX_NB                (short)2

static NDT_Index_Type  Appl_Struct_initial_idx_tab[IMRD_SDMD_APPL_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_LIST | NDD_INDEX_SUBTYPE_SORTED),
      (NDD_INDEX_STATUS_CLOSED)
};

static NDT_Index_Type  Appl_Struct_final_idx_tab[IMRD_SDMD_APPL_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED),
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED)
};

#define IMRD_SDMD_APPL_IDX_ID                (short)0
#define IMRD_SDMD_APPL_IDX_NAME              (short)1

/********************************************************************/
/*       Les index du Manager SDM_FmtAttr_Manager                   */
/********************************************************************/
#define IMRD_SDMD_FMTATTR_STRUCT_IDX_NB                (short)2

static NDT_Index_Type  FmtAttr_Struct_initial_idx_tab[IMRD_SDMD_FMTATTR_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_LIST | NDD_INDEX_SUBTYPE_SORTED),
      (NDD_INDEX_STATUS_CLOSED)
};

static NDT_Index_Type  FmtAttr_Struct_final_idx_tab[IMRD_SDMD_FMTATTR_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED),
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED)
};

#define IMRD_SDMD_FMTATTR_IDX_ID                (short)0
#define IMRD_SDMD_FMTATTR_IDX_NAME              (short)1


/********************************************************************/
/*       Les index du Manager SDM_Fmt_Manager                       */
/********************************************************************/
#define IMRD_SDMD_FMT_STRUCT_IDX_NB                (short)2

static NDT_Index_Type  Fmt_Struct_initial_idx_tab[IMRD_SDMD_FMT_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_LIST | NDD_INDEX_SUBTYPE_SORTED),
      (NDD_INDEX_STATUS_CLOSED)
};

static NDT_Index_Type  Fmt_Struct_final_idx_tab[IMRD_SDMD_FMT_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED),
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED)
};

#define IMRD_SDMD_FMT_IDX_ID                (short)0
#define IMRD_SDMD_FMT_IDX_NAME              (short)1


/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _BUFFER_INFO_MNG_C_
IMRT_Status  SDM_DataStruct_Finalize(NDT_Root  *, NDT_Index_Type *, short );
NDT_Status  SDM_Appl_Manager(    NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_FmtAttr_Manager(    NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_FmtMsg_Manager(  NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_Fmt_Manager(     NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_MapCmd_Manager(  NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_MapPath_Manager( NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
IMRT_Status  SDM_MapPath_Proceed( IMRT_Appl_Id  Appl_Id_Target, IMRT_Fmt_Id  Fmt_Id_Target, IMRT_Msg_Id  Msg_Id_Target,
				  IMRT_Appl_Id  ApplId_Src,     IMRT_Fmt_Id  Fmt_Id_Src,    IMRT_Msg_Id  Msg_Id_Src,
				  IMRT_SDMCB_Buffer_Map    *CCB_Buffer_Map_Ptr,
				  IMRT_SDMCB_Buffer_Copy   *CCB_Buffer_Copy_Ptr,
				  IMRT_SDMCB_Buffer_Ident  *CCB_Buffer_Ident_Ptr);
IMRT_Status  SDM_Fmt_Proceed( IMRT_SDMCB_Fmt_Add  *CCB_Fmt_Add_Ptr);
void SDM_CompareCritereMapPath(IMRT_Status CitereTable[],
			       const int NbCritere,
			       SDMT_CritereRecChemin * Critere,
			       IMRT_MapPath * myMapPath,
			       IMRT_Status  *Valide );
void SDM_IniTableCritere(IMRT_Status Table[],const int NbElement);
void SDM_InitMapCmd(IMRT_MapCmd * mymapcmd);
void SDM_InitMapPath(IMRT_MapPath * mymappath);
void SDM_InitFormat(IMRT_Fmt * myformat);
void SDM_InitFmtAttr(IMRT_FmtAttr * myFmtAttr);
void SDM_InitFmtMsg(IMRT_FmtMsg * myFmtMsg);
void SDM_InitAppl(IMRT_Appl * Appl_Ptr); 
IMRT_Status SDM_BufferInfo_Init(IMRT_SDM_Config  * Lib_Config_Ptr);
IMRT_Status SDM_Close_RootMapPath(void);
IMRT_Status SDM_Close_RootAppl(void);
IMRT_Status SDM_Close_RootFmtAttr(void);
IMRT_Status SDM_Close_RootFmt(void);
IMRT_Status SDM_BufferInfo_DInit(void);

#   else

extern IMRT_Status  SDM_DataStruct_Finalize(NDT_Root  *ds_Ptr, NDT_Index_Type *Index_Id_Ptr, short hMaxEntries);
extern NDT_Status  SDM_Appl_Manager(    NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_FmtAttr_Manager(    NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_FmtMsg_Manager(  NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_Fmt_Manager(     NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_MapCmd_Manager(  NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_MapPath_Manager( NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern IMRT_Status SDM_MapPath_Proceed( IMRT_Appl_Id  Appl_Id_Target, IMRT_Fmt_Id  Fmt_Id_Target, IMRT_Msg_Id  Msg_Id_Target,
					IMRT_Appl_Id  ApplId_Src,     IMRT_Fmt_Id  Fmt_Id_Src,    IMRT_Msg_Id  Msg_Id_Src,
					IMRT_SDMCB_Buffer_Map    *CCB_Buffer_Map_Ptr,
					IMRT_SDMCB_Buffer_Copy   *CCB_Buffer_Copy_Ptr,
					IMRT_SDMCB_Buffer_Ident  *CCB_Buffer_Ident_Ptr);
extern IMRT_Status  SDM_Fmt_Proceed( IMRT_SDMCB_Fmt_Add  *CCB_Fmt_Add_Ptr);
extern IMRT_Status SDM_BufferInfo_Init(IMRT_SDM_Config  * Lib_Config_Ptr);
extern IMRT_Status SDM_Close_RootMapPath(void);
extern IMRT_Status SDM_Close_RootAppl(void);
extern IMRT_Status SDM_Close_RootFmtAttr(void);
extern IMRT_Status SDM_Close_RootFmt(void);
extern IMRT_Status SDM_BufferInfo_DInit(void);
#   endif





/*----------------------------------------------------------------------------*/
/* Local Includes                                                             */
/*----------------------------------------------------------------------------*/

#   ifdef _BUFFER_INFO_MNG_C_

#       include "buffer_info_xml.h"
#       include "buffer_info_sql.h"

#   endif





/*----------------------------------------------------------------------------*/

#endif
