/*----------------------------------------------------------------------------*/
/* File: buffer_info_sql.h 				         	      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _BUFFER_INFO_SQL_H_
#   define _BUFFER_INFO_SQL_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#   include <libstatic_data_mng.h>





/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _BUFFER_INFO_SQL_PC_

IMRT_Status SDM_SQL_BufferInfo_Init();
IMRT_Status SDM_SQL_Load_FmtAttr(NDT_Root **myRootFmtAttr_Ptr_Ptr);
IMRT_Status SDM_SQL_Load_Appli(NDT_Root **myRootAppli_Ptr_Ptr);
IMRT_Status SDM_SQL_Load_Format(NDT_Root  **myRootFormat_Ptr_Ptr);
IMRT_Status SDM_SQL_LoadFmtMsg(IMRT_Fmt  *myFormat_Ptr);
IMRT_Status SDM_SQL_Load_MapPath(NDT_Root **myRootMapPath_Ptr_Ptr);
IMRT_Status SDM_SQL_LoadMapCmd(IMRT_MapPath  *myMapPath_Ptr);
IMRT_Status SDM_SQL_Load_JumpTable(IMRT_Jump  **JumpTable_Ptr_Ptr, int *JumpTableNbElt_Ptr, IMRT_MapCmd_Id IdMapCmd);
IMRT_Status SDM_SQL_Dump_FmtAttr_Header(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_FmtAttr_Body(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_FmtAttr_Footer(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_FmtAttr(void);
IMRT_Status SDM_SQL_Dump_Appli_Header(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_Appli_Body(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_Appli_Footer(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_Appli(void);
IMRT_Status SDM_SQL_Dump_Format_Header(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_Format_Body(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_Format_Footer(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_Format(void);
IMRT_Status SDM_SQL_Dump_MapPath_Header(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_MapPath_Body(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_MapPath_Footer(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_MapPath(void);
IMRT_Status SDM_SQL_BufferInfo_Dump(void);

#   else

extern IMRT_Status SDM_SQL_BufferInfo_Init();
extern IMRT_Status SDM_SQL_Load_FmtAttr(NDT_Root **myRootFmtAttr_Ptr_Ptr);
extern IMRT_Status SDM_SQL_Load_Appli(NDT_Root **myRootAppli_Ptr_Ptr);
extern IMRT_Status SDM_SQL_Load_Format(NDT_Root  **myRootFormat_Ptr_Ptr);
extern IMRT_Status SDM_SQL_LoadFmtMsg(IMRT_Fmt  *myFormat_Ptr);
extern IMRT_Status SDM_SQL_Load_MapPath(NDT_Root **myRootMapPath_Ptr_Ptr);
extern IMRT_Status SDM_SQL_LoadMapCmd(IMRT_MapPath  *myMapPath_Ptr);
extern IMRT_Status SDM_SQL_Load_JumpTable(IMRT_Jump  **JumpTable_Ptr_Ptr, int *JumpTableNbElt_Ptr, IMRT_MapCmd_Id IdMapCmd);
extern IMRT_Status SDM_SQL_Dump_FmtAttr_Header(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_FmtAttr_Body(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_FmtAttr_Footer(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_FmtAttr(void);
extern IMRT_Status SDM_SQL_Dump_Appli_Header(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_Appli_Body(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_Appli_Footer(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_Appli(void);
extern IMRT_Status SDM_SQL_Dump_Format_Header(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_Format_Body(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_Format_Footer(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_Format(void);
extern IMRT_Status SDM_SQL_Dump_MapPath_Header(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_MapPath_Body(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_MapPath_Footer(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_MapPath(void);
extern IMRT_Status SDM_SQL_BufferInfo_Dump(void);

#   endif





/*----------------------------------------------------------------------------*/

#endif
