/*----------------------------------------------------------------------------*/
/* File: buffer_info_xml.c   		         		  	      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#define _LIBSTATIC_DATA_MNG_
#define _BUFFER_INFO_XML_C_

#include "buffer_info_xml.h" 



IMRT_Status SDM_XML_BufferInfo_Init(IMRT_Path    Lib_Path)
{
	SDMT_BufferInfo_Contexte Buffer_Info_Ctx;
	IMRT_Status  status, StatusTmp;
    char	     Xml_File_Name[255];


    IMRD_LM_LOG_TRACE_0( IMRD_LOG_LEVEL_VERBOSE_0, "Loading FmtAttr...");

    Buffer_Info_Ctx.flagerror = 0;
    Buffer_Info_Ctx.CptFmtAttr  = IMRD_FMTATTR_ID_UNKNOWN;             
	memset(Buffer_Info_Ctx.PathArray,0,sizeof(Buffer_Info_Ctx.PathArray));
	Buffer_Info_Ctx.PresentLevelTag = IMRD_SDMD_MIN_LEVEL_TAG;
    memset(Xml_File_Name,0,sizeof(Xml_File_Name));
	strcpy(Xml_File_Name, Lib_Path);
	strcat(Xml_File_Name, "/");
	strcat(Xml_File_Name, SDMD_FMTATTR_FILE);

    status = SDM_XML_Load_FmtAttr(Xml_File_Name, &(Buffer_Info_Ctx));

    if(status == IMRS_OK)
    {
	IMRG_SDM_Base.RootFmtAttr = Buffer_Info_Ctx.RootFmtAttr;

	IMRD_LM_LOG_INFO_1( "FmtAtt loaded: (%d)", IMRG_SDM_Base.RootFmtAttr->Index_Tab[NDD_INDEX_PRIMARY].Node_Number);

	IMRD_LM_LOG_TRACE_0( IMRD_LOG_LEVEL_VERBOSE_0, "Loading Fmt...");

	    Buffer_Info_Ctx.flagerror = 0;
	    Buffer_Info_Ctx.CptFmt  = IMRD_FMT_ID_UNKNOWN;             
		memset(Buffer_Info_Ctx.PathArray,0,sizeof(Buffer_Info_Ctx.PathArray));
		Buffer_Info_Ctx.PresentLevelTag = IMRD_SDMD_MIN_LEVEL_TAG;
	    memset(Xml_File_Name,0,sizeof(Xml_File_Name));
		strcpy(Xml_File_Name, Lib_Path);
		strcat(Xml_File_Name, "/");
		strcat(Xml_File_Name, SDMD_FORMAT_FILE);
	
	    status = SDM_XML_Load_Format(Xml_File_Name, &(Buffer_Info_Ctx));
	      
	    if(status == IMRS_OK)
	    {
		IMRG_SDM_Base.RootFmt = Buffer_Info_Ctx.RootFormat;

		IMRD_LM_LOG_INFO_1( "Fmt loaded: (%d)", IMRG_SDM_Base.RootFmt->Index_Tab[NDD_INDEX_PRIMARY].Node_Number);
	
		IMRD_LM_LOG_TRACE_0( IMRD_LOG_LEVEL_VERBOSE_0, "Loading Appl...");

			memset(Buffer_Info_Ctx.PathArray,0,sizeof(Buffer_Info_Ctx.PathArray));
			Buffer_Info_Ctx.PresentLevelTag = IMRD_SDMD_MIN_LEVEL_TAG;
		    Buffer_Info_Ctx.CptAppl = IMRD_APPL_ID_UNKNOWN;
		    memset(Xml_File_Name,0,sizeof(Xml_File_Name));
			strcpy(Xml_File_Name, Lib_Path);
			strcat(Xml_File_Name, "/");
			strcat(Xml_File_Name, SDMD_APPLI_FILE);
	
			status = SDM_XML_Load_Appli(Xml_File_Name, &(Buffer_Info_Ctx));
			if(status == IMRS_OK)
			{
			    IMRG_SDM_Base.RootAppl = Buffer_Info_Ctx.RootAppli;

			    IMRD_LM_LOG_INFO_1( "Appl loaded: (%d)", IMRG_SDM_Base.RootAppl->Index_Tab[NDD_INDEX_PRIMARY].Node_Number);
	
			    IMRD_LM_LOG_TRACE_0( IMRD_LOG_LEVEL_VERBOSE_0, "Loading MapPath...");

			    Buffer_Info_Ctx.NbMapPath = 0 ;
			    Buffer_Info_Ctx.NbMapCmd  = 0 ;
				memset(Buffer_Info_Ctx.PathArray,0,sizeof(Buffer_Info_Ctx.PathArray));
				Buffer_Info_Ctx.PresentLevelTag = IMRD_SDMD_MIN_LEVEL_TAG;
			    memset(Xml_File_Name,0,sizeof(Xml_File_Name));
				strcpy(Xml_File_Name, Lib_Path);
				strcat(Xml_File_Name, "/");
				strcat(Xml_File_Name, SDMD_MAPPATH_FILE);
			    status = SDM_XML_Load_MapPath(Xml_File_Name, &(Buffer_Info_Ctx));
			    if(status == IMRS_OK)
			    {
				IMRG_SDM_Base.RootMapPath = Buffer_Info_Ctx.RootMapPath;
				
				IMRD_LM_LOG_INFO_1( "MapPath loaded: (%d)", IMRG_SDM_Base.RootMapPath->Index_Tab[NDD_INDEX_PRIMARY].Node_Number);
			    }
			    else
			    {
				IMRD_LM_LOG_ERROR_0( "Can't load MapPath !");

					StatusTmp = SDM_Close_RootFmtAttr();
					StatusTmp = SDM_Close_RootFmt();
					StatusTmp = SDM_Close_RootAppl();
			    }
			    
			}
			else
			{
			    IMRD_LM_LOG_ERROR_0( "Can't load Appl !");

				StatusTmp = SDM_Close_RootFmtAttr();
			    StatusTmp = SDM_Close_RootFmt();
			}
	    }
	    else
	    {
		StatusTmp = SDM_Close_RootFmtAttr();

		IMRD_LM_LOG_ERROR_0( "Can't load Fmt !");
	    }
    }
    else
    {
		IMRD_LM_LOG_ERROR_0( "Can't load FmtAttr !");
    }

    return(status);

}



static IMRT_Status error(SDMT_BufferInfo_Contexte *ctx , const char *msg, ...)
{
    xmlParserCtxt * SaxCtx;
  
    SaxCtx = ctx->SaxCtxHdl;
  
    IMRD_LM_LOG_ERROR_1( "CallBack error: <%s> !",msg);

    SaxCtx->sax  = &ErrorSAXHandlerStruct;
    ctx->flagerror = 1;
    ctx->FataError.errorCode = SDMD_XML_CODE_ERROR_1;
    strcpy(ctx->FataError.libError,msg) ;
    
}

IMRT_Status  startElementNsAppli( SDMT_BufferInfo_Contexte * ctx , 
			  const xmlChar *localname,
			  const xmlChar *prefix,
			  const xmlChar *URI,
			  int nb_namespaces,
			  const xmlChar **namespaces,
			  int nb_attributes,
			  int nb_defaulted,
			  const xmlChar **attributes)
{
    NDT_Status  nd_status;
    const char   functionname [] = "startElementNsAppli";
    char         DescErr [IMRD_SDMD_DESCERR_LEN]; 
  
    if(strcmp((const char*)localname, IMRD_SDMD_TAG_APPLI) == 0)
    {
		/*cration d'un nouvelle objet appli*/
		if( ( nd_status = ND_Value_Alloc( ctx->RootAppli, (void  **)&(ctx->CurrentAppli)) != NDS_OK))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_APPLI);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
		}
    }
}


IMRT_Status startElementNsFmtAttr( SDMT_BufferInfo_Contexte * ctx , 
			const xmlChar *localname,
			const xmlChar *prefix,
			const xmlChar *URI,
			int nb_namespaces,
			const xmlChar **namespaces,
			int nb_attributes,
			int nb_defaulted,
			const xmlChar **attributes)
{
    NDT_Status   nd_status;
    const char   functionname [] = "startElementNsFmtAttr";
    char         DescErr [IMRD_SDMD_DESCERR_LEN]; 
  
    if(strcmp((const char*)localname, IMRD_SDMD_TAG_FMTATTR) == 0)
    {
		/*cration d'un nouvelle objet FmtAttr*/
		if( ( nd_status = ND_Value_Alloc( ctx->RootFmtAttr, (void  **)&(ctx->CurrentFmtAttr)) != NDS_OK))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_FMTATTR);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
		}
    }

}


IMRT_Status startElementNsFmt( SDMT_BufferInfo_Contexte * ctx , 
			const xmlChar *localname,
			const xmlChar *prefix,
			const xmlChar *URI,
			int nb_namespaces,
			const xmlChar **namespaces,
			int nb_attributes,
			int nb_defaulted,
			const xmlChar **attributes)
{
    NDT_Status   nd_status;
    const char   functionname [] = "startElementNsFmt";
    char         DescErr [IMRD_SDMD_DESCERR_LEN]; 
    
    
    if(strcmp((const char*)localname,IMRD_SDMD_TAG_FORMAT) == 0)
    {
		/*cration d'un nouvel objet format*/
		if(( nd_status = ND_Value_Alloc( ctx->RootFormat, (void  **)&(ctx->CurrentFormat)) != NDS_OK))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_FORMAT);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
		}
	    else
		{
			ctx->PresentLevelTag = ctx->PresentLevelTag + 1;
			strcpy(ctx->PathArray[ctx->PresentLevelTag], (char*)localname);
	    }
    }
    else if (strcmp((const char*)localname,IMRD_SDMD_TAG_FMTMSG) == 0)
    {
		/*creation d'un nouvel objet FmtMsg*/
		if( ( nd_status = ND_Value_Alloc( ctx->CurrentFormat->FmtMsg_Struct_Ptr, (void  **)&(ctx->CurrentFmtMsg)) != NDS_OK))
		{
			snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_3, IMRD_SDMD_TAG_FMTMSG);
			SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname , DescErr, SDMD_XML_CODE_ERROR_3 );
		}
		ctx->PresentLevelTag = ctx->PresentLevelTag + 1;
		strcpy(ctx->PathArray[ctx->PresentLevelTag], (char*)localname);
    }
  
}

IMRT_Status startElementNsMapPath( SDMT_BufferInfo_Contexte * ctx , 
			    const xmlChar *localname,
			    const xmlChar *prefix,
			    const xmlChar *URI,
			    int nb_namespaces,
			    const xmlChar **namespaces,
			    int nb_attributes,
			    int nb_defaulted,
			    const xmlChar **attributes)
{
    NDT_Status         nd_status;
    const char         functionname [] = "startElementNsMapPath";
    char               DescErr [IMRD_SDMD_DESCERR_LEN]; 
    IMRT_Jump		*jump_ptr;
 
   if(strcmp((const char *)localname, IMRD_SDMD_TAG_MAPPATH) == 0)
   {
		/*creation d'un nouvel objet MapPath*/
		if( ( nd_status = ND_Value_Alloc(ctx->RootMapPath,(void  **)&(ctx->CurrentMapPath)) != NDS_OK))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_3, IMRD_SDMD_TAG_MAPPATH);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname ,DescErr, SDMD_XML_CODE_ERROR_3);
		}
		ctx->PresentLevelTag = ctx->PresentLevelTag + 1;
		strcpy(ctx->PathArray[ctx->PresentLevelTag], (char*)localname);
	}
   else if (strcmp((const char *)localname, IMRD_SDMD_TAG_MAPCMD) == 0)
   {
		/*creation d'un nouvel objet MapCmd*/
		if( ( nd_status = ND_Value_Alloc( ctx->CurrentMapPath->MapCmd_Struct_Ptr, (void  **)&(ctx->CurrentMapCmd)) != NDS_OK))
		{
			snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_3, IMRD_SDMD_TAG_MAPCMD);
			SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname , DescErr, SDMD_XML_CODE_ERROR_3 );
		}
		ctx->PresentLevelTag = ctx->PresentLevelTag + 1;
		strcpy(ctx->PathArray[ctx->PresentLevelTag], (char*)localname);
	}
   else if ((strcmp((const char *)localname, IMRD_SDMD_TAG_MAPPER)     == 0) ||
            (strcmp((const char *)localname, IMRD_SDMD_TAG_COPIE)      == 0)
           )
   {
		ctx->PresentLevelTag = ctx->PresentLevelTag + 1;
		strcpy(ctx->PathArray[ctx->PresentLevelTag], (char*)localname);
	}
    else if(strcmp((const char *)localname, IMRD_SDMD_TAG_IDENTIFIER) == 0)
    {
		ctx->PresentLevelTag = ctx->PresentLevelTag + 1;
		strcpy(ctx->PathArray[ctx->PresentLevelTag], (char*)localname);
		ctx->IdxJpTble = 0;
	}
    else if(strcmp((const char*)localname,IMRD_SDMD_TAG_GO_TO)== 0)
    {
		ctx->PresentLevelTag = ctx->PresentLevelTag + 1;
		strcpy(ctx->PathArray[ctx->PresentLevelTag], (char*)localname);
		
		if (ctx->PresentLevelTag == IMRD_SDMD_LEVEL_TAG_3)
		{
		  	jump_ptr = (IMRT_Jump *)realloc((void *)ctx->CurrentMapCmd->Jump_Tab , 
										(size_t)((ctx->CurrentMapCmd->JmpTbleNbElts + 1) * sizeof(IMRT_Jump)));
		  	if (jump_ptr == NULL)
		  	{
			    snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_3, "Jump Table");
			    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname , DescErr, SDMD_XML_CODE_ERROR_3);  	  		
		  	}
		  	else
		  	{	
		  	    ctx->CurrentMapCmd->Jump_Tab = jump_ptr;
		  	    ctx->CurrentMapCmd->JmpTbleNbElts++;
		  	}
		}
    }

}



IMRT_Status endElementNsAppli( SDMT_BufferInfo_Contexte * ctx, 
			const xmlChar *localname,
			const xmlChar *prefix,
			const xmlChar *URI)
{
    NDT_Status        nd_status;
    IMRT_Status       status_tmp;
    const char        fonctionname [] ="endElementNsAppli";
    char              DescErr[IMRD_SDMD_DESCERR_LEN];
  
    if(strcmp((const char*)localname, IMRD_SDMD_TAG_APPLI) == 0)
    {
		/*insertion de l'appli courante*/
		/*insertion du format*/
	    ctx->CurrentAppli->Id =  ctx->CptAppl;
		if( ( nd_status = ND_DataStruct_Value_Add( ctx->RootAppli, (void  *)(ctx->CurrentAppli))) != NDS_OK)
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_3, IMRD_SDMD_TAG_APPLI);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_3 );
		}
	    ctx->CptAppl ++;
    }
    else if(strcmp((const char*)localname, IMRD_SDMD_TAG_NAME) == 0)
    {
		strcpy(ctx->CurrentAppli->Name, ctx->value);
    }
    else if (strcmp((const char *)localname, IMRD_SDMD_TAG_VERSION) == 0)
    {
		IMRD_LM_LOG_INFO_1( "[Appl]: [%s]", ctx->value);
		status_tmp = SDM_Set_Struct_Version((IMRT_Data_Version *)ctx->RootAppli->User_Ptr, (char *)ctx->value);
    }
}


IMRT_Status endElementNsFmtAttr( SDMT_BufferInfo_Contexte * ctx, 
			const xmlChar *localname,
			const xmlChar *prefix,
			const xmlChar *URI)
{
    NDT_Status        nd_status;
    IMRT_Status       status, status_tmp;
    const char        fonctionname [] ="endElementNsFmtAttr";
    char              DescErr[IMRD_SDMD_DESCERR_LEN];
  
    if(strcmp((const char*)localname, IMRD_SDMD_TAG_FMTATTR) == 0)
    {
	    ctx->CurrentFmtAttr->Id =  ctx->CptFmtAttr;
		if( ( nd_status = ND_DataStruct_Value_Add( ctx->RootFmtAttr, (void  *)(ctx->CurrentFmtAttr))) != NDS_OK)
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_3, IMRD_SDMD_TAG_FMTATTR);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_3 );
		}
	    ctx->CptFmtAttr ++;
    }
    else if(strcmp((const char*)localname, IMRD_SDMD_TAG_NAME) == 0)
    {
		strcpy(ctx->CurrentFmtAttr->Name, ctx->value);
    }
    else if(strcmp((const char*)localname, IMRD_SDMD_TAG_VALUE) == 0)
    {
		memset(ctx->CurrentFmtAttr->Value,'\0', IMRD_FMTATTR_VALUE_SIZE);
		status = SDM_ConvertAttribute(ctx->value, ctx->CurrentFmtAttr->Value);
    }
    else if (strcmp((const char *)localname, IMRD_SDMD_TAG_VERSION) == 0)
    {
		IMRD_LM_LOG_INFO_1( "[FmtAtt]: [%s]", ctx->value);
		status_tmp = SDM_Set_Struct_Version((IMRT_Data_Version *)ctx->RootFmtAttr->User_Ptr, (char *)ctx->value);
    }
}


IMRT_Status endElementNsMapPath( SDMT_BufferInfo_Contexte * ctx, 
			  const xmlChar *localname,
			  const xmlChar *prefix,
			  const xmlChar *URI)
{
    NDT_Node *      node_ptr;
    NDT_Status      nd_status;
    IMRT_Status     status, status_tmp;
    IMRT_MsgMap     msgmap;
    IMRT_Appl       appli;
    IMRT_Fmt        fmt;
    IMRT_Msg        msg;
    IMRT_FmtAttr  FmtAttr;
    char fonctionname [] = "endElementNsMapPath";
    char DescErr[IMRD_SDMD_DESCERR_LEN];


  if (strcmp((const char *)localname, IMRD_SDMD_TAG_FORMAT) == 0)
  {

	  strcpy(fmt.Name, ctx->value);
	  if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmt,
					 IMRD_SDMD_FMT_IDX_NAME, &fmt, NULL)) != NDS_OK)||
			(node_ptr == NULL))
	  {
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_FORMAT, fmt.Name );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
	  }
	  else
 	  {
	    ctx->CurrentMapCmd->Jump_Tab[ctx->IdxJpTble].Fmt_Ptr = node_ptr->Value;
	  }	
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_BRANCHE_ID) == 0)
  {
  	switch(ctx->PresentLevelTag)
  	{
  	  case IMRD_SDMD_LEVEL_TAG_1:  /* IMRD_SDMD_TAG_MAPCMD */
  	  {
  	  	ctx->CurrentMapCmd->Branche_Id = atoi(ctx->value);
  		break;	
      }

  	  case IMRD_SDMD_LEVEL_TAG_2:   /* Command go_to */
  	  {
  	  	ctx->CurrentMapCmd->Goto_Branche_Id = atoi(ctx->value);
  		break;	
      }

  	  case IMRD_SDMD_LEVEL_TAG_3:   /* Jump Table */
  	  {
	  	ctx->CurrentMapCmd->Jump_Tab[ctx->IdxJpTble].Branche_Id = atoi(ctx->value);
  		break;	
      }

  	  default:
  	  {
        snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_10, SDMD_MAPPATH_FILE);
        SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_10);
  	  }
    } /* end switch */
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_TYPE) == 0)
  {
  	switch(ctx->PresentLevelTag)
  	{
  	  case IMRD_SDMD_LEVEL_TAG_2:
  	  {
		strcpy(msg.Name, ctx->value);
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootMsg,
						 IMRD_SDMD_MSG_IDX_NAME, &msg, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, msg.Name );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentMapCmd->Ident_First_Msg_Ptr = node_ptr->Value;
		}
  		break;	
      }

  	  case IMRD_SDMD_LEVEL_TAG_3:
  	  {
		strcpy(msg.Name, ctx->value);
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootMsg,
						 IMRD_SDMD_MSG_IDX_NAME, &msg, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, msg.Name );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentMapCmd->Jump_Tab[ctx->IdxJpTble].Msg_Ptr = node_ptr->Value;
		}
  		break;	
      }

  	  default:
  	  {
        snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_10, SDMD_MAPPATH_FILE);
        SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_10);
  	  }
    } /* end switch */
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_INPUTFORMAT) == 0)
  {
	strcpy(fmt.Name, ctx->value);
	if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmt,
					 IMRD_SDMD_FMT_IDX_NAME, &fmt, NULL)) != NDS_OK)||
		(node_ptr == NULL))
	{
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_INPUTFORMAT, fmt.Name );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
	}
	else
	{
	  	switch(ctx->PresentLevelTag)
	  	{
	  	  case IMRD_SDMD_LEVEL_TAG_2:
	  	  {
			ctx->CurrentMapCmd->Fmt_Input_Ptr = node_ptr->Value;
	  		break;	
	      }
	
	  	  case IMRD_SDMD_LEVEL_TAG_0:
	  	  {
	  	  	ctx->CurrentMapPath->Fmt_Input_Ptr = node_ptr->Value;
	  		break;	
	      }
	
	  	  default:
	  	  {
	        snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_10, SDMD_MAPPATH_FILE);
	        SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_10);
	  	  }
	    } /* end switch */
	}
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_INPUTFORMAT_ATTR) == 0)
  {
  	switch(ctx->PresentLevelTag)
  	{
  	  case IMRD_SDMD_LEVEL_TAG_2:
  	  {

	    strcpy(FmtAttr.Name, ctx->value);
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmtAttr,
						 IMRD_SDMD_FMTATTR_IDX_NAME, &FmtAttr, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, FmtAttr.Name );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentMapCmd->FmtAttr_Input_Ptr = node_ptr->Value;
		}
        
  		break;	
      }

  	  default:
  	  {
        snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_10, SDMD_MAPPATH_FILE);
        SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_10);
  	  }
    } /* end switch */
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_OUTPUTFORMAT) == 0)
  {
	strcpy(fmt.Name, ctx->value);
	if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmt,
					 IMRD_SDMD_FMT_IDX_NAME, &fmt, NULL)) != NDS_OK)||
		(node_ptr == NULL))
	{
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_OUTPUTFORMAT, fmt.Name );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
	}
	else
	{
	  	switch(ctx->PresentLevelTag)
	  	{
	  	  case IMRD_SDMD_LEVEL_TAG_2:
	  	  {
			ctx->CurrentMapCmd->Fmt_Output_Ptr = node_ptr->Value;
	  		break;	
	      }
	
	  	  case IMRD_SDMD_LEVEL_TAG_0:
	  	  {
	  	  	ctx->CurrentMapPath->Fmt_Output_Ptr = node_ptr->Value;
	  		break;	
	      }
	
	  	  default:
	  	  {
	        snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_10, SDMD_MAPPATH_FILE);
	        SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_10);
	  	  }
	    } /* end switch */
	}
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_OUTPUTFORMAT_ATTR) == 0)
  {
  	switch(ctx->PresentLevelTag)
  	{
  	  case IMRD_SDMD_LEVEL_TAG_2:
  	  {
	    strcpy(FmtAttr.Name, ctx->value);
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmtAttr,
						 IMRD_SDMD_FMTATTR_IDX_NAME, &FmtAttr, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, FmtAttr.Name );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentMapCmd->FmtAttr_Output_Ptr = node_ptr->Value;
		}
  		break;	
      }

  	  default:
  	  {
        snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_10, SDMD_MAPPATH_FILE);
        SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_10);
  	  }
    }  /* end switch */
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_INPUTBUFFER) == 0)
  {
  	ctx->CurrentMapCmd->Buffer_Id_Input = atoi(ctx->value);
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_OUTPUTBUFFER) == 0)
  {
  	ctx->CurrentMapCmd->Buffer_Id_Output = atoi(ctx->value);
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_NUMBUFFER) == 0)
  {
  	ctx->CurrentMapCmd->Buffer_Id_Ident = atoi(ctx->value);
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_INPUTAPPLI) == 0)
  {
	strcpy(appli.Name, ctx->value);
	if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootAppl,
					 IMRD_SDMD_APPL_IDX_NAME, &appli, NULL)) != NDS_OK)||
		(node_ptr == NULL))
	{
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_INPUTAPPLI, appli.Name );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
	}
	else
	{
	    ctx->CurrentMapPath->Appl_Input_Ptr = node_ptr->Value;
	}
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_OUTPUTAPPLI) == 0)
  {
	strcpy(appli.Name, ctx->value);
	if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootAppl,
					 IMRD_SDMD_APPL_IDX_NAME, &appli, NULL)) != NDS_OK)||
		(node_ptr == NULL))
	{
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_INPUTAPPLI, appli.Name );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
	}
	else
	{
	    ctx->CurrentMapPath->Appl_Output_Ptr = node_ptr->Value;
	}
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_IDENTTOTAL) == 0)
  {
  	if(*(ctx->value) == IMRD_YES)
  	{
  		ctx->CurrentMapCmd->Ident_Total = IMRD_TRUE;
  	}
  	else
  	{
  		ctx->CurrentMapCmd->Ident_Total = IMRD_FALSE;
  	}
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_MSGMAP) == 0)
  {
	strcpy(msgmap.Name, ctx->value);
	if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootMsgMap,
					 IMRD_SDMD_MSGMAP_IDX_NAME, &msgmap, NULL)) != NDS_OK)||
		(node_ptr == NULL))
	{
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_MSGMAP, msgmap.Name );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
	}
	else
	{
	    ctx->CurrentMapCmd->MsgMap_Ptr = node_ptr->Value;
	}
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_CLEARFLAG) == 0)
  {
  	ctx->CurrentMapCmd->Clear_Flag = atoi(ctx->value);
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_GO_TO) == 0)
  {
  	ctx->CurrentMapCmd->TypeCmd = IMRD_MAPCMD_TYPE_GOTO;
  	if(ctx->PresentLevelTag == IMRD_SDMD_LEVEL_TAG_3)
  	{
	  		ctx->IdxJpTble++;
	  	
  	}
    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
    ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_IDENTIFIER) == 0)
  {
	ctx->CurrentMapCmd->TypeCmd = IMRD_MAPCMD_TYPE_IDENT;
    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
    ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
    ctx->IdxJpTble = 0;
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_MAPPER) == 0)
  {
	ctx->CurrentMapCmd->TypeCmd = IMRD_MAPCMD_TYPE_MAP;

    if (ctx->CurrentMapCmd->FmtAttr_Input_Ptr == NULL)
    {
	    strcpy(FmtAttr.Name, IMRD_FMTATTR_NAME_UNKNOWN);
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmtAttr,
						 IMRD_SDMD_FMTATTR_IDX_NAME, &FmtAttr, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, FmtAttr.Name );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentMapCmd->FmtAttr_Input_Ptr = node_ptr->Value;
		}
	}
    if (ctx->CurrentMapCmd->FmtAttr_Output_Ptr == NULL)
    {
	    strcpy(FmtAttr.Name, IMRD_FMTATTR_NAME_UNKNOWN);
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmtAttr,
						 IMRD_SDMD_FMTATTR_IDX_NAME, &FmtAttr, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, FmtAttr.Name );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentMapCmd->FmtAttr_Output_Ptr = node_ptr->Value;
		}
	}

    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
    ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_COPIE) == 0)
  {
	ctx->CurrentMapCmd->TypeCmd = IMRD_MAPCMD_TYPE_COPY;
    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
    ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_MAPCMD) == 0)
  {
	if(ctx->CurrentMapCmd->Ident_First_Msg_Ptr == NULL)
	{
		msg.Id = IMRD_MSG_ID_UNKNOWN;
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootMsg,
						 IMRD_SDMD_MSG_IDX_ID, &msg, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, "unknown" );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentMapCmd->Ident_First_Msg_Ptr = node_ptr->Value;
		}
	}

	if (ctx->CurrentMapCmd->TypeCmd == IMRD_MAPCMD_TYPE_MAP)
	{
		status = SDM_Control_Fmt_Attr(ctx->CurrentMapCmd->MsgMap_Ptr->Msg_Input_Ptr,
									  ctx->CurrentMapCmd->Fmt_Input_Ptr->FmtMsg_Struct_Ptr,
									  ctx->CurrentMapCmd->FmtAttr_Input_Ptr);

		if (status == IMRS_OK)
		{
			status = SDM_Control_Fmt_Attr(ctx->CurrentMapCmd->MsgMap_Ptr->Msg_Output_Ptr,
										  ctx->CurrentMapCmd->Fmt_Output_Ptr->FmtMsg_Struct_Ptr,
										  ctx->CurrentMapCmd->FmtAttr_Output_Ptr);

			if (status != IMRS_OK)
			{
			    snprintf(DescErr,sizeof(DescErr),SDMD_LIB_ERROR_11 );
			    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_CODE_ERROR_11 );
			}
		}
		else
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_LIB_ERROR_11 );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_CODE_ERROR_11 );
		}
	}

	ctx->CurrentMapCmd->MapCmd_Id = ctx->NbMapCmd;
	if( ( nd_status = ND_DataStruct_Value_Add( ctx->CurrentMapPath->MapCmd_Struct_Ptr, (void *)(ctx->CurrentMapCmd))) != NDS_OK)
	{
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_2,IMRD_SDMD_TAG_MAPCMD );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_2 );
	}
	ctx->NbMapCmd++;
    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
    ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_MAPPATH) == 0)
  {
	ctx->CurrentMapPath->idMapPath = ctx->NbMapPath;

	if( ( nd_status = ND_DataStruct_Value_Add( ctx->RootMapPath, (void *)(ctx->CurrentMapPath))) != NDS_OK)
	{
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_2,IMRD_SDMD_TAG_MAPPATH );
	    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), fonctionname , DescErr, SDMD_XML_CODE_ERROR_2 );
	}
	ctx->NbMapPath++;
    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
    ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
  }
  else if (strcmp((const char *)localname, IMRD_SDMD_TAG_VERSION) == 0)
  {
	IMRD_LM_LOG_INFO_1( "[MapPath]: [%s]", ctx->value);
	status_tmp = SDM_Set_Struct_Version((IMRT_Data_Version *)ctx->RootMapPath->User_Ptr, (char *)ctx->value);
  }

}


IMRT_Status endElementNsFmt ( SDMT_BufferInfo_Contexte * ctx, 
		       const xmlChar *localname,
		       const xmlChar *prefix,
		       const xmlChar *URI)
{
    NDT_Node    * node_ptr;
    NDT_Status    nd_status;
    IMRT_Status status, status_tmp;
    IMRT_Msg      message;
    IMRT_FmtAttr  FmtAttr;
    const char   functionname [] = "endElementNsFmt";
    char         DescErr [IMRD_SDMD_DESCERR_LEN]; 

   
	if (strcmp((const char *)localname, IMRD_SDMD_TAG_NAME) == 0)
	{
		switch(ctx->PresentLevelTag)
		{
		  case IMRD_SDMD_LEVEL_TAG_0:
		  {
		  	strcpy(ctx->CurrentFormat->Name, ctx->value);
			break;	
		  }
		  case IMRD_SDMD_LEVEL_TAG_1:
		  {
		    /*recherch du message avec le nom*/
		    strcpy(message.Name, ctx->value);
		    if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootMsg,
						     IMRD_SDMD_MSG_IDX_NAME, &message, NULL)) != NDS_OK)||
			   (node_ptr == NULL))
		    {
				snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5, IMRD_SDMD_TAG_FORMAT);
			    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
		    }
		    else
		    {
		    	ctx->CurrentFmtMsg->Msg_Ptr = node_ptr->Value;
		    }

			break;	
		  }
		
		  default:
		  {
		    snprintf(DescErr, sizeof(DescErr), SDMD_XML_LIB_ERROR_10, SDMD_FORMAT_FILE);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname , DescErr, SDMD_XML_CODE_ERROR_10);
		  }
		} /* end switch */
	}
	else if (strcmp((const char *)localname, IMRD_SDMD_TAG_BRANCHE_ID) == 0)
	{
		ctx->CurrentFmtMsg->Branche_Id = atoi(ctx->value);
	}
	else if (strcmp((const char *)localname, IMRD_SDMD_TAG_FMTATTR_NAME) == 0)
	{
	    strcpy(FmtAttr.Name, ctx->value);
		if(((nd_status = ND_Index_Node_Find( &node_ptr, IMRG_SDM_Base.RootFmtAttr,
						 IMRD_SDMD_FMTATTR_IDX_NAME, &FmtAttr, NULL)) != NDS_OK)||
			(node_ptr == NULL))
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_4,IMRD_SDMD_TAG_TYPE, FmtAttr.Name );
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname , DescErr, SDMD_XML_CODE_ERROR_4 );
		}
		else
		{
		    ctx->CurrentFmtMsg->FmtAttr_Ptr = node_ptr->Value;
		}
	}
	else if (strcmp((const char *)localname, IMRD_SDMD_TAG_FORMAT) == 0)
	{

		/*insertion du format*/
		ctx->CurrentFormat->Id =  ctx->CptFmt;
		if( ( nd_status = ND_DataStruct_Value_Add( ctx->RootFormat, (void  *)(ctx->CurrentFormat))) != NDS_OK)
		{
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_FORMAT);
		    SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
		}
		ctx->CptFmt ++;
	    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
		ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
	}
	else if (strcmp((const char *)localname, IMRD_SDMD_TAG_FMTMSG) == 0)
	{
		if( ( nd_status = ND_DataStruct_Value_Add( ctx->CurrentFormat->FmtMsg_Struct_Ptr, (void  *)(ctx->CurrentFmtMsg))) != NDS_OK)
		{
			snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5, IMRD_SDMD_TAG_FMTMSG);
			SDM_RaiseError(ctx->SaxCtxHdl,&(ctx->FataError),&(ctx->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
		}
	    memset(ctx->PathArray[ctx->PresentLevelTag],0,sizeof(IMRD_SDMD_SIZE_TAG_SIZE));
		ctx->PresentLevelTag = ctx->PresentLevelTag - 1;
	}
	else if (strcmp((const char *)localname, IMRD_SDMD_TAG_VERSION) == 0)
	{
		IMRD_LM_LOG_INFO_1( "[Fmt]: [%s]", ctx->value);
		status_tmp = SDM_Set_Struct_Version((IMRT_Data_Version *)ctx->RootFormat->User_Ptr, (char *)ctx->value);
	}
}



IMRT_Status Buff_Info_characters(SDMT_BufferInfo_Contexte * ctx , const xmlChar *ch, int len)
{
    char output[40];
    int i;
    
    memset(ctx->value,0, sizeof(ctx->value));
    
    for (i = 0;(i<len) && (i < IMRD_SDMD_VALUE_LEN);i++)
	ctx->value[i] = ch[i];
    ctx->value[i] = 0;
}



IMRT_Status SDM_XML_Load_Appli( char *demo_file, SDMT_BufferInfo_Contexte *mycontexte)
{
    IMRT_Status     status;
    NDT_Status      nd_status;
    char * docname = NULL;
    NDT_Index_Type  *index_type_ptr;
    xmlDocPtr doc = NULL;
    xmlDtdPtr dtd;
    xmlParserCtxtPtr ctxt =NULL;
    xmlSAXHandlerPtr SAXHandler;
    xmlSAXHandlerPtr SAXHandler_Sav;
    const char functionname []="SDM_XML_Load_Appli";
    char DescErr[IMRD_SDMD_DESCERR_LEN];
	IMRT_Data_Version   *Data_Version_Ptr;

    LIBXML_TEST_VERSION
	xmlKeepBlanksDefault(0);	
    xmlSAXDefaultVersion(2);
    xmlLineNumbersDefault(1);
	
    status = IMRS_OK;
    docname = demo_file;
    ctxt = xmlNewParserCtxt();
    /*initialisation des indexes*/
    index_type_ptr =  Appl_Struct_initial_idx_tab;
  

    if(ctxt != NULL)
    {
		mycontexte->flagerror  = IMRS_OK;
		SAXHandler            = &SaxAppliHandlerStruct;
		mycontexte->SaxCtxHdl = ctxt;
		ctxt->userData        = mycontexte;
		SAXHandler_Sav        = ctxt->sax;
		ctxt->sax             = SAXHandler;
		ctxt->sax2            = 1 ;
	    
		Data_Version_Ptr = (IMRT_Data_Version *) malloc(sizeof(IMRT_Data_Version));
		Data_Version_Ptr->Label[0] = '\0';
		Data_Version_Ptr->Date[0] = '\0';
		if( ( nd_status = ND_DataStruct_Open(&(mycontexte->RootAppli),IMRD_SDMD_APPL_STRUCT_IDX_NB,index_type_ptr, "SDM_Appl_Manager",SDM_Appl_Manager, NULL, NULL, NULL, NULL,0, Data_Version_Ptr)) != NDS_OK)
		{
		    status = IMRS_KO;
		    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_APPLI);
		    SDM_RaiseError(mycontexte->SaxCtxHdl,&(mycontexte->FataError),&(mycontexte->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
		}
		else
		{
		    doc = xmlCtxtReadFile(ctxt,docname,NULL,XML_PARSE_DTDATTR+XML_PARSE_DTDVALID);
		    if (ctxt->lastError.code != XML_ERR_OK)
		    {
		    	status = IMRS_KO;
		    	IMRD_LM_LOG_ERROR_3( "Erreur de parsing du fichier (%s): (%s) line (%d) !", docname, ctxt->lastError.message, ctxt->lastError.line);
		    }
			else if(mycontexte->flagerror != IMRS_OK)
			{
				status = IMRS_KO;
				IMRD_LM_LOG_ERROR_1( "%s !", mycontexte->FataError.libError);
			}
		    else
		    {
				index_type_ptr =Appl_Struct_final_idx_tab;
				status = SDM_DataStruct_Finalize(mycontexte->RootAppli,index_type_ptr, IMRD_SDMD_APPL_STRUCT_IDX_NB);
				/*SDM_DataStruct_Dump(mycontexte->RootAppli);*/
			}
		}

		if((status != IMRS_OK)&&(mycontexte->RootAppli != NULL))
		{
			free(mycontexte->RootAppli->User_Ptr);
			nd_status = ND_DataStruct_Close(mycontexte->RootAppli);
		}

	    ctxt->sax = SAXHandler_Sav ;
	    xmlFreeParserCtxt(ctxt);
    }
    else
    {
		status = IMRS_KO;
    }

	return(status);

}


IMRT_Status  SDM_XML_Load_FmtAttr( char *demo_file, SDMT_BufferInfo_Contexte *mycontexte)
{
    IMRT_Status     status;
    NDT_Status      nd_status;
    char * docname = NULL;
    NDT_Index_Type  *index_type_ptr;
    xmlDocPtr doc = NULL;
    xmlDtdPtr dtd;
    xmlParserCtxtPtr ctxt =NULL;
    xmlSAXHandlerPtr SAXHandler;
    xmlSAXHandlerPtr SAXHandler_Sav;
    const char functionname[]= "SDM_XML_Load_FmtAttr";
    char DescErr[IMRD_SDMD_DESCERR_LEN];
	IMRT_Data_Version   *Data_Version_Ptr;

    LIBXML_TEST_VERSION
	xmlKeepBlanksDefault(0);	
    xmlSAXDefaultVersion(2);
    xmlLineNumbersDefault(1);
	
    status = IMRS_OK;
    docname = demo_file;
    ctxt = xmlNewParserCtxt();
    /*initialisation des indexes*/
    index_type_ptr =  FmtAttr_Struct_initial_idx_tab;
  
    if(ctxt != NULL)
    {
	mycontexte->flagerror  = IMRS_OK;
	SAXHandler            = &SaxFmtAttrHandlerStruct;
	mycontexte->SaxCtxHdl = ctxt;
	ctxt->userData        = mycontexte;
	SAXHandler_Sav        = ctxt->sax;
	ctxt->sax             = SAXHandler;
	ctxt->sax2            = 1 ;

	Data_Version_Ptr = (IMRT_Data_Version *) malloc(sizeof(IMRT_Data_Version));
	Data_Version_Ptr->Label[0] = '\0';
	Data_Version_Ptr->Date[0] = '\0';
	if( ( nd_status = ND_DataStruct_Open(&(mycontexte->RootFmtAttr),IMRD_SDMD_FMTATTR_STRUCT_IDX_NB,index_type_ptr, "SDM_FmtAttr_Manager",SDM_FmtAttr_Manager, NULL, NULL, NULL, NULL,0, Data_Version_Ptr)) != NDS_OK)
	{
	    status = IMRS_KO;
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_FMTATTR);
	    SDM_RaiseError(mycontexte->SaxCtxHdl,&(mycontexte->FataError),&(mycontexte->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
	}
	else
	{
	    doc = xmlCtxtReadFile(ctxt,docname,NULL,XML_PARSE_DTDATTR+XML_PARSE_DTDVALID);
	    if (ctxt->lastError.code != XML_ERR_OK)
	    {
	    	status = IMRS_KO;
	    	IMRD_LM_LOG_ERROR_3( "Erreur de parsing du fichier (%s): (%s) line (%d) !", docname, ctxt->lastError.message, ctxt->lastError.line);
	    }
		else if(mycontexte->flagerror != IMRS_OK)
		{
			status = IMRS_KO;
			IMRD_LM_LOG_ERROR_1( "%s !", mycontexte->FataError.libError);
		}
	    else
	    {
			index_type_ptr = FmtAttr_Struct_final_idx_tab;
			status = SDM_DataStruct_Finalize(mycontexte->RootFmtAttr, index_type_ptr, IMRD_SDMD_FMTATTR_STRUCT_IDX_NB);
			/*SDM_DataStruct_Dump( mycontexte->RootFmtAttr);*/
		}
	}

	if((status != IMRS_OK)&&(mycontexte->RootFmtAttr != NULL))
	{
		free(mycontexte->RootFmtAttr->User_Ptr);
		nd_status = ND_DataStruct_Close(mycontexte->RootFmtAttr);
	}

	ctxt->sax = SAXHandler_Sav ;
    xmlFreeParserCtxt(ctxt);
    }
    else
    {
		status = IMRS_KO;
    }

	return(status);

}



IMRT_Status  SDM_XML_Load_Format( char *demo_file, SDMT_BufferInfo_Contexte *mycontexte)
{
    IMRT_Status     status;
    NDT_Status      nd_status;
    char * docname = NULL;
    NDT_Index_Type  *index_type_ptr;
    xmlDocPtr doc = NULL;
    xmlDtdPtr dtd;
    xmlParserCtxtPtr ctxt =NULL;
    xmlSAXHandlerPtr SAXHandler_Sav;
    xmlSAXHandlerPtr SAXHandler;
    const char functionname[]= "SDM_XML_Load_Format";
    char DescErr[IMRD_SDMD_DESCERR_LEN];
	IMRT_Data_Version   *Data_Version_Ptr;

    LIBXML_TEST_VERSION
	xmlKeepBlanksDefault(0);	
    xmlSAXDefaultVersion(2);
    xmlLineNumbersDefault(1);
	
    status = IMRS_OK;
    docname = demo_file;
    ctxt = xmlNewParserCtxt();
    /*initialisation des indexes*/
    index_type_ptr =  Fmt_Struct_initial_idx_tab;
  
    if(ctxt != NULL)
    {
	mycontexte->flagerror  = IMRS_OK;
	SAXHandler            = &SaxFmtHandlerStruct;
	mycontexte->SaxCtxHdl = ctxt;
	ctxt->userData        = mycontexte;
	SAXHandler_Sav        = ctxt->sax;
	ctxt->sax             = SAXHandler;
	ctxt->sax2            = 1 ;
    
	Data_Version_Ptr = (IMRT_Data_Version *) malloc(sizeof(IMRT_Data_Version));
	Data_Version_Ptr->Label[0] = '\0';
	Data_Version_Ptr->Date[0] = '\0';
	if( ( nd_status = ND_DataStruct_Open(&(mycontexte->RootFormat),IMRD_SDMD_FMT_STRUCT_IDX_NB,index_type_ptr, "SDM_Fmt_Manager",SDM_Fmt_Manager, NULL, NULL, NULL, NULL,0, Data_Version_Ptr)) != NDS_OK)
	{
	    status = IMRS_KO;
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_FORMAT);
	    SDM_RaiseError(mycontexte->SaxCtxHdl,&(mycontexte->FataError),&(mycontexte->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
	}
	else
	{
	    doc = xmlCtxtReadFile(ctxt,docname,NULL,XML_PARSE_DTDATTR+XML_PARSE_DTDVALID);
	    if (ctxt->lastError.code != XML_ERR_OK)
	    {
	    	status = IMRS_KO;
	    	IMRD_LM_LOG_ERROR_3( "Erreur de parsing du fichier (%s): (%s) line (%d) !", docname, ctxt->lastError.message, ctxt->lastError.line);
	    }
		else if(mycontexte->flagerror != IMRS_OK)
		{
			status = IMRS_KO;
			IMRD_LM_LOG_ERROR_1( "%s !", mycontexte->FataError.libError);
		}
	    else
	    {
			index_type_ptr = Fmt_Struct_final_idx_tab;
			status = SDM_DataStruct_Finalize(mycontexte->RootFormat, index_type_ptr, IMRD_SDMD_FMT_STRUCT_IDX_NB);
			/*SDM_DataStruct_Dump( mycontexte->RootFormat);*/
		}
	}

	if((status != IMRS_OK)&&(mycontexte->RootFormat != NULL))
	{
		free(mycontexte->RootFormat->User_Ptr);
		nd_status = ND_DataStruct_Close(mycontexte->RootFormat);
	}

	ctxt->sax = SAXHandler_Sav ;
    xmlFreeParserCtxt(ctxt);
    }
    else
    {
		status = IMRS_KO;
    }

	return(status);

}



IMRT_Status SDM_XML_Load_MapPath( char *demo_file, SDMT_BufferInfo_Contexte *mycontexte)
{
    IMRT_Status    status;
    NDT_Status     nd_status;
    char * docname = NULL;
    NDT_Index_Type  *index_type_ptr;
    xmlDocPtr doc = NULL;
    xmlDtdPtr dtd;
    xmlParserCtxtPtr ctxt =NULL;
    xmlSAXHandlerPtr SAXHandler;
    xmlSAXHandlerPtr SAXHandler_Sav;
    const char functionname []="SDM_XML_Load_MapPath";
    char DescErr[IMRD_SDMD_DESCERR_LEN];
	IMRT_Data_Version   *Data_Version_Ptr;


    LIBXML_TEST_VERSION
	xmlKeepBlanksDefault(0);	
    xmlSAXDefaultVersion(2);
    xmlLineNumbersDefault(1);
	
    status = IMRS_OK;
    docname = demo_file;
    ctxt = xmlNewParserCtxt();
    /*initialisation des indexes*/
    index_type_ptr = index_type_initial_tab;
  
    if(ctxt != NULL)
    {
	mycontexte->flagerror  = IMRS_OK;
	SAXHandler            = &SaxMapPathHandlerStruct;
	mycontexte->SaxCtxHdl = ctxt;
	ctxt->userData        = mycontexte;
	SAXHandler_Sav        = ctxt->sax ;
	ctxt->sax             = SAXHandler;
	ctxt->sax2            = 1 ;

	Data_Version_Ptr = (IMRT_Data_Version *) malloc(sizeof(IMRT_Data_Version));
	Data_Version_Ptr->Label[0] = '\0';
	Data_Version_Ptr->Date[0] = '\0';
	if( ( nd_status = ND_DataStruct_Open(&(mycontexte->RootMapPath), IMRD_SDMD_INDEX_NB, index_type_ptr, "SDM_MapPath_Manager",SDM_MapPath_Manager, NULL, NULL, NULL, NULL,0, Data_Version_Ptr)) != NDS_OK)
	{
	    status = IMRS_KO;
	    snprintf(DescErr,sizeof(DescErr),SDMD_XML_LIB_ERROR_5,IMRD_SDMD_TAG_MAPPATH);
	    SDM_RaiseError(mycontexte->SaxCtxHdl,&(mycontexte->FataError),&(mycontexte->flagerror), functionname, DescErr, SDMD_XML_CODE_ERROR_5 );
	}
	else
	{
	    doc = xmlCtxtReadFile(ctxt,docname,NULL,XML_PARSE_DTDATTR+XML_PARSE_DTDVALID);
	    if (ctxt->lastError.code != XML_ERR_OK)
	    {
	    	status = IMRS_KO;
	    	IMRD_LM_LOG_ERROR_3( "Erreur de parsing du fichier (%s): (%s) line (%d) !", docname, ctxt->lastError.message, ctxt->lastError.line);
	    }
		else if(mycontexte->flagerror != IMRS_OK)
		{
			status = IMRS_KO;
			IMRD_LM_LOG_ERROR_1( "%s !", mycontexte->FataError.libError);
		}
	    else
	    {
			/*SDM_DataStruct_Dump(mycontexte->RootMapPath);*/
		}
	}

	if(status != IMRS_OK)
	{
	    if(mycontexte->CurrentMapPath != NULL)
            {
		if(mycontexte->CurrentMapPath->MapCmd_Struct_Ptr != NULL)
		{
		  nd_status = ND_DataStruct_Close(mycontexte->CurrentMapPath->MapCmd_Struct_Ptr);
                  if(nd_status == NDS_OK)
		  {
		      free(mycontexte->CurrentMapPath);
                  }  
                }
            }
            if(mycontexte->CurrentMapCmd != NULL)
            {
		     free(mycontexte->CurrentMapCmd);
            }

            if(mycontexte->CurrentFormat != NULL)
            {
		if(mycontexte->CurrentFormat->FmtMsg_Struct_Ptr != NULL)
		{
		    nd_status = ND_DataStruct_Close(mycontexte->CurrentFormat->FmtMsg_Struct_Ptr);
		    if(nd_status == NDS_OK)
		    {
			free(mycontexte->CurrentFormat);
		    }  
                }		 
 
            }
            
            if(mycontexte->CurrentFmtMsg != NULL)
            {
		free(mycontexte->CurrentFmtMsg);
            }
            if (mycontexte->CurrentAppli  != NULL)
            {
                free(mycontexte->CurrentAppli);
            }

	    if(mycontexte->RootMapPath != NULL)
	    {
	    free(mycontexte->RootMapPath->User_Ptr);
		nd_status = ND_DataStruct_Close(mycontexte->RootMapPath);
	    }

	    if(mycontexte->RootFormat != NULL)
	    {
	    free(mycontexte->RootFormat->User_Ptr);
		nd_status = ND_DataStruct_Close(mycontexte->RootFormat);
	    }

		if(mycontexte->RootFmtAttr != NULL)
		{
			free(mycontexte->RootFmtAttr->User_Ptr);
			nd_status = ND_DataStruct_Close(mycontexte->RootFmtAttr);
		}

	    if(mycontexte->RootAppli != NULL)
	    {
	    free(mycontexte->RootAppli->User_Ptr);
		nd_status = ND_DataStruct_Close(mycontexte->RootAppli);
	    }
	}

	ctxt->sax = SAXHandler_Sav ;
    xmlFreeParserCtxt(ctxt);
  } /* end if(ctxt != NULL) */
  else
  {
  	status = IMRS_KO;
  }

  return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_FmtAttr_Header(FILE *dump_file)
{
	fprintf(dump_file, "<?xml version=\"1.0\" ?>\n");
	fprintf(dump_file, "<!-- FmtAttr Struct definitions -->\n");
	fprintf(dump_file, "<%s>\n", IMRD_SDMD_FMTATTR_STRUCT);
	fprintf(dump_file, "<version>@(#) VERSIONIMR: $Label:  $   $Date: 2008/11/12 02:25:23 $   $Workfile:   buffer_info_xml.c  $</version>\n", 
				((IMRT_Data_Version *)IMRG_SDM_Base.RootFmtAttr->User_Ptr)->Label,
				((IMRT_Data_Version *)IMRG_SDM_Base.RootFmtAttr->User_Ptr)->Date);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_FmtAttr_Body(FILE *dump_file)
{
	IMRT_Status  status;
	NDT_Status  nd_status;

	if( ( nd_status = ND_DataStruct_Traverse( IMRG_SDM_Base.RootFmtAttr, IMRD_SDMD_CMD_API_XML_DUMP, dump_file)) != NDS_OK)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "XML Dump RootFmtAttr failed (%d) !", nd_status);
	}
	else
	{
		status = IMRS_OK;
	}

	return(status);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_FmtAttr_Footer(FILE *dump_file)
{
	fprintf(dump_file, "<!-- FmtAttr Struct definitions footer -->\n");
	fprintf(dump_file, "</%s>\n", IMRD_SDMD_FMTATTR_STRUCT);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_FmtAttr(void)
{
	IMRT_Status     status;
	char	    dump_filename[255];
	FILE	   *dump_file;

	strcpy(dump_filename, SDMD_FMTATTR_FILE);

	if( ( dump_file = fopen( dump_filename, "w")) == NULL)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "Can't open dump file (%s) !", dump_filename);
	}
	else
	{
		status = SDM_XML_Dump_FmtAttr_Header(dump_file);
		if(status == IMRS_OK)
		{
			status = SDM_XML_Dump_FmtAttr_Body(dump_file);
			if(status == IMRS_OK)
			{
				status = SDM_XML_Dump_FmtAttr_Footer(dump_file);
			}
		}

		fclose( dump_file);
	}

	return(status);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Appli_Header(FILE *dump_file)
{
	fprintf(dump_file, "<?xml version=\"1.0\" ?>\n");
	fprintf(dump_file, "<!-- Appl Struct definitions -->\n");
	fprintf(dump_file, "<%s>\n", IMRD_SDMD_APPLI_STRUCT);
	fprintf(dump_file, "<version>@(#) VERSIONIMR: $Label:  $   $Date: 2008/11/12 02:25:23 $   $Workfile:   buffer_info_xml.c  $</version>\n", 
				((IMRT_Data_Version *)IMRG_SDM_Base.RootAppl->User_Ptr)->Label,
				((IMRT_Data_Version *)IMRG_SDM_Base.RootAppl->User_Ptr)->Date);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Appli_Body(FILE *dump_file)
{
	IMRT_Status  status;
	NDT_Status  nd_status;

	if( ( nd_status = ND_DataStruct_Traverse( IMRG_SDM_Base.RootAppl, IMRD_SDMD_CMD_API_XML_DUMP, dump_file)) != NDS_OK)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "XML Dump RootAppl failed (%d) !", nd_status);
	}
	else
	{
		status = IMRS_OK;
	}

	return(status);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Appli_Footer(FILE *dump_file)
{
	fprintf(dump_file, "<!-- Appl Struct definitions footer -->\n");
	fprintf(dump_file, "</%s>\n", IMRD_SDMD_APPLI_STRUCT);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Appli(void)
{
	IMRT_Status     status;
	char	    dump_filename[255];
	FILE	   *dump_file;

	strcpy(dump_filename, SDMD_APPLI_FILE);

	if( ( dump_file = fopen( dump_filename, "w")) == NULL)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "Can't open dump file (%s) !", dump_filename);
	}
	else
	{
		status = SDM_XML_Dump_Appli_Header(dump_file);
		if(status == IMRS_OK)
		{
			status = SDM_XML_Dump_Appli_Body(dump_file);
			if(status == IMRS_OK)
			{
				status = SDM_XML_Dump_Appli_Footer(dump_file);
			}
		}

		fclose( dump_file);
	}

	return(status);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Format_Header(FILE *dump_file)
{
	fprintf(dump_file, "<?xml version=\"1.0\" ?>\n");
	fprintf(dump_file, "<!-- Fmt Struct definitions -->\n");
	fprintf(dump_file, "<%s>\n", IMRD_SDMD_FMT_STRUCT);
	fprintf(dump_file, "<version>@(#) VERSIONIMR: $Label:  $   $Date: 2008/11/12 02:25:23 $   $Workfile:   buffer_info_xml.c  $</version>\n",
				((IMRT_Data_Version *)IMRG_SDM_Base.RootFmt->User_Ptr)->Label,
				((IMRT_Data_Version *)IMRG_SDM_Base.RootFmt->User_Ptr)->Date);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Format_Body(FILE *dump_file)
{
	IMRT_Status  status;
	NDT_Status  nd_status;

	if( ( nd_status = ND_DataStruct_Traverse( IMRG_SDM_Base.RootFmt, IMRD_SDMD_CMD_API_XML_DUMP, dump_file)) != NDS_OK)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "XML Dump RootFmt failed (%d) !", nd_status);
	}
	else
	{
		status = IMRS_OK;		
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Format_Footer(FILE *dump_file)
{
	fprintf(dump_file, "<!-- Fmt Struct definitions footer -->\n");
	fprintf(dump_file, "</%s>\n", IMRD_SDMD_FMT_STRUCT);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_Format(void)
{
	IMRT_Status     status;
	char	    dump_filename[255];
	FILE	   *dump_file;

	strcpy(dump_filename, SDMD_FORMAT_FILE);

	if( ( dump_file = fopen( dump_filename, "w")) == NULL)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "Can't open dump file (%s) !", dump_filename);
	}
	else
	{
		status = SDM_XML_Dump_Format_Header(dump_file);
		if(status == IMRS_OK)
		{
			status = SDM_XML_Dump_Format_Body(dump_file);
			if(status == IMRS_OK)
			{
				status = SDM_XML_Dump_Format_Footer(dump_file);
			}
		}

		fclose( dump_file);
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_MapPath_Header(FILE *dump_file)
{
	fprintf(dump_file, "<?xml version=\"1.0\" ?>\n");
	fprintf(dump_file, "<!-- MapPath Struct definitions -->\n");
	fprintf(dump_file, "<%s>\n", IMRD_SDMD_MAPPATH_STRUCT);
	fprintf(dump_file, "<version>@(#) VERSIONIMR: $Label:  $   $Date: 2008/11/12 02:25:23 $   $Workfile:   buffer_info_xml.c  $</version>\n", 
				((IMRT_Data_Version *)IMRG_SDM_Base.RootMapPath->User_Ptr)->Label,
				((IMRT_Data_Version *)IMRG_SDM_Base.RootMapPath->User_Ptr)->Date);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_MapPath_Body(FILE *dump_file)
{
	IMRT_Status  status;
	NDT_Status  nd_status;

	if( ( nd_status = ND_DataStruct_Traverse( IMRG_SDM_Base.RootMapPath, IMRD_SDMD_CMD_API_XML_DUMP, dump_file)) != NDS_OK)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "XML Dump RootMapPath failed (%d) !", nd_status);
	}
	else
	{
		status = IMRS_OK;		
	}

	return(status);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_MapPath_Footer(FILE *dump_file)
{
	fprintf(dump_file, "<!-- MapPath Struct definitions footer -->\n");
	fprintf(dump_file, "</%s>\n", IMRD_SDMD_MAPPATH_STRUCT);
	return( IMRS_OK);

}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_Dump_MapPath(void)
{
	IMRT_Status  status;
	char	    dump_filename[255];
	FILE	   *dump_file;

	strcpy(dump_filename, SDMD_MAPPATH_FILE);

	if( ( dump_file = fopen( dump_filename, "w")) == NULL)
	{
		status = IMRS_KO;
		IMRD_LM_LOG_ERROR_1( "Can't open dump file (%s) !", dump_filename);
	}
	else
	{
		status = SDM_XML_Dump_MapPath_Header(dump_file);
		if(status == IMRS_OK)
		{
			status = SDM_XML_Dump_MapPath_Body(dump_file);
			if(status == IMRS_OK)
			{
				status = SDM_XML_Dump_MapPath_Footer(dump_file);
			}
		}

		fclose( dump_file);
	}

	return(status);
}
/******************************************************************************/
/******************************************************************************/
/******************************************************************************/
IMRT_Status  SDM_XML_BufferInfo_Dump(void)
{
	IMRT_Status  status;

	status = SDM_XML_Dump_Appli();
	if(status == IMRS_OK)
	{
		status = SDM_XML_Dump_Format();
		if(status == IMRS_OK)
		{
			status = SDM_XML_Dump_MapPath();
			if(status == IMRS_OK)
			{
				status = SDM_XML_Dump_FmtAttr();
			}
		}
	}

	return(status);

}

/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/
IMRT_Status  SDM_ConvertAttribute(char * Attribute_ptr, char * Attribute_convert_ptr)
{
	
    char * read_ptr ;
    char * write_ptr; 
    IMRT_Status status;
    char *unescaped;
    char   sHexa[4];

    status = IMRS_OK;

    for( read_ptr = Attribute_ptr, write_ptr =Attribute_convert_ptr ; *read_ptr != '\0'; read_ptr++, write_ptr++)
	{

		if (*read_ptr == '%')
		{
			memset(sHexa, '\0', sizeof(sHexa));
			strncpy(sHexa, read_ptr, 3); 
			write_ptr = (char *)xmlURIUnescapeString(sHexa, strlen(sHexa), write_ptr);
			read_ptr ++;
			read_ptr ++;
		}
		else
		{
			if( ( *read_ptr == '\\') && ( *(read_ptr+1) != '\0') )
			{
				switch( *( read_ptr + 1))
				{
					case 'n':
					{
						*write_ptr = '\n';
						break;
					}
	
					case 't':
					{
						*write_ptr = '\t';
						break;
					}
	
					case '\\':
					{
						*write_ptr = '\\';
						break;
					}
	
					case 'r':
					{
						*write_ptr = '\r';
						break;
					}
	
					case 'T':
					{
						*write_ptr = 'T';
						break;
					}
	
					case 'S':
					{
						*write_ptr = 'S';
						break;
					}
	
					default:
					{
						*write_ptr = '?';
						break;
					}
				}
	
				read_ptr++;
			}
			else
			{
				if (( *read_ptr == '\n') || (*read_ptr == '\t'))
				{
	//				*write_ptr = '';
				}
				else
				{
					*write_ptr = *read_ptr;
				}
			}
		}
	}

	*write_ptr = '\0';

	return(status);
}


IMRT_Status  SDM_ConvertAttributeInv(char * Attrinute_Ptr, char * Attribute_convert_ptr)
{
    const xmlChar * string_to_escape = (xmlChar *)Attrinute_Ptr;
    const xmlChar * list = (xmlChar *)"TS";
    xmlChar * Ret=NULL;

    memset(Attribute_convert_ptr, '\0', IMRD_FMTATTR_VALUE_SIZE);
    Ret = xmlURIEscapeStr(string_to_escape, list);
    if (Ret != NULL)
    {
    	strcpy(Attribute_convert_ptr, (char *)Ret);
    }
    xmlFree(Ret);

    return(IMRS_OK);
}


IMRT_Status  SDM_Control_Fmt_Attr(IMRT_Msg * Msg_Ptr, NDT_Root * FmtMsg_Struct_Ptr, IMRT_FmtAttr  * FmtAttr_Ptr)
{
    IMRT_Status status;
	NDT_Status  nd_status;

	status = IMRS_OK;

	if (strcmp(FmtAttr_Ptr->Name , IMRD_FMTATTR_NAME_UNKNOWN) != 0)
	{
		nd_status = ND_DataStruct_Traverse(FmtMsg_Struct_Ptr, IMRD_SDMD_CMD_CHECK_FMT_ATTR, Msg_Ptr, FmtAttr_Ptr);
		if (nd_status == NDS_NODE_FOUND)
		{
			status = IMRS_OK;
		}
		else
		{
			status = IMRS_KO;
		}
	}

	return(status);
}
