/*----------------------------------------------------------------------------*/
/* File: mapping_info_mng.h 				         	      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _MAPPING_INFO_MNG_H_
#   define _MAPPING_INFO_MNG_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#   include <libstatic_data_mng.h>


/*----------------------------------------------------------------------------*/
/* XML TAG                                                                    */
/*----------------------------------------------------------------------------*/
#define IMRD_SDMD_TAG_MSGMAP_STRUCT "msgmap_struct" 

/* Nom des fichiers pour le chargement XML */
#define SDMD_MSGMAP_FILE            "sd_msgmap_struct.xml"


/********************************************************************/
/*       Les index du Manager SDM_MsgMap_Manager                    */
/********************************************************************/
#define IMRD_SDMD_MSGMAP_STRUCT_IDX_NB                (short)2

static NDT_Index_Type  MsgMap_Struct_initial_idx_tab[IMRD_SDMD_MSGMAP_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_LIST | NDD_INDEX_SUBTYPE_SORTED),
      (NDD_INDEX_STATUS_CLOSED)
};

static NDT_Index_Type  MsgMap_Struct_final_idx_tab[IMRD_SDMD_MSGMAP_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED),
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED)
};



/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _MAPPING_INFO_MNG_C_

NDT_Status  SDM_FieldMap_Manager( NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_MsgMap_Manager(   NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
IMRT_Status SDM_MapInfoInfo_Init(IMRT_Lib_Flag  Lib_Flag);
IMRT_Status SDM_Close_RootMsgMap(void);
IMRT_Status SDM_MapInfo_Init(IMRT_SDM_Config  * Lib_Config_Ptr);
IMRT_Status SDM_MapInfo_DInit(void);
IMRT_Status  SDM_MsgMap_Proceed( IMRT_MsgMap  *MsgMap_Ptr, IMRT_SDMCB_Field_Map  *CCB_Field_Map_Ptr);
void SDM_InitMsgMap(IMRT_MsgMap * mymsgmap);
void SDM_InitFieldMap(IMRT_FieldMap * myfieldmap);

#   else

extern NDT_Status  SDM_FieldMap_Manager( NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_MsgMap_Manager(   NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern IMRT_Status SDM_MapInfo_Init(IMRT_SDM_Config  * Lib_Config_Ptr);
extern IMRT_Status SDM_Close_RootMsgMap(void);
extern IMRT_Status SDM_MapInfo_DInit(void);
extern IMRT_Status  SDM_MsgMap_Proceed( IMRT_MsgMap  *MsgMap_Ptr, IMRT_SDMCB_Field_Map  *CCB_Field_Map_Ptr);

#   endif





/*----------------------------------------------------------------------------*/
/* Local Includes                                                             */
/*----------------------------------------------------------------------------*/

#   ifdef _MAPPING_INFO_MNG_C_

#       include "mapping_info_xml.h"
#       include "mapping_info_sql.h"

#   endif





/*----------------------------------------------------------------------------*/

#endif
