/*----------------------------------------------------------------------------*/
/* File: mapping_info_sql.h 				         	      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _MAPPING_INFO_SQL_H_
#   define _MAPPING_INFO_SQL_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#   include <libstatic_data_mng.h>





/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _MAPPING_INFO_SQL_PC_

IMRT_Status SDM_SQL_MapInfo_Init(void);
IMRT_Status SDM_SQL_Load_MsgMap(NDT_Root  **myRootMsgMap_Ptr_Ptr);
IMRT_Status SDM_SQL_LoadFieldMap(IMRT_MsgMap *myMsgMap);
IMRT_Status SDM_SQL_Dump_MsgMap_Header(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_MsgMap_Body(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_MsgMap_Footer(FILE *dump_file);
IMRT_Status SDM_SQL_Dump_MsgMap(void);
IMRT_Status SDM_SQL_MapInfo_Dump(void);

#   else

extern IMRT_Status SDM_SQL_MapInfo_Init(void);
extern IMRT_Status SDM_SQL_Load_MsgMap(NDT_Root  **myRootMsgMap_Ptr_Ptr);
extern IMRT_Status SDM_SQL_LoadFieldMap(IMRT_MsgMap *myMsgMap);
extern IMRT_Status SDM_SQL_Dump_MsgMap_Header(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_MsgMap_Body(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_MsgMap_Footer(FILE *dump_file);
extern IMRT_Status SDM_SQL_Dump_MsgMap(void);
extern IMRT_Status SDM_SQL_MapInfo_Dump(void);

#   endif





/*----------------------------------------------------------------------------*/

#endif
