/*----------------------------------------------------------------------------*/
/* File: struct_info_mng.h 				      		      */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/*----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/
/* IMR - Interlinking Message Router                                          */
/* Copyright (C) 2005 Arnaud G. Gibert & Others (See ReadMe.txt)              */
/* mailto:arnaud@rx3.net                                                      */
/* http://www.rx3.org/dvp/?dvp=imr                                            */
/*----------------------------------------------------------------------------*/
/* This file is part of IMR                                                   */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software Foundation,    */
/* Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.        */
/*----------------------------------------------------------------------------*/

#ifndef _STRUCT_INFO_MNG_H_
#   define _STRUCT_INFO_MNG_H_



/*----------------------------------------------------------------------------*/
/* Global Include                                                             */
/*----------------------------------------------------------------------------*/

#   include <libstatic_data_mng.h>


/*----------------------------------------------------------------------------*/
/* XML TAG                                                                    */
/*----------------------------------------------------------------------------*/
#define IMRD_SDMD_TAG_CNV_STRUCT    "cnv_struct"
#define IMRD_SDMD_TAG_MSG_STRUCT    "msg_struct"


/* Nom des fichiers pour le chargement XML */
#define SDMD_MSGFIELD_FILE          "sd_msg_struct.xml"
#define SDMD_CNV_FILE               "sd_cnv_struct.xml"


/********************************************************************/
/*       Les index du Manager SDM_Msg_Manager                       */
/********************************************************************/
#define IMRD_SDMD_MSG_STRUCT_IDX_NB                (short)2

static NDT_Index_Type  Msg_Struct_initial_idx_tab[IMRD_SDMD_MSG_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_LIST | NDD_INDEX_SUBTYPE_SORTED),
      (NDD_INDEX_STATUS_CLOSED)
};

static NDT_Index_Type  Msg_Struct_final_idx_tab[IMRD_SDMD_MSG_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED),
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED)
};

#define IMRD_SDMD_MSG_IDX_ID                (short)0
#define IMRD_SDMD_MSG_IDX_NAME              (short)1


/********************************************************************/
/*       Les index du Manager SDM_Field_Manager                     */
/********************************************************************/
#define IMRD_SDMD_FIELD_STRUCT_IDX_NB                (short)2

static NDT_Index_Type  Field_Struct_initial_idx_tab[IMRD_SDMD_FIELD_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_LIST | NDD_INDEX_SUBTYPE_SORTED),
      (NDD_INDEX_STATUS_CLOSED)
};

static NDT_Index_Type  Field_Struct_final_idx_tab[IMRD_SDMD_FIELD_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED),
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED)
};

#define IMRD_SDMD_FIELD_IDX_ID                (short)0
#define IMRD_SDMD_FIELD_IDX_NAME              (short)1


/********************************************************************/
/*       Les index du Manager SDM_Cnv_Manager                      */
/********************************************************************/
#define IMRD_SDMD_CNV_STRUCT_IDX_NB                (short)2

static NDT_Index_Type  Cnv_Struct_initial_idx_tab[IMRD_SDMD_CNV_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_LIST | NDD_INDEX_SUBTYPE_SORTED),
      (NDD_INDEX_STATUS_CLOSED)
};

static NDT_Index_Type  Cnv_Struct_final_idx_tab[IMRD_SDMD_CNV_STRUCT_IDX_NB] = 
{
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED),
      (NDD_INDEX_STATUS_OPENED | NDD_INDEX_TYPE_TREE | NDD_INDEX_SUBTYPE_BALANCED)
};

#define IMRD_SDMD_CNV_IDX_ID                (short)0
#define IMRD_SDMD_CNV_IDX_NAME              (short)1



/*----------------------------------------------------------------------------*/
/* Prototypes                                                                 */
/*----------------------------------------------------------------------------*/

#   ifdef _STRUCT_INFO_MNG_C_

NDT_Status  SDM_Cnv_Manager(    NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_Field_Manager( NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
NDT_Status  SDM_Msg_Manager(   NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
IMRT_Status SDM_StructInfo_Init(IMRT_SDM_Config * Lib_Config_Ptr);
IMRT_Status SDM_Close_RootCnv(void);
IMRT_Status SDM_Close_RootMsg(void);
IMRT_Status SDM_StructInfo_DInit(void);
IMRT_Status  SDM_Cnv_Proceed( IMRT_SDMCB_Cnv_Add  *CCB_Cnv_Add_Ptr);
void SDM_InitMessage(IMRT_Msg * mymessage);
void SDM_InitField(IMRT_Field * myfield);
void SDM_InitCnv(IMRT_Cnv * Cnv_Ptr);

#   else

extern NDT_Status  SDM_Cnv_Manager(    NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_Field_Manager( NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern NDT_Status  SDM_Msg_Manager(   NDT_Root  *, NDT_Index_Id, NDT_Node  *, NDT_Command, va_list);
extern IMRT_Status SDM_StructInfo_Init(IMRT_SDM_Config * Lib_Config_Ptr);
extern IMRT_Status SDM_Close_RootCnv(void);
extern IMRT_Status SDM_Close_RootMsg(void);
extern IMRT_Status SDM_StructInfo_DInit(void);
extern IMRT_Status  SDM_Cnv_Proceed( IMRT_SDMCB_Cnv_Add  *CCB_Cnv_Add_Ptr);

#   endif





/*----------------------------------------------------------------------------*/
/* Local Includes                                                             */
/*----------------------------------------------------------------------------*/

#   ifdef _STRUCT_INFO_MNG_C_

#       include "struct_info_xml.h"
#       include "struct_info_sql.h"

#   endif





/*----------------------------------------------------------------------------*/

#endif
